//Package:       RMIM - Functional Independence Measurement (FIM)
//Date Created : Nov 1,2002
//Site Name:     West Palm Beach VA Medical Center
//Developers:    John (Larry) McIntosh, Jerry Pickup, Cyndi McCracken
//Description:   Creates progress notes/consult responses and sends FIM
//               data to the FSOD database at AAC
unit Auth;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls, Inifiles,
  Forms, Dialogs, ExtCtrls, StdCtrls, Buttons, Trpcb,
  Menus, Spin, Clipbrd, Mfunstr;


type
  TfrmAuthor = class(TForm)
    InvisiblefmListBoxPatients: TListBox;
    PatientWildCardEdit: TEdit;
    Label1: TLabel;
    RPCMemo: TMemo;
    GroupBox1: TGroupBox;
    pnlTitle: TPanel;
    lblPatients: TLabel;
    fmListBoxPatients: TListBox;
    txtHelp2: TMemo;
    GroupBox2: TGroupBox;
    AuthorsCB: TCheckBox;
    Label2: TLabel;
    btnCancel: TBitBtn;
    btnOK: TBitBtn;
    procedure btnOKClick(Sender: TObject);
    procedure PatientWildCardEditKeyPress(Sender: TObject; var Key: Char);
    procedure btnCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure AuthorsBrokerCall;
    procedure fmListBoxPatientsKeyPress(Sender: TObject; var Key: Char);

  Private
    { Private declarations }
  Public
    { Public declarations }
    Status: string;
  end;

var
  frmAuthor: TfrmAuthor;
  PNErrortrap: string;
  AuthorCall: string;
  CallValue: string;
implementation
uses Main, uFIM_Objects;
{$R *.DFM}

procedure TfrmAuthor.btnOKClick(Sender: TObject);
begin
  MainForm.AuthorHold := '';
  MainForm.Author_NumHold := '';
  if fmListBoxPatients.ItemIndex <> -1 then
  begin
    MainForm.AuthorHold := piece(InvisiblefmListBoxPatients.items[fmListBoxPatients.ItemIndex], '^', 2);
    MainForm.Author_NumHold := piece(InvisiblefmListBoxPatients.items[fmListBoxPatients.ItemIndex], '^', 1);
    ModalResult := mrOK;
    AuthorsCB.state := cbunchecked;
  end;
end;

procedure TfrmAuthor.PatientWildCardEditKeyPress(Sender: TObject;
  var Key: Char);
begin
  AuthorsCB.checked := false;
  if key = chr(13) then
  begin
    CallValue := PatientWildCardEdit.Text;
    if CallValue = '' then
    begin
      ModalResult := mrOK;
      exit;
    end;
    AuthorCall := MainForm.GetAllAuthorsCall;
    AuthorsBrokerCall;
    fmListBoxPatients.setfocus;
  end;
end;

procedure TfrmAuthor.btnCancelClick(Sender: TObject);
begin
  PNErrorTrap := '';
  Status := 'Cancel';
  ModalResult := mrOK;
end;

procedure TfrmAuthor.FormCreate(Sender: TObject);
begin
  Status := '';
end;

procedure TfrmAuthor.FormActivate(Sender: TObject);
begin
  Status := '';
  fmListBoxpatients.clear;
  PatientWildCardEdit.setfocus;
  AuthorsCB.state := cbunchecked;
end;

procedure TfrmAuthor.AuthorsBrokerCall;
var
  K: Integer;
begin
  FIMBroker.Param[0].PType := literal;
  FIMBroker.Param[0].Value := CallValue;
  FIMBroker.RemoteProcedure := AuthorCall;
  Try
   FIMBroker.Call;
   {check for errors on return}
  except
   on E:EBrokerError do
    begin
     ShowMessage('Broker Error: '+E.Message);
     exit;
    end;
   on E:EAccessViolation do
    begin
     ShowMessage(E.Message);
     exit;
    end;
   else
    begin
     raise;
     exit;
    end;
  end;
  GroupBox1.visible := true;
  InvisiblefmListBoxPatients.Items.Clear;
  fmListBoxPatients.Items.Clear;
  InvisiblefmListBoxPatients.Items := FIMBroker.Results;
  for K := 0 to (InvisiblefmListBoxPatients.items.count - 1) do
  begin
    fmListBoxPatients.items.add(piece(InvisiblefmListBoxPatients.items[K], '^', 2));
  end;
  btnOK.visible := true;
end;

procedure TfrmAuthor.fmListBoxPatientsKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then btnOKClick(application);
end;

end.
