//Package:       RMIM - Functional Independence Measurement (FIM)
//Date Created : Nov 1,2002
//Site Name:     West Palm Beach VA Medical Center
//Developers:    John (Larry) McIntosh, Jerry Pickup, Cyndi McCracken
//Description:   Creates progress notes/consult responses and sends FIM
//               data to the FSOD database at AAC
unit SignNote;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Trpcb, Hash, Mfunstr;

type
  TfrmSign = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    PWord: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    PtName: TLabel;
    NoteTitle: TLabel;
    Label4: TLabel;
    Author: TLabel;
    Label5: TLabel;
    Cosigner: TLabel;
    Label6: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure PWordKeyPress(Sender: TObject; var Key: Char);
  Private
    { Private declarations }
  Public
    { Public declarations }
  end;

var
  frmSign: TfrmSign;

implementation

uses Main, Cpat, uFIM_Objects;

{$R *.DFM}

procedure TfrmSign.FormActivate(Sender: TObject);
begin
  PWord.setfocus;
end;

procedure TfrmSign.BitBtn1Click(Sender: TObject);
begin
 If MainForm.NewPN_IEN <> '' then
  begin
   FIMBroker.Param[0].PType  := literal;
   FIMBroker.Param[0].Value  := MainForm.NewPN_IEN;
   FIMBroker.Param[1].PType  := literal;
   FIMBroker.Param[1].Value  := Encrypt(PWord.Text);
   FIMBroker.RemoteProcedure := MainForm.VerifyESign; {TIU SIGN RECORD}
   Try
    FIMBroker.Call;
    {check for errors on return}
   except
    on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
      ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
   end;
   if FIMBroker.Results[0] <> '0' then
    begin
     MessageDlg(Piece(FIMBroker.Results[0], '^', 2), mtinformation, [mbok], 0);
     PWord.Text := '';
     PWord.SetFocus;
     ModalResult := 0;
     exit;
    end;
  end;
 If MainForm.Consul_IEN <> '' then
  begin
   FIMBroker.Param[0].PType  := literal;
   FIMBroker.Param[0].Value  := MainForm.Consul_IEN;
   FIMBroker.Param[1].PType  := literal;
   FIMBroker.Param[1].Value  := Encrypt(PWord.Text);
   FIMBroker.RemoteProcedure := MainForm.VerifyESign; {TIU SIGN RECORD}
   Try
    FIMBroker.Call;
    {check for errors on return}
   except
    on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
      ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
   end;
   if FIMBroker.Results[0] <> '0' then
    begin
     MessageDlg(Piece(FIMBroker.Results[0], '^', 2), mtinformation, [mbok], 0);
     PWord.Text := '';
     PWord.SetFocus;
     ModalResult := 0;
     exit;
    end;
  end;
 If MainForm.AddPN_IEN <> '' then
  begin
   FIMBroker.Param[0].PType  := literal;
   FIMBroker.Param[0].Value  := MainForm.AddPN_IEN;
   FIMBroker.Param[1].PType  := literal;
   FIMBroker.Param[1].Value  := Encrypt(PWord.Text);
   FIMBroker.RemoteProcedure := MainForm.VerifyESign; {TIU SIGN RECORD}
   Try
    FIMBroker.Call;
    {check for errors on return}
   except
    on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
      ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
   end;
   if FIMBroker.Results[0] <> '0' then
    begin
     MessageDlg(Piece(FIMBroker.Results[0], '^', 2), mtinformation, [mbok], 0);
     PWord.Text := '';
     PWord.SetFocus;
     ModalResult := 0;
     exit;
    end;
  end;
 MainForm.TIU_UnlockNote;
 Screen.cursor := crHourGlass;
 Close;
end;

procedure TfrmSign.BitBtn2Click(Sender: TObject);
begin
  If (Mainform.FSODkey = '0') or (Mainform.SendFSOD = false) then
   begin
    ModalResult := mrCancel;
    exit;
   end;
  If MessageDlg('If you Cancel, ALL of your data will be lost !!'+#13+#13+
                'Do you still wish to Cancel?',mtinformation,[mbyes,mbno],0) = mryes then
   begin
    MainForm.TIU_DeleteNote;
    MainForm.TIU_UnlockNote;
    MainForm.NoteStatus := 'Cancel';
    ModalResult := mrCancel;
   end
  else
   ModalResult := 0;
end;

procedure TfrmSign.PWordKeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(13) then BitBtn1Click(application);
end;

end.
