//Package:       RMIM - Functional Independence Measurement (FIM)
//Date Created : Nov 1,2002
//Site Name:     West Palm Beach VA Medical Center
//Developers:    John (Larry) McIntosh, Jerry Pickup, Cyndi McCracken
//Description:   Creates progress notes/consult responses and sends FIM
//               data to the FSOD database at AAC
unit frmLookupUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Trpcb, Mfunstr;

type
  TfrmLookup = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    BtnSearch: TBitBtn;
    ListBox1: TListBox;
    BtnOK: TBitBtn;
    BtnCancel: TBitBtn;
    InvisibleListBox1: TListBox;
    procedure BtnSearchClick(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1Enter(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmLookup: TfrmLookup;

implementation

uses Main, uFIM_Objects;

{$R *.DFM}

procedure TfrmLookup.BtnSearchClick(Sender: TObject);
var x : Integer;
begin
 ListBox1.Clear;
 InvisibleListBox1.Clear;
 If Label1.Caption = 'Search for Diagnosis' then
  begin
   FIMBroker.Param[0].PType := literal;
   FIMBroker.Param[0].Value := Edit1.Text;
   FIMBroker.Param[1].PType := literal;
   FIMBroker.Param[1].Value := 'ICD';
   FIMBroker.RemoteProcedure := MainForm.DiagnosisCk;
   Try
    FIMBroker.Call;
    {check for errors on return}
   except
    on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
     ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
   end;
   InvisibleListBox1.Items := FIMBroker.Results;
  end;
 For x := 0 to InvisibleListBox1.Items.Count-1 do
  ListBox1.Items.Add(Piece(InvisibleListBox1.Items[x],'^',2));
 If ListBox1.Items.Count > 0 then
  try
   ListBox1.ItemIndex := 0;
   ListBox1.SetFocus;
  except
  end;  
 BtnOk.Default := true;
end;

procedure TfrmLookup.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 If Key = VK_RETURN then
  BtnSearchClick(application);
end;

procedure TfrmLookup.Edit1Enter(Sender: TObject);
begin
 BtnOK.Default := false;
end;

procedure TfrmLookup.ListBox1DblClick(Sender: TObject);
begin
 BtnOK.Click;
end;

end.
