unit uFIM_Objects;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  Menus,
  Trpcb,
  ExtCtrls,
  StdCtrls,
  Hash,
  FileCtrl,
  RPCConf1,
  Printers,
  mFunStr;

type
  TFIM_AppSpecific = class(TObject)
    BrokerCall: string;
    DateTime: string;
    RPCB_Server: string;
    //cd      RPCB_Port: string;
    RPCB_Port: integer;
    GetVisitCall: string;
    GetTitleCall: string;
    TerminateFlag: Boolean;
    ErrorInput: string;
    FormName: string;
    FormVersion: string;
    DateToday: string;
    CallType: string;
      ReadOnly: Boolean;
    CkDate: TDate;
    TimeOutNum: Cardinal;
    TimeOutFlag: Boolean;
    StartedfromCPRS: Boolean;
    ErrorFlag: Boolean;
    DT: string;
    //      NoteErrorTrap : String;  CD 8/4/03 Not being used
    FVistaMsg: Word;
    ParamCount: Integer;
    //    procedure DefaultHandler(var Message); override;
  end;

type
  TFIM_User = class(TObject)
    FBroker: TRPCBroker;
    FDTime: integer;
    FUserName: string;
    FUserDUZ: string;
    FSignOnDt: TDateTime;
    FfrmAuthorStatus: string;
    FFSODkey: string;
    FDomainIEN: string;
    FDomain: string;
    FDivisionIEN: string;
    FDivision: string;
    FSendFSOD: Boolean;
    FConfirmAppClose: Boolean;
    FHelpFileDirectory: string;
    //    function GetSetting(Name: TGMV_UserSetting): string;
    //    procedure SetSetting(Name: TGMV_UserSetting; const Value: string);
  private
    //    function CallServer(Broker: TRPCBroker; RemoteProcedure: string; Parameters: array of string; MultList: TStringList; RetList: TStringList = nil): Boolean; overload;
    //    function CallServer(Broker: TRPCBroker; RemoteProcedure: string; Parameters: array of string; MultList: TStringList; var RetString: string): Boolean; overload;

  public
    { Public declarations }
//    FVistaMsg: Word;
    constructor Create(Broker: TRPCBroker);
    destructor Destroy; override;
    function SignOn(Context: string; BypassOffline: Boolean): Boolean;
    function CreateContext(Context: string): Boolean;
    function SignOff: Boolean;
    function TheString(H: string; SubStrs: array of string; CaseSensitive: Boolean = True): Boolean;
    //    function CheckESig: Boolean;
    //    function SubmitToTaskman(RoutineReference: string): Boolean;
    //    property Setting[Name: TGMV_UserSetting]: string read GetSetting write SetSetting;
  published
    { Published declarations }
    property Broker: TRPCBroker read FBroker;
    property DTime: integer read FDTime;
    property UserName: string read FUserName write FUserName;
    property FSODkey: string read FFSODkey write FFSODkey;
    property UserDUZ: string read FUserDUZ write FUserDUZ;
    property frmAuthorStatus: string read FfrmAuthorStatus;
    property SignOnDateTime: TDateTime read FSignOnDt;
    property DomainIEN: string read FDomainIEN;
    property Domain: string read FDomain;
    property DivisionIEN: string read FDivisionIEN;
    property Division: string read FDivision;
    property ConfirmAppClose: Boolean read FConfirmAppClose write FConfirmAppClose;
    property HelpFileDirectory: string read FHelpFileDirectory;
    property SendFSOD: Boolean read FSendFSOD write FSendFSOD;
  end;

type
  TFIM_Patient = class(TObject)
    PatientSSN: string;
    PatientDFN: string;
    CPRSDFN: string;
    PatientDOB: string;
    PatientAGE: string;
    PatientName: string;
    PatientSex: string;
    PatientMaritalStatus: string;
    PatientRace: string;
    P_Street: string;
    P_City: string;
    P_State: string;
    P_Zip: string;
    P_Phone: string;
    PatientActiveDuty: string;
    Sensitivity: string;
    //      GetPatientAddress: string; cd 8/1/03 never used
  end;

type
  TFIM_Visit = class(TObject)
    //      CreateVisitCall: string; cd 8/1/03 never used
    VisitNo: string;
    VisitDate: string;
    VisitLocation: string;
    VisitType: string;
    //      LoadVisitCall: string; cd 8/1/03 never used
  end;

type
  TFIM_Consult = class(TObject)
    NoteStatus: string;
    ConsultTitle: string;
    Consult_IEN: string;
    Consult: string;
    CosignStatus: string;
    PN_IEN: string;
    TempPN_IEN: string;
    AddPN_IEN: string;
    NewPN_IEN: string;
    Consul_IEN: string;
    PatNoteNum: string;
    SendAddendum: string;
    Author: string;
    SendParam: string;
    Author_Num: string;
    Author_NumHold: string;
    AuthorHold: string;
    Cosigner: string;
    Cosigner_Num: string;
    CosignerHold: string;
    FIMFacilityName: string;
    StationNumber: string;
    FSODNoteTitle: string;
    NonFSODNoteTitle: string;
    FSODConsultTitle: string;
    FSODNoteIEN: string;
    NonFSODNoteIEN: string;
    FSODConsultIEN: string;
    NoteTitle: string;
    TitleNo: string;
    FSODMailGroup: string;
    MailMsgnum: string;
    RecType: string;
    CaseIEN: string;
    NoteError: boolean;
    StopFlag: boolean;
    MDate: string;
    Provider: Boolean;
    ProviderDuz: string;
    DT: string;
    NowDate: string;
    LastPrimary: integer;
  end;

  //function InString(S: string; SubStrs: array of string; CaseSensitive: Boolean = True): Boolean;

const
  RPC_CREATECONTEXT: string = 'RMIMFIM';
  RPC_CheckMultiPatients: string = 'DG CHK BS5 XREF Y/N';
  //cd 8/1/03    RPC_LoadConsultsCall : String = 'ORQQCN LIST';
  //cd this was a duplicate
  RPC_LoadConsultsCall: string = 'RMIM CONSULT LIST';
  //cd 8/1/03 Had to rename Constants due to procedure with same name GetVisits.
  RPC_GetVisits: string = 'ORWCV VST';
  RPC_DiagnosisCk: string = 'ORWPCE LEX';
  //cd 8/1/03 Patch 1 added RPC Call to get all admissions.
  RPC_GetAdmits: string = 'ORWPT ADMITLST';
  RPC_GetNowCall: string = 'ORWU DT';
  RPC_GetMDate: string = 'ORWD DT';
  RPC_CreateNote: string = 'TIU CREATE RECORD';
  RPC_UpdateNote: string = 'TIU UPDATE RECORD';
  RPC_CreateAddendum: string = 'TIU CREATE ADDENDUM RECORD';
  RPC_AddendumText: string = 'TIU SET DOCUMENT TEXT';
  RPC_GetCosign: string = 'TIU REQUIRES COSIGNATURE';
  RPC_VerifyESign: string = 'TIU SIGN RECORD';
  RPC_LockTIURecord: string = 'TIU LOCK RECORD';
  RPC_UnlockTIURecord: string = 'TIU UNLOCK RECORD';
  RPC_DeleteTIURecord: string = 'TIU DELETE RECORD';

  RPC_GetPatientCall: string = 'RMIM PATIENT LOOKUP';
  RPC_GetPatientData: string = 'RMIM PATIENT INFO';
  RPC_GetAllAuthorsCall: string = 'RMIM AUTHOR LOOKUP';
  RPC_RestrictedRecordCall: string = 'RMIM RESTRICTED RECORD';
  RPC_GetLocationsCall: string = 'RMIM LOCATION LOOKUP';

  RPC_GetDFNCall: string = 'RMIM GET DFN';
  RPC_SendFormName: string = 'RMIM GET FORM';
  RPC_SendEMailCall: string = 'RMIM SEND EMAIL';
  RPC_ReformatDateTime: string = 'RMIM CONVERT DATE';
  RPC_GetUserCall: string = 'RMIM GET USER INFO';
  RPC_FIMParms: string = 'RMIM FIM PARAMETER';
  RPC_DMECall: string = 'RMIM GET PATIENT DME';
  RPC_SaveFSOD: string = 'RMIM SAVE FSOD';
  RPC_GetCases: string = 'RMIM GET CASES';
  RPC_GetSelectedCase: string = 'RMIM GET SELECTED CASE';
  RPC_CheckVersion: string = 'RMIM VERSION';
  RPC_LockPatient: string = 'RMIM LOCK PATIENT';
  RPC_CheckforDuplicate: string = 'RMIM CHECK DUPLICATE';

var
  FIMUser: TFIM_User;
  FIMPatient: TFIM_Patient;
  FIMVisit: TFIM_Visit;
  FIMConsult: TFIM_Consult;
  FIMAppSpecific: TFIM_AppSpecific;
  FIMBroker: TRPCBroker;
  FIMRunAsCPRSSlave: Boolean = False;
  FIMInitialDFN: string = '';

implementation

uses
  Main;

constructor TFIM_User.Create(Broker: TRPCBroker);
begin
  inherited Create;
  FBroker := Broker;
  FUserDUZ := '';
  FUserName := '';
  FDivisionIEN := '';
  FDivision := '';
  FfrmAuthorStatus := '';
  FFSODkey := '';
  FDomainIEN := '';
  FDomain := '';
  FDivisionIEN := '';
  FDivision := '';
  FSendFSOD := False;
end;

destructor TFIM_User.Destroy;
begin
  FBroker := nil;
  inherited Destroy;
end;

function TFIM_User.TheString(H: string; SubStrs: array of string; CaseSensitive: Boolean = True): Boolean;
var
  i: integer;
begin
  i := 0;
  Result := False;
  while (i <= High(SubStrs)) and (Result = False) do
    begin
      if CaseSensitive then
        begin
          if Pos(SubStrs[i], H) > 0 then
            Result := True
          else
            inc(i)
        end
      else
        begin
          if Pos(LowerCase(SubStrs[i]), LowerCase(H)) > 0 then
            Result := True
          else
            inc(i)
        end;
    end
end;


{function Piece(Value, Delimiter: string; StartPiece: integer = 1; EndPiece: integer = 0): string;
var
  i: integer;
begin
  if EndPiece > 0 then {Two parameter mode}
{    begin
      i := StartPiece;
      while i < EndPiece do
        begin
          Result := Result + Piece(Value, Delimiter, i) + Delimiter;
          inc(i);
        end;
      Result := Result + Piece(Value, Delimiter, EndPiece);
    end
  else
    if StartPiece < 1 then
      Result := ''
    else
      if (Pos(Delimiter, Value) < 1) and (StartPiece > 1) then
        Result := ''
      else
        if Pos(Delimiter, Value) < 1 then
          Result := Value
        else
          begin
            i := 1;
            while i < StartPiece do
              begin
                if Pos(Delimiter, Value) < 1 then
                  Value := ''
                else
                  Value := Copy(Value, Pos(Delimiter, Value) + 1, Length(Value));
                inc(i);
              end;

            if Value <> '' then
              if Pos(Delimiter, Value) > 0 then
                Value := Copy(Value, 0, Pos(Delimiter, Value) - 1);

            Result := Value;
          end;
end;
}
function TFIM_User.CreateContext(Context: string): Boolean;
begin
  Result := FBroker.CreateContext(Context);
end;

function TFIM_User.SignOff: Boolean;
//var
//  f: TextFile;
begin
  Result := True;
end;

function GetPiece(Value, Delimiter: string; StartPiece: integer; EndPiece: integer = 0): string;
var
  i: integer;
begin
  if EndPiece > 0 then {Two parameter mode}
    begin
      i := StartPiece;
      while i < EndPiece do
        begin
          Result := Result + getPiece(Value, Delimiter, i) + Delimiter;
          inc(i);
        end;
      Result := Result + getPiece(Value, Delimiter, EndPiece);
    end
  else
    if StartPiece < 1 then
      Result := ''
    else
      if Pos(Delimiter, Value) < 1 then
        Result := Value
      else
        begin
          i := 1;
          while i < StartPiece do
            begin
              if Pos(Delimiter, Value) < 1 then
                Value := ''
              else
                Value := Copy(Value, Pos(Delimiter, Value) + 1, Length(Value));
              inc(i);
            end;

          if Value <> '' then
            if Pos(Delimiter, Value) > 0 then
              Value := Copy(Value, 0, Pos(Delimiter, Value) - 1);

          Result := Value;
        end;
end;



function TFIM_User.SignOn(Context: string; BypassOffline: Boolean): Boolean;
var
  i, x: integer;
  UseServerList: Boolean;
  SLServer, SLPort: string;
  UserParameter: string;
  DemoMode: boolean;
  f: textfile;

  function Online: Boolean;
    {Determine if the application is on-line after the user has signed on}
  begin
    Result := True;
  end;

begin
  {Initialize variables}
  Result := False;
  UseServerList := True;
//  SLServer := 'BROKERSERVER';
//  SLPort := '9200';
  FIMPatient.CPRSDFN := '';
  FIMAppSpecific.StartedfromCPRS := false;
//showmessage('1');

  {Are we connected}
  if FBroker.Socket > 0 then
    begin
      Result := True;
      exit;
    end;
//showmessage('2');

  {Loop through the params}
  if ParamCount > 0 then
  begin
        If (ParamStr(1) <> '') then
          begin
          if TheString(ParamStr(1), ['/server=', '-server=',
                'server=', '/s=', '-s=', 's='], False) then
             SLServer := Piece(ParamStr(1), '=', 2);
             UseServerList := False;
//showmessage(SLServer);
          end;

          If (ParamStr(2) <> '') then
          begin
            if TheString(ParamStr(2), ['/port=', '-port=', 'port=',
               '/p=', '-p=', 'p='], False) then
          begin
            SLPort := Piece(ParamStr(2), '=', 2);
            UseServerList := False;
//showmessage(SLPort);
          end;
        end;

        If (ParamStr(3) <> '') then
        begin
          if TheString(ParamStr(3), ['/dfn=', '-dfn=', 'dfn=', 'd='], False) then
            begin
              FIMPatient.PatientDFN := Piece(ParamStr(3), '=', 2);
              FIMPatient.CPRSDFN := FIMPatient.PatientDFN;
//              Result := True;
//showmessage(FIMPatient.PatientDFN);
            end;
              FIMAppSpecific.FVistaMsg := RegisterWindowMessage('VistA Event - Clinical');
//              MainForm.memmessages.Lines.Clear;
              FIMAppSpecific.StartedfromCPRS := True;
              UseServerList := False;
      end;

     end;

  if UseServerList then
    if GetServerInfo(SLServer, SLPort) <> 1 then
      begin
        MessageDlg('Sign-On Cancelled while selecting server', mtInformation, [mbok], 0);
        Result := False;
        Exit;
      end;

  try
    FBroker.Server := SLServer;
    FBroker.ListenerPort := StrToIntDef(SLPort, 9200);
    FBroker.ClearParameters := True;
    FBroker.ClearResults := True;
    FBroker.Connected := True;
  except
    on E: EBrokerError do
      begin
        MessageDlg('Error Encountered' + #13 + #13 +
          'User Sign-on not complete.' + #13 +
          'Attempted connection using the following:' + #13 +
          'VistA Server: ' + FBroker.Server + #13 +
          'Listener Port: ' + IntToStr(FBroker.ListenerPort) + #13 +
          'Error Message: ' + #13 + E.Message,
          mtError,
          [mbok],
          0);
        Result := False;
        Exit;
      end;
  else
    Result := False;
    raise;
  end;

  if not FBroker.CreateContext(Context) then
    begin
      MessageDlg('Sorry, you are not allowed access to this application.', mtInformation, [mbok], 0);
      Result := False;
      Exit;
    end;

  FIMBroker.RemoteProcedure := RPC_GetUserCall;
  try
    FIMBroker.Call;
    {check for errors on return}
  except
    on E: EBrokerError do
      begin
        ShowMessage('Broker Error: ' + E.Message);
        result := False;
        exit;
      end;
    on E: EAccessViolation do
      begin
        ShowMessage(E.Message);
        result := False;
        exit;
      end;
  else
    begin
      raise;
      exit;
    end;
  end;
  FIMUser.UserDUZ := Piece(FIMBroker.Results[0], '^', 1);
  FIMUser.UserName := Piece(FIMBroker.Results[0], '^', 2);
  FIMUser.FSODKey := Piece(FIMBroker.Results[0], '^', 3);
  FIMConsult.Author := FIMUser.UserName;
  FIMConsult.Author_Num := FIMUser.UserDuz;
  {x := StrToInt(FIMUser.UserDUZ);  }
  x := StrToInt64(FIMUser.UserDUZ);
  if x = 0 then
    begin
      MessageDlg('Error Detected during logon (DUZ = 0).' + chr(13) + 'You will have to start over.', mtError, [mbOK], 0);
      if FIMBroker.Connected = True then
        FIMBroker.Connected := False;
      result := False;
      Application.Terminate;
      exit;
    end;
  //   Send the Form Name to Vista for Error checking
  FIMBroker.RemoteProcedure := RPC_SendFormName;
  FIMBroker.Param[0].PType := Literal;
  FIMBroker.Param[0].Value := 'FIM';
  try
    FIMBroker.Call;
    {check for errors on return}
  except
    on E: EBrokerError do
      begin
        ShowMessage('Broker Error: ' + E.Message);
        result := False;
        exit;
      end;
    on E: EAccessViolation do
      begin
        ShowMessage(E.Message);
        result := False;
        exit;
      end;
  else
    begin
      raise;
      result := False;
      exit;
    end;
  end;

  Result := True;

end;

end.

