unit uFIM_Objects;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  Menus,
  Trpcb,
  ExtCtrls,
  StdCtrls,
  Hash,
  FileCtrl,
  RPCConf1,
  Printers;

type
   TFIM_AppSpecific = class(TObject)
      BrokerCall: string;
      DateTime: string;
      RPCB_Server: string;
      RPCB_Port: Integer;
      GetVisitCall: string;
      GetTitleCall: string;
      TerminateFlag: Boolean;
      ErrorInput: string;
      FormName: string;
      FormVersion: string;
      DateToday: string;
      CallType : String;
      ReadOnly : Boolean;
      CkDate : TDate;
      TimeOutNum : Cardinal;
      TimeOutFlag : Boolean;
      StartedfromCPRS : Boolean;
      ErrorFlag : Boolean;
      DT : String;
//      NoteErrorTrap : String;  CD 8/4/03 Not being used
      FVistaMsg: Word;
//    procedure DefaultHandler(var Message); override;
   end;

type
   TFIM_User = class(TObject)
     FBroker : TRPCBroker;
     FDTime: integer;
     FUserName: string;
     FUserDUZ: string;
     FSignOnDt: TDateTime;
     FfrmAuthorStatus: string;
     FFSODkey : string;
     FDomainIEN: string;
     FDomain: string;
     FDivisionIEN: string;
     FDivision: string;
     FSendFSOD : Boolean;
     FConfirmAppClose: Boolean;
     FHelpFileDirectory: string;
//    function GetSetting(Name: TGMV_UserSetting): string;
//    procedure SetSetting(Name: TGMV_UserSetting; const Value: string);
  private
//    function CallServer(Broker: TRPCBroker; RemoteProcedure: string; Parameters: array of string; MultList: TStringList; RetList: TStringList = nil): Boolean; overload;
//    function CallServer(Broker: TRPCBroker; RemoteProcedure: string; Parameters: array of string; MultList: TStringList; var RetString: string): Boolean; overload;

  public
    { Public declarations }
//    FVistaMsg: Word;
    constructor Create(Broker: TRPCBroker);
    destructor Destroy; override;
    function SignOn(Context: string; BypassOffline: Boolean): Boolean;
    function CreateContext(Context: string): Boolean;
    function SignOff: Boolean;
//    function CheckESig: Boolean;
//    function SubmitToTaskman(RoutineReference: string): Boolean;
//    property Setting[Name: TGMV_UserSetting]: string read GetSetting write SetSetting;
  published
    { Published declarations }
    property Broker: TRPCBroker read FBroker;
    property DTime: integer read FDTime;
    property UserName: string read FUserName write FUserName;
    property FSODkey : string read FFSODkey write FFSODkey;
    property UserDUZ: string read FUserDUZ write FUserDUZ;
    property frmAuthorStatus: string read FfrmAuthorStatus;
    property SignOnDateTime: TDateTime read FSignOnDt;
    property DomainIEN: string read FDomainIEN;
    property Domain: string read FDomain;
    property DivisionIEN: string read FDivisionIEN;
    property Division: string read FDivision;
    property ConfirmAppClose: Boolean read FConfirmAppClose write FConfirmAppClose;
    property HelpFileDirectory: string read FHelpFileDirectory;
    property SendFSOD : Boolean read FSendFSOD write FSendFSOD;
  end;

type
   TFIM_Patient = class(TObject)
      PatientSSN: string;
      PatientDFN: string;
      CPRSDFN: string;
      PatientDOB: string;
      PatientAGE: string;
      PatientName: string;
      PatientSex: string;
      PatientMaritalStatus: string;
      PatientRace: string;
      P_Street: string;
      P_City: string;
      P_State: string;
      P_Zip: string;
      P_Phone: string;
      PatientActiveDuty: string;
      Sensitivity : string;
//      GetPatientAddress: string; cd 8/1/03 never used
   end;

type
   TFIM_Visit = class(TObject)
//      CreateVisitCall: string; cd 8/1/03 never used
      VisitNo: string;
      VisitDate: string;
      VisitLocation: string;
      VisitType: string;
//      LoadVisitCall: string; cd 8/1/03 never used
   end;

type
   TFIM_Consult = class(TObject)
      NoteStatus: string;
      ConsultTitle: string;
      Consult_IEN: string;
      Consult: string;
      CosignStatus : String;
      PN_IEN: string;
      TempPN_IEN: string;
      AddPN_IEN: string;
      NewPN_IEN: string;
      Consul_IEN: string;
      PatNoteNum: string;
      SendAddendum: string;
      Author: string;
      SendParam : String;
      Author_Num: string;
      Author_NumHold: string;
      AuthorHold: string;
      Cosigner: string;
      Cosigner_Num: string;
      CosignerHold: string;
      FIMFacilityName: string;
      StationNumber: string;
      FSODNoteTitle: string;
      NonFSODNoteTitle: string;
      FSODConsultTitle: string;
      FSODNoteIEN: string;
      NonFSODNoteIEN: string;
      FSODConsultIEN: string;
      NoteTitle: string;
      TitleNo: string;
      FSODMailGroup: string;
      MailMsgnum: string;
      RecType : string;
      CaseIEN : string;
      NoteError : boolean;
      StopFlag : boolean;
      MDate : String;
      Provider : Boolean;
      ProviderDuz : string;
      DT: string;
      NowDate: string;
      LastPrimary: integer;
    end;

//function InString(S: string; SubStrs: array of string; CaseSensitive: Boolean = True): Boolean;



const
    RPC_CREATECONTEXT : String = 'RMIMFIM';
    RPC_CheckMultiPatients : String = 'DG CHK BS5 XREF Y/N';
//cd 8/1/03    RPC_LoadConsultsCall : String = 'ORQQCN LIST';
//cd this was a duplicate
    RPC_LoadConsultsCall : String = 'RMIM CONSULT LIST';
//cd 8/1/03 Had to rename Constants due to procedure with same name GetVisits.
    RPC_GetVisits : String = 'ORWCV VST';
    RPC_DiagnosisCk : String = 'ORWPCE LEX';
//cd 8/1/03 Patch 1 added RPC Call to get all admissions.
    RPC_GetAdmits : String = 'ORWPT ADMITLST';
    RPC_GetNowCall : String = 'ORWU DT';
    RPC_GetMDate : String = 'ORWD DT';
    RPC_CreateNote : String = 'TIU CREATE RECORD';
    RPC_UpdateNote : String = 'TIU UPDATE RECORD';
    RPC_CreateAddendum : String = 'TIU CREATE ADDENDUM RECORD';
    RPC_AddendumText : String = 'TIU SET DOCUMENT TEXT';
    RPC_GetCosign : String = 'TIU REQUIRES COSIGNATURE';
    RPC_VerifyESign : String = 'TIU SIGN RECORD';
    RPC_LockTIURecord : String = 'TIU LOCK RECORD';
    RPC_UnlockTIURecord : String = 'TIU UNLOCK RECORD';
    RPC_DeleteTIURecord : String = 'TIU DELETE RECORD';

    RPC_GetPatientCall : String = 'RMIM PATIENT LOOKUP';
    RPC_GetPatientData : String = 'RMIM PATIENT INFO';
    RPC_GetAllAuthorsCall : String = 'RMIM AUTHOR LOOKUP';
    RPC_RestrictedRecordCall : String = 'RMIM RESTRICTED RECORD';
    RPC_GetLocationsCall : String = 'RMIM LOCATION LOOKUP';

    RPC_GetDFNCall : String = 'RMIM GET DFN';
    RPC_SendFormName : String = 'RMIM GET FORM';
    RPC_SendEMailCall : String = 'RMIM SEND EMAIL';
    RPC_ReformatDateTime : String = 'RMIM CONVERT DATE';
    RPC_GetUserCall : String = 'RMIM GET USER INFO';
    RPC_FIMParms : String = 'RMIM FIM PARAMETER';
    RPC_DMECall : String = 'RMIM GET PATIENT DME';
    RPC_SaveFSOD : String = 'RMIM SAVE FSOD';
    RPC_GetCases : String = 'RMIM GET CASES';
    RPC_GetSelectedCase : String = 'RMIM GET SELECTED CASE';
    RPC_CheckVersion : String = 'RMIM VERSION';
    RPC_LockPatient : String = 'RMIM LOCK PATIENT';
    RPC_CheckforDuplicate : String = 'RMIM CHECK DUPLICATE';


var
  FIMUser: TFIM_User;
  FIMPatient: TFIM_Patient;
  FIMVisit: TFIM_Visit;
  FIMConsult: TFIM_Consult;
  FIMAppSpecific: TFIM_AppSpecific;
  FIMBroker: TRPCBroker;
  FIMRunAsCPRSSlave: Boolean = False;
  FIMInitialDFN: string = '';


implementation

uses
  uFIM_Common, Main;

constructor TFIM_User.Create(Broker: TRPCBroker);
var
  i: integer;
begin
  inherited Create;
  FBroker := Broker;
  FUserDUZ := '';
  FUserName := '';
  FDivisionIEN := '';
  FDivision := '';
  FfrmAuthorStatus := '';
  FFSODkey := '';
  FDomainIEN := '';
  FDomain := '';
  FDivisionIEN := '';
  FDivision := '';
  FSendFSOD := False;
end;

destructor TFIM_User.Destroy;
begin
  FBroker := nil;
  inherited Destroy;
end;

function InString(S: string; SubStrs: array of string; CaseSensitive: Boolean = True): Boolean;
var
  i: integer;
begin
  i := 0;
  Result := False;
  while (i <= High(SubStrs)) and (Result = False) do
    begin
      if CaseSensitive then
        begin
          if Pos(SubStrs[i], S) > 0 then
            Result := True
          else
            inc(i)
        end
      else
        begin
          if Pos(LowerCase(SubStrs[i]), LowerCase(S)) > 0 then
            Result := True
          else
            inc(i)
        end;
    end
end;


function Piece(Value, Delimiter: string; StartPiece: integer = 1; EndPiece: integer = 0): string;
var
  i: integer;
begin
  if EndPiece > 0 then {Two parameter mode}
    begin
      i := StartPiece;
      while i < EndPiece do
        begin
          Result := Result + Piece(Value, Delimiter, i) + Delimiter;
          inc(i);
        end;
      Result := Result + Piece(Value, Delimiter, EndPiece);
    end
  else if StartPiece < 1 then
    Result := ''
  else if (Pos(Delimiter, Value) < 1) and (StartPiece > 1) then
    Result := ''
  else if Pos(Delimiter, Value) < 1 then
    Result := Value
  else
    begin
      i := 1;
      while i < StartPiece do
        begin
          if Pos(Delimiter, Value) < 1 then
            Value := ''
          else
            Value := Copy(Value, Pos(Delimiter, Value) + 1, Length(Value));
          inc(i);
        end;

      if Value <> '' then
        if Pos(Delimiter, Value) > 0 then
          Value := Copy(Value, 0, Pos(Delimiter, Value) - 1);

      Result := Value;
    end;
end;

function TFIM_User.CreateContext(Context: string): Boolean;
begin
  Result := FBroker.CreateContext(Context);
end;


{function CallServer(Broker: TRPCBroker; RemoteProcedure: string; Parameters: array of string; MultList: TStringList; var RetString: string): Boolean;
begin
  Result := CallServer(Broker, RemoteProcedure, Parameters, MultList, nil);
  RetString := Broker.Results[0];
end;
}{
function CallServer(Broker: TRPCBroker; RemoteProcedure: string; Parameters: array of string; MultList: TStringList; RetList: TStringList = nil): Boolean;
var
  i, j: integer;
begin
  Broker.RemoteProcedure := RemoteProcedure;
  i := 0;
  while i <= High(Parameters) do
    if (Copy(Parameters[i], 1, 1) = '@') and (Parameters[i] <> '@') then
      begin
        Broker.Param[i].Value := Copy(Parameters[i], 2, Length(Parameters[i]));
        Broker.Param[i].PType := Reference;
        inc(i);
      end
    else
      begin
        Broker.Param[i].Value := Parameters[i];
        Broker.Param[i].PType := Literal;
        inc(i);
      end;

  if MultList <> nil then
    begin
      for j := 0 to MultList.Count - 1 do
        Broker.Param[i + 1].Mult[IntToStr(j)] := MultList[j];
      Broker.Param[i + 1].PType := List;
    end;

  try
    if RetList = nil then
      Broker.Call
    else
      begin
        RetList.Clear;
        Broker.lstCall(RetList);
      end;
    Result := True;

  except
    on e: EBrokerError do
      begin
        MessageDlg(
          'Error encountered retrieving VistA data.' + #13 +
          'Server: ' + Broker.Server + #13 +
          'Listener port: ' + IntToStr(Broker.ListenerPort) + #13 +
          'Remote procedure: ' + Broker.RemoteProcedure + #13 +
          'Error is: ' + #13 +
          e.Message, mtError, [mbok], e.HelpContext);
        Broker.Results.Insert(0, '-1^' + e.Message);
        Result := False;
      end
  else
    raise;
  end;
end;
}

function TFIM_User.SignOff: Boolean;
var
  f: TextFile;
begin
  Result := True;
end;


function TFIM_User.SignOn(Context: string; BypassOffline: Boolean): Boolean;
var
  i,x: integer;
  UseServerList: Boolean;
  SLServer, SLPort: string;
  CRCActual, CRCExpected: string;
  f: textfile;
  UserParameter: string;
  DemoMode : boolean;

  function Online: Boolean;
    {Determine if the application is on-line after the user has signed on}
  begin
    Result := True;
  end;

begin
  DemoMode := False;
  Result := False;
  UseServerList := True;
  SLServer := 'BROKERSERVER';
  SLPort := '9200';
  FBroker.ClearParameters := True;
  FBroker.ClearResults := True;
//cd1  FIMPatient.CPRSDFN := '';
//cd1  FIMAppSpecific.StartedfromCPRS := false;

  if FBroker.Socket > 0 then
    begin
      Result := True;
      exit;
    end;


  if not DemoMode then
    for i := 1 to ParamCount do
      begin
        if MainForm.InString(ParamStr(i), ['/s=', '-s=', 's='], False) then
          begin
            SLServer := Piece(ParamStr(i), '=', 2);
            UseServerList := False;
          end;

        if InString(ParamStr(i), ['/server=', '-server=', 'server='], False) then
          begin
            SLServer := Piece(ParamStr(i), '=', 2);
            UseServerList := False;
          end;

        if InString(ParamStr(i), ['/p=', '-p=', 'p='], False) then
          begin
            SLPort := Piece(ParamStr(i), '=', 2);
//            SLPort := StrToIntDef(Piece(ParamStr(i), '=', 2), '9200');
            UseServerList := False;
          end;

        if InString(ParamStr(i), ['/port=', '-port=', 'port='], False) then
          begin
            SLPort := Piece(ParamStr(i), '=', 2);
            UseServerList := False;
          end;

        if InString(ParamStr(i), ['/cprs', '-cprs'], False) then
          FIMRunAsCPRSSlave := True;

        if InString(ParamStr(i), ['/dfn=', '-dfn=', 'dfn=', 'd='], False) then
          begin
            UseServerList := False;
            FIMPatient.PatientDFN := Piece(ParamStr(i), '=', 2);
            FIMPatient.CPRSDFN := FIMPatient.PatientDFN;
//            FIMAppSpecific.FVistaMsg := RegisterWindowMessage('VistA Event - Clinical');
//            MainForm.memmessages.Lines.Clear;
//            FIMAppSpecific.StartedfromCPRS := true;
//            MainForm.New1.Click;

          end;

//          FIMInitialDFN := Piece(ParamStr(i), '=', 2);

        if InString(ParamStr(i), ['/helpdir=', '-helpdir=', 'helpdir='], False) then
          FHelpFileDirectory := ExcludeTrailingBackslash(Piece(ParamStr(i), '=', 2)) + '\';

      end;

  if not DemoMode then
    if UseServerList then
      if GetServerInfo(SLServer, SLPort) <> 1 then
        begin
          MessageDlg('Sign-On Cancelled while selecting server', mtInformation, [mbok], 0);
          Result := False;
          Exit;
        end
      else
        begin
          Application.ProcessMessages; {Refresh screen prior to connecting}
        end;

  try
//    FBroker.Server := SLServer;
//    FBroker.ListenerPort := StrToIntDef(SLPort, 9200);
    FBroker.Connected := True;
    Application.ProcessMessages;
  except
    on E: EBrokerError do
      begin
        MessageDlg('Error Encountered' + #13 + #13 +
          'User Sign-on not complete.' + #13 +
          'Attempted connection using the following:' + #13 +
          'VistA Server: ' + FBroker.Server + #13 +
          'Listener Port: ' + IntToStr(FBroker.ListenerPort) + #13 +
          'Error Message: ' + #13 + E.Message,
          mtError,
          [mbok],
          0);
        Result := False;
        Exit;
      end;
  else
    Result := False;
    raise;
  end;

  if not FBroker.CreateContext(Context) then
    begin
      MessageDlg('Sorry, you are not allowed access to this application.', mtInformation, [mbok], 0);
      Result := False;
      Exit;
    end;


    FIMBroker.RemoteProcedure := RPC_GetUserCall;
    Try
     FIMBroker.Call;
     {check for errors on return}
    except
     on E:EBrokerError do
      begin
       ShowMessage('Broker Error: '+E.Message);
       result := false;
       exit;
      end;
     on E:EAccessViolation do
      begin
       ShowMessage(E.Message);
       result := false;
       exit;
      end;
     else
      begin
       raise;
       exit;
      end;
    end;
    FIMUser.UserDUZ  := Piece(FIMBroker.Results[0], '^', 1);
    FIMUser.UserName := Piece(FIMBroker.Results[0], '^', 2);
    FIMUser.FSODKey  := Piece(FIMBroker.Results[0], '^', 3);
    FIMConsult.Author := FIMUser.UserName;
    FIMConsult.Author_Num := FIMUser.UserDuz;
    x := StrToInt(FIMUser.UserDUZ);
    if x = 0 then
    begin
      MessageDlg('Error Detected during logon (DUZ = 0).' + chr(13) + 'You will have to start over.', mtError, [mbOK], 0);
      if FIMBroker.Connected = true then FIMBroker.Connected := false;
      result := false;
      Application.Terminate;
      exit;
    end;
//   Send the Form Name to Vista for Error checking
    FIMBroker.RemoteProcedure := RPC_SendFormName;
    FIMBroker.Param[0].PType := Literal;
    FIMBroker.Param[0].Value := 'FIM';
    Try
     FIMBroker.Call;
     {check for errors on return}
    except
     on E:EBrokerError do
      begin
       ShowMessage('Broker Error: '+E.Message);
       result := false;
       exit;
      end;
     on E:EAccessViolation do
      begin
       ShowMessage(E.Message);
       result := false;
       exit;
      end;
     else
      begin
       raise;
       result := false;
       exit;
      end;
    end;

  Result := True;



end;




end.
