//Package:       RMIM - Functional Independence Measurement (FIM)
//Date Created : Nov 1,2002
//Site Name:     West Palm Beach VA Medical Center
//Chief Developer: S. Adele Cerbone
//Developers:    John (Larry) McIntosh, Jerry Pickup, Cyndi McCracken,
//Description:   Creates progress notes/consult responses and sends FIM
//               data to the FSOD database at AAC

unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons, TabNotBk,
  Tabs, DBCtrls, DBLookup, FileCtrl,
  Menus, RPCConf1, Printers, DBIProcs, DBITypes, DBIErrs,
  CPat, Trpcb, Grids, ComCtrls, Mfunstr, CheckLst;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    New1: TMenuItem;
    pnlPt1: TPanel;
    pgctrl1: TPageControl;
    tbshtPt: TTabSheet;
    tbshtDx: TTabSheet;
    grpPtInfo: TGroupBox;
    tbshtAdmit: TTabSheet;
    lblPT2: TLabel;
    edtDob: TEdit;
    lblPT5: TLabel;
    cbxEthnic: TComboBox;
    lblPT4: TLabel;
    cbxMarStat: TComboBox;
    grp2: TGroupBox;
    lblDX15: TLabel;
    lblDX16: TLabel;
    lblDX18: TLabel;
    lblDX17: TLabel;
    lblDX19: TLabel;
    lblDX20: TLabel;
    lblDX25: TLabel;
    lblDX21: TLabel;
    lblDX22: TLabel;
    lblDX23: TLabel;
    lblDX26: TLabel;
    lblDX27: TLabel;
    lblDX28: TLabel;
    lblDX24: TLabel;
    lblDX29: TLabel;
    lblDX17a: TLabel;
    cbxASIA: TComboBox;
    lblDX14: TLabel;
    tbshtInterim: TTabSheet;
    edtOnsetDt: TEdit;
    tbshtDC: TTabSheet;
    tbshtCase: TTabSheet;
    tbshtFU: TTabSheet;
    pnlPt: TPanel;
    lblName: TLabel;
    lblSSN: TLabel;
    Help1: TMenuItem;
    About1: TMenuItem;
    lblPT1: TLabel;
    edtPtCode: TEdit;
    lblPT3: TLabel;
    cbxGender: TComboBox;
    pnlHdr1: TPanel;
    BtnGraph: TBitBtn;
    pnlHdr2: TPanel;
    lblPT6: TLabel;
    cbxMilStat: TComboBox;
    tbshtNote: TTabSheet;
    tbshtFinishedPage: TGroupBox;
    mem1: TMemo;
    mem3: TMemo;
    pnlFin1: TPanel;
    lblFin1: TLabel;
    btnVISTA: TBitBtn;
    BtnAddress: TBitBtn;
    lstGender: TListBox;
    lstMstat: TListBox;
    BTNImpGrp: TBitBtn;
    dtpkr9: TDateTimePicker;
    BTNETDiag: TBitBtn;
    BTNDiag1: TBitBtn;
    BTNDiag2: TBitBtn;
    BTNDiag3: TBitBtn;
    BTNDiag4: TBitBtn;
    BTNDiag5: TBitBtn;
    BTNDiag6: TBitBtn;
    BTNDiag7: TBitBtn;
    pnlGraph: TPanel;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image1: TImage;
    lbl7: TLabel;
    lbl6: TLabel;
    lbl5: TLabel;
    lbl4: TLabel;
    lbl3: TLabel;
    lbl2: TLabel;
    lbl1: TLabel;
    lblGR1: TLabel;
    lblGR2: TLabel;
    lblGR3: TLabel;
    lblGR4: TLabel;
    lblGR5: TLabel;
    lblGR6: TLabel;
    lblGR7: TLabel;
    lblGR8: TLabel;
    lblGR9: TLabel;
    lblGR10: TLabel;
    lblGR11: TLabel;
    lblGR12: TLabel;
    lblGR13: TLabel;
    lblGR14: TLabel;
    lblGR15: TLabel;
    lblGR16: TLabel;
    lblGR17: TLabel;
    lblGR18: TLabel;
    BtnG_AD: TButton;
    BtnG_IN: TButton;
    BtnG_DC: TButton;
    BtnG_FU: TButton;
    BtnG_G: TButton;
    pnlDC: TPanel;
    pnlInterim: TPanel;
    pnlAdmit: TPanel;
    pnlFU: TPanel;
    btnGReturn: TBitBtn;
    tbshtGoal: TTabSheet;
    GroupBox49: TGroupBox;
    lblG1: TLabel;
    lblG2: TLabel;
    lblG3: TLabel;
    lblG4: TLabel;
    lblG5: TLabel;
    lblG6: TLabel;
    edtSEC1g: TEdit;
    edtSEC2g: TEdit;
    edtSEC3g: TEdit;
    edtSEC4g: TEdit;
    edtSEC5g: TEdit;
    edtSEC6g: TEdit;
    lblG7: TLabel;
    BtnKeyGoal: TBitBtn;
    GroupBox50: TGroupBox;
    lblG8: TLabel;
    lblG9: TLabel;
    edtSPC1g: TEdit;
    edtSPC2g: TEdit;
    GroupBox51: TGroupBox;
    lblG10: TLabel;
    lblG11: TLabel;
    lblG12: TLabel;
    edtTR1g: TEdit;
    edtTR2g: TEdit;
    edtTR3g: TEdit;
    GroupBox52: TGroupBox;
    lblG13: TLabel;
    lblG14: TLabel;
    edtLOCO1g: TEdit;
    edtLOCO2g: TEdit;
    GroupBox53: TGroupBox;
    GroupBox54: TGroupBox;
    lblG15: TLabel;
    lblG16: TLabel;
    bvl9: TBevel;
    edtCOMM1g: TEdit;
    edtCOMM2g: TEdit;
    GroupBox57: TGroupBox;
    lblG17: TLabel;
    lblG19: TLabel;
    lblG20: TLabel;
    edtSC1g: TEdit;
    edtSC2g: TEdit;
    edtSC3g: TEdit;
    lblG21: TLabel;
    edMotorG: TEdit;
    lblG22: TLabel;
    edCognitiveG: TEdit;
    lblG23: TLabel;
    edTotalG: TEdit;
    pnlImpGrp: TPanel;
    lstImpGrp: TListBox;
    BtnReturn: TBitBtn;
    edtEtDiag: TEdit;
    edtImpGrp: TEdit;
    edtDiag1: TEdit;
    edtDiag3: TEdit;
    edtDiag2: TEdit;
    edtDiag4: TEdit;
    edtDiag5: TEdit;
    edtDiag6: TEdit;
    edtDiag7: TEdit;
    BtnPrint: TBitBtn;
    grpAssess: TGroupBox;
    chkDC: TCheckBox;
    chkAdmit: TCheckBox;
    chkInterim: TCheckBox;
    chkFU: TCheckBox;
    grp10: TGroupBox;
    lblDX1: TLabel;
    lblDX2: TLabel;
    lblDX3: TLabel;
    lblDX4: TLabel;
    dtpkr2: TDateTimePicker;
    chkInterrupt: TCheckBox;
    cbxAdmitClass: TComboBox;
    edtDC: TEdit;
    dtpkr1: TDateTimePicker;
    edtAdmit: TEdit;
    grp36: TGroupBox;
    bvl1: TBevel;
    lblDX8: TLabel;
    lblDX11: TLabel;
    lblDX9: TLabel;
    lblDX12: TLabel;
    lblDX10: TLabel;
    lblDX13: TLabel;
    lblDX5: TLabel;
    bvl3: TBevel;
    bvl2: TBevel;
    lblDX6: TLabel;
    lblDX7: TLabel;
    dtpkr8: TDateTimePicker;
    dtpkr7: TDateTimePicker;
    dtpkr6: TDateTimePicker;
    dtpkr4: TDateTimePicker;
    dtpkr5: TDateTimePicker;
    edtRtDt1: TEdit;
    edTrDt2: TEdit;
    edtRtDt2: TEdit;
    edTrDt3: TEdit;
    edtRtDt3: TEdit;
    dtpkr3: TDateTimePicker;
    edTrDt1: TEdit;
    chkNOMS: TCheckBox;
    grpFacCode: TGroupBox;
    lblPT7: TLabel;
    grpEpisodes: TGroupBox;
    lblPT8: TLabel;
    lblPT9: TLabel;
    lblPT10: TLabel;
    lstEpisodes: TListBox;
    GroupBox27: TGroupBox;
    lblF1: TLabel;
    lblF2: TLabel;
    lblF3: TLabel;
    lblF4: TLabel;
    lblF5: TLabel;
    lblF6: TLabel;
    edtSEC1FU: TEdit;
    edtSEC2FU: TEdit;
    edtSEC3FU: TEdit;
    edtSEC4FU: TEdit;
    edtSEC5FU: TEdit;
    edtSEC6FU: TEdit;
    BtnKeyFU: TBitBtn;
    GroupBox28: TGroupBox;
    lblF8: TLabel;
    lblF9: TLabel;
    edtSPC1FU: TEdit;
    edtSPC2FU: TEdit;
    GroupBox29: TGroupBox;
    lblF10: TLabel;
    lblF11: TLabel;
    lblF12: TLabel;
    edtTR1FU: TEdit;
    edtTR2FU: TEdit;
    edtTR3FU: TEdit;
    GroupBox30: TGroupBox;
    lblF13: TLabel;
    lblF14: TLabel;
    edtLOCO1FU: TEdit;
    edtLOCO2FU: TEdit;
    GroupBox25: TGroupBox;
    lblF15: TLabel;
    lblF16: TLabel;
    bvl7: TBevel;
    edtCOMM1FU: TEdit;
    edtCOMM2FU: TEdit;
    GroupBox26: TGroupBox;
    lblF17: TLabel;
    lblF18: TLabel;
    lblF19: TLabel;
    edtSC1FU: TEdit;
    edtSC2FU: TEdit;
    edtSC3FU: TEdit;
    lblF20: TLabel;
    edMotorFU: TEdit;
    lblF21: TLabel;
    edCognitiveFU: TEdit;
    lblF22: TLabel;
    edTotalFU: TEdit;
    GroupBox6: TGroupBox;
    lblA1: TLabel;
    lblA2: TLabel;
    lblA3: TLabel;
    lblA4: TLabel;
    lblA5: TLabel;
    lblA6: TLabel;
    edtSEC1: TEdit;
    edtSEC2: TEdit;
    edtSEC3: TEdit;
    edtSEC4: TEdit;
    edtSEC5: TEdit;
    edtSEC6: TEdit;
    BtnKeyAdmit: TBitBtn;
    GroupBox7: TGroupBox;
    lblA8: TLabel;
    lblA9: TLabel;
    edtSPC1: TEdit;
    edtSPC2: TEdit;
    GroupBox8: TGroupBox;
    lblA10: TLabel;
    lblA11: TLabel;
    lblA12: TLabel;
    edtTR1: TEdit;
    edtTR2: TEdit;
    edtTR3: TEdit;
    GroupBox9: TGroupBox;
    lblA13: TLabel;
    lblA14: TLabel;
    bvl8: TBevel;
    edtLOCO1: TEdit;
    edtLOCO2: TEdit;
    GroupBox4: TGroupBox;
    lblA15: TLabel;
    lblA16: TLabel;
    bvl4: TBevel;
    edtComm1: TEdit;
    edtComm2: TEdit;
    GroupBox5: TGroupBox;
    lblA17: TLabel;
    lblA18: TLabel;
    lblA19: TLabel;
    edtSC1: TEdit;
    edtSC2: TEdit;
    edtSC3: TEdit;
    lblA20: TLabel;
    edMotorAdmit: TEdit;
    lblA21: TLabel;
    edCognitiveAdmit: TEdit;
    lblA22: TLabel;
    edTotalAdmit: TEdit;
    GroupBox15: TGroupBox;
    lblI1: TLabel;
    lblI2: TLabel;
    lblI3: TLabel;
    lblI4: TLabel;
    lblI5: TLabel;
    lblI6: TLabel;
    edtSEC1i: TEdit;
    edtSEC2i: TEdit;
    edtSEC3i: TEdit;
    edtSEC4i: TEdit;
    edtSEC5i: TEdit;
    edtSEC6i: TEdit;
    BtnKeyInt: TBitBtn;
    GroupBox16: TGroupBox;
    lblI7: TLabel;
    lblI8: TLabel;
    edtSPC1i: TEdit;
    edtSPC2i: TEdit;
    GroupBox17: TGroupBox;
    lblI9: TLabel;
    lblI10: TLabel;
    lblI11: TLabel;
    edtTR1i: TEdit;
    edtTR2i: TEdit;
    edtTR3i: TEdit;
    GroupBox18: TGroupBox;
    lblI12: TLabel;
    lblI13: TLabel;
    edtLOCO1i: TEdit;
    edtLOCO2i: TEdit;
    GroupBox13: TGroupBox;
    lblI14: TLabel;
    lblI15: TLabel;
    bvl5: TBevel;
    edtCOMM1i: TEdit;
    edtCOMM2i: TEdit;
    GroupBox14: TGroupBox;
    lblI16: TLabel;
    lblI17: TLabel;
    lblI18: TLabel;
    edtSC1i: TEdit;
    edtSC2i: TEdit;
    edtSC3i: TEdit;
    lblI19: TLabel;
    edMotorInterim: TEdit;
    lblI20: TLabel;
    edCognitiveInterim: TEdit;
    lblI21: TLabel;
    edTotalInterim: TEdit;
    cbxFacilityCodes: TComboBox;
    pnlG: TPanel;
    GroupBox21: TGroupBox;
    lblDC1: TLabel;
    lblDC2: TLabel;
    lblDC3: TLabel;
    lblDC4: TLabel;
    lblDC5: TLabel;
    lblDC6: TLabel;
    edtSEC1D: TEdit;
    edtSEC2D: TEdit;
    edtSEC3D: TEdit;
    edtSEC4D: TEdit;
    edtSEC5D: TEdit;
    edtSEC6D: TEdit;
    BtnKeyDC: TBitBtn;
    GroupBox22: TGroupBox;
    lblDC8: TLabel;
    lblDC9: TLabel;
    edtSPC1D: TEdit;
    edtSPC2D: TEdit;
    GroupBox23: TGroupBox;
    lblDC10: TLabel;
    lblDC21: TLabel;
    lblDC22: TLabel;
    edtTR1D: TEdit;
    edtTR2D: TEdit;
    edtTR3D: TEdit;
    GroupBox24: TGroupBox;
    lblDC11: TLabel;
    lblDC12: TLabel;
    edtLOCO1D: TEdit;
    edtLOCO2D: TEdit;
    GroupBox20: TGroupBox;
    lblDC15: TLabel;
    lblDC16: TLabel;
    lblDC17: TLabel;
    edtSC1D: TEdit;
    edtSC2D: TEdit;
    edtSC3D: TEdit;
    GroupBox19: TGroupBox;
    lblDC13: TLabel;
    lblDC14: TLabel;
    bvl6: TBevel;
    edtCOMM1D: TEdit;
    edtCOMM2D: TEdit;
    lblDC18: TLabel;
    edMotorDC: TEdit;
    lblDC19: TLabel;
    edCognitiveDC: TEdit;
    lblDC20: TLabel;
    edTotalDC: TEdit;
    lstinvEpisodes: TListBox;
    lstFacilityCodes: TListBox;
    lblA7: TLabel;
    lblI22: TLabel;
    lblDC7: TLabel;
    lblF7: TLabel;
    lblC1: TLabel;
    grpCurrNote: TGroupBox;
    memCurrent: TMemo;
    grpPrevNote: TGroupBox;
    memPrevious: TMemo;
    lstFSODout: TListBox;
    lstinvLBCase: TListBox;
    Edit1: TMenuItem;
    Edit2: TMenuItem;
    Save1: TMenuItem;
    View: TMenuItem;
    PtProgram1: TMenuItem;
    DatesDx1: TMenuItem;
    Admission1: TMenuItem;
    Interim1: TMenuItem;
    Discharge1: TMenuItem;
    FollowUp1: TMenuItem;
    CaseNotes1: TMenuItem;
    Goals1: TMenuItem;
    Finished1: TMenuItem;
    FIMGraph1: TMenuItem;
    cbxG1: TCheckBox;
    cbxG2: TCheckBox;
    cbxG3: TCheckBox;
    GroupBox1: TGroupBox;
    cbxF1: TCheckBox;
    cbxF2: TCheckBox;
    cbxF3: TCheckBox;
    GroupBox3: TGroupBox;
    cbxD1: TCheckBox;
    cbxD2: TCheckBox;
    cbxD3: TCheckBox;
    GroupBox11: TGroupBox;
    cbxI1: TCheckBox;
    cbxI2: TCheckBox;
    cbxI3: TCheckBox;
    GroupBox12: TGroupBox;
    cbxA1: TCheckBox;
    cbxA2: TCheckBox;
    cbxA3: TCheckBox;
    GroupBox31: TGroupBox;
    cbxG4: TCheckBox;
    cbxG5: TCheckBox;
    cbxG6: TCheckBox;
    GroupBox32: TGroupBox;
    cbxG7: TCheckBox;
    cbxG8: TCheckBox;
    cbxG9: TCheckBox;
    GroupBox33: TGroupBox;
    cbxF4: TCheckBox;
    cbxF5: TCheckBox;
    cbxF6: TCheckBox;
    GroupBox37: TGroupBox;
    cbxD4: TCheckBox;
    cbxD5: TCheckBox;
    cbxD6: TCheckBox;
    GroupBox38: TGroupBox;
    cbxI4: TCheckBox;
    cbxI5: TCheckBox;
    cbxI6: TCheckBox;
    GroupBox34: TGroupBox;
    cbxA4: TCheckBox;
    cbxA5: TCheckBox;
    cbxA6: TCheckBox;
    GroupBox40: TGroupBox;
    cbxF7: TCheckBox;
    cbxF8: TCheckBox;
    cbxF9: TCheckBox;
    GroupBox41: TGroupBox;
    cbxD7: TCheckBox;
    cbxD8: TCheckBox;
    cbxD9: TCheckBox;
    GroupBox39: TGroupBox;
    cbxI7: TCheckBox;
    cbxI8: TCheckBox;
    cbxI9: TCheckBox;
    GroupBox35: TGroupBox;
    cbxA7: TCheckBox;
    cbxA8: TCheckBox;
    cbxA9: TCheckBox;
    edtImpGrptxt: TEdit;
    mem2: TMemo;
    Label1: TLabel;
    lstRace: TListBox;
    C1: TMenuItem;
    N3: TMenuItem;
    Timer1: TTimer;
    memmessages: TMemo;
    function FileVersionValue(const AFileName, AValueName: string): string;
    procedure SetTimer(var Msg: TMsg; var Handled: Boolean);
    procedure SetTimer1;
    procedure Timer1Timer(Sender: TObject);
    procedure CheckServerVersion;
    procedure TIU_LockNote;
    procedure TIU_UnLockNote;
    procedure TIU_DeleteNote;
    procedure GetFIMParms;
    procedure ClearComponents(Sender: TObject);
    procedure ClearPatientData;
    procedure SetReadOnly(Sender: TObject);
    procedure DisableCheckBoxes;
    procedure SetReadOnlyOff(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ConnectBroker(Sender: TObject);
    procedure btnVISTAClick(Sender: TObject);
    procedure CallNoteForm;
    procedure DoSignNote(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtnKeyAdmitClick(Sender: TObject);
    procedure ErrorMessage;
    procedure SetState(state: Boolean; WinControl: TWinControl);
    procedure chkInterruptClick(Sender: TObject);
    procedure edtSEC1Exit(Sender: TObject);
    procedure edtSEC1DExit(Sender: TObject);
    procedure edtSEC1iExit(Sender: TObject);
    procedure edtSEC1FUExit(Sender: TObject);
    procedure edtSEC1gExit(Sender: TObject);
    procedure ClearSelected(WinControl: TWinControl);
    procedure CheckScoresPresent(WinControl: TWinControl);
    procedure ResetFim(WinControl: TWinControl);
    procedure FinishedButton1Click(Sender: TObject);
    procedure chkDCClick(Sender: TObject);
    procedure chkAdmitClick(Sender: TObject);
    procedure impDateConvert(Sender: TObject);
              //RMIM*1*3
    procedure edtAdmitExit(Sender: TObject);
    procedure chkInterimClick(Sender: TObject);
    procedure InitializeCoordinates(Kind: integer);
              //where 1 is admit, 2 is interim,
              //3 is discharge, 4 is f/u, and 5 is goal
    procedure FinishGraph;
    procedure eraseallgraphs;
    procedure seta(Value: string);
    procedure setb(Value: string);
    procedure setc(Value: string);
    procedure setd(Value: string);
    procedure sete(Value: string);
    procedure setf(Value: string);
    procedure setg(Value: string);
    procedure seth(Value: string);
    procedure seti(Value: string);
    procedure setj(Value: string);
    procedure setk(Value: string);
    procedure setl(Value: string);
    procedure setm(Value: string);
    procedure setn(Value: string);
    procedure seto(Value: string);
    procedure setp(Value: string);
    procedure setq(Value: string);
    procedure setr(Value: string);
    procedure Errorcheck;
    procedure chkFUClick(Sender: TObject);
    procedure cbxEthnicKeyPress(Sender: TObject; var Key: Char);
    procedure BtnGraphClick(Sender: TObject);
    procedure btnGReturnClick(Sender: TObject);
    procedure BtnG_ADClick(Sender: TObject);
    procedure BtnG_INClick(Sender: TObject);
    procedure BtnG_DCClick(Sender: TObject);
    procedure BtnG_FUClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure pgctrl1Change(Sender: TObject);
    procedure BtnAddressClick(Sender: TObject);
    procedure CheckDFN;
    procedure BTNImpGrpClick(Sender: TObject);
    procedure FormatDate(Sender: TObject);
    procedure dtpkr1Change(Sender: TObject);
    procedure dtpkr2Change(Sender: TObject);
    procedure dtpkr3Change(Sender: TObject);
    procedure dtpkr4Change(Sender: TObject);
    procedure dtpkr5Change(Sender: TObject);
    procedure dtpkr6Change(Sender: TObject);
    procedure dtpkr7Change(Sender: TObject);
    procedure dtpkr8Change(Sender: TObject);
    procedure dtpkr9Change(Sender: TObject);
    procedure FindCPT(Sender: TObject);
    procedure BTNETDiagClick(Sender: TObject);
    procedure BTNDiag1Click(Sender: TObject);
    procedure BTNDiag2Click(Sender: TObject);
    procedure BTNDiag3Click(Sender: TObject);
    procedure BTNDiag4Click(Sender: TObject);
    procedure BTNDiag5Click(Sender: TObject);
    procedure BTNDiag6Click(Sender: TObject);
    procedure BTNDiag7Click(Sender: TObject);
    procedure SetGraphBtn;
    procedure SendEMAIL;
    procedure BtnG_GClick(Sender: TObject);
    procedure BtnReturnClick(Sender: TObject);
    procedure lstImpGrpClick(Sender: TObject);
    procedure SendDatatoFSOD;
    procedure edtPtCodeClick(Sender: TObject);
    procedure GetEpisodes;
    procedure lstEpisodesClick(Sender: TObject);
    procedure PopulateFormData;
    procedure Save1Click(Sender: TObject);
    procedure Edit2Click(Sender: TObject);
    procedure cbxFacilityCodesChange(Sender: TObject);
    procedure cbxFacilityCodesKeyPress(Sender: TObject; var Key: Char);
    procedure SendAddendumNote;
    procedure DatesDx1Click(Sender: TObject);
    procedure PtProgram1Click(Sender: TObject);
    procedure Admission1Click(Sender: TObject);
    procedure Interim1Click(Sender: TObject);
    procedure Discharge1Click(Sender: TObject);
    procedure FollowUp1Click(Sender: TObject);
    procedure CaseNotes1Click(Sender: TObject);
    procedure Goals1Click(Sender: TObject);
    procedure Finished1Click(Sender: TObject);
    procedure FIMGraph1Click(Sender: TObject);
    procedure cbxA1Click(Sender: TObject);
    procedure cbxA2Click(Sender: TObject);
    procedure cbxA3Click(Sender: TObject);
    procedure cbxA4Click(Sender: TObject);
    procedure cbxA5Click(Sender: TObject);
    procedure cbxA6Click(Sender: TObject);
    procedure cbxA7Click(Sender: TObject);
    procedure cbxA8Click(Sender: TObject);
    procedure cbxA9Click(Sender: TObject);
    procedure cbxI1Click(Sender: TObject);
    procedure cbxI2Click(Sender: TObject);
    procedure cbxI3Click(Sender: TObject);
    procedure cbxI4Click(Sender: TObject);
    procedure cbxI5Click(Sender: TObject);
    procedure cbxI6Click(Sender: TObject);
    procedure cbxI7Click(Sender: TObject);
    procedure cbxI8Click(Sender: TObject);
    procedure cbxI9Click(Sender: TObject);
    procedure cbxD1Click(Sender: TObject);
    procedure cbxD2Click(Sender: TObject);
    procedure cbxD3Click(Sender: TObject);
    procedure cbxD4Click(Sender: TObject);
    procedure cbxD5Click(Sender: TObject);
    procedure cbxD6Click(Sender: TObject);
    procedure cbxD7Click(Sender: TObject);
    procedure cbxD8Click(Sender: TObject);
    procedure cbxD9Click(Sender: TObject);
    procedure cbxF1Click(Sender: TObject);
    procedure cbxF2Click(Sender: TObject);
    procedure cbxF3Click(Sender: TObject);
    procedure cbxF4Click(Sender: TObject);
    procedure cbxF5Click(Sender: TObject);
    procedure cbxF6Click(Sender: TObject);
    procedure cbxF7Click(Sender: TObject);
    procedure cbxF8Click(Sender: TObject);
    procedure cbxF9Click(Sender: TObject);
    procedure cbxG1Click(Sender: TObject);
    procedure cbxG2Click(Sender: TObject);
    procedure cbxG3Click(Sender: TObject);
    procedure cbxG4Click(Sender: TObject);
    procedure cbxG5Click(Sender: TObject);
    procedure cbxG6Click(Sender: TObject);
    procedure cbxG7Click(Sender: TObject);
    procedure cbxG8Click(Sender: TObject);
    procedure cbxG9Click(Sender: TObject);
    procedure CopyIndentedText;
    procedure lstImpGrpKeyPress(Sender: TObject; var Key: Char);
    procedure C1Click(Sender: TObject);
    procedure memCurrentChange(Sender: TObject);
    procedure memmessagesChange(Sender: TObject);

  Private
    { Private declarations}
    FVistaMsg: Word;
    procedure DefaultHandler(var Message); override;
  Public
    { Public declarations }
    UserName: string;
    UserDUZ: string;
    PatientSSN: string;
    PatientDFN: string;
    CPRSDFN: string;
    PatientDOB: string;
    PatientAGE: string;
    PatientName: string;
    PatientSex: string;
    PatientMaritalStatus: string;
    PatientRace: string;
    GetVisits: string;
    VisitNo: string;
    VisitDate: string;
    VisitLocation: string;
    VisitType: string;
    NoteStatus: string;
    ConsultTitle: string;
    Consult_IEN: string;
    Consult: string;
    PN_IEN: string;
    TempPN_IEN: string;
    AddPN_IEN: string;
    NewPN_IEN: string;
    Consul_IEN: string;
    PatNoteNum: string;
    SendAddendum: string;
    CheckforDuplicate: string;
    DateTime: string;
    RPCB_Server: string;
    RPCB_Port: string;
    Author: string;
    Author_Num: string;
    Author_NumHold: string;
    AuthorHold: string;
    Cosigner: string;
    ReformatDateTime: string;
    Cosigner_Num: string;
    CosignerHold: string;
    GetAllAuthorsCall: string;
    CreateNote: string;
    UpdateNote: string;
    CreateAddendum: string;
    AddendumText: string;
    RPC_GetAdmits: string;
    GetNowCall: string;
    GetMDate: string;
    GetPatientCall: string;
    GetPatientData: string;
    GetPatientAddress: string;
    GetLocationsCall: string;
    CheckMultiPatients: string;
    LoadConsultsCall: string;
    DMECall: string;
    CreateVisitCall: string;
    FIMParms: string;
    VerifyESign: string;
    GetCosign: string;
    SendEMailCall: string;
    GetUserCall: string;
    SendFormName: string;
    RestrictedRecordCall: string;
    LoadVisitCall: string;
    GetDFNCall: string;
    GetVisitCall: string;
    GetTitleCall: string;
    TerminateFlag: Boolean;
    CurrentUser: string;
    ErrorInput: string;
    FormName: string;
    FormVersion: string;
    SaveFSOD: string;
    GetCases: string;
    GetSelectedCase: string;
    LockPatient: string;
    P_Street: string;
    P_City: string;
    P_State: string;
    P_Zip: string;
    P_Phone: string;
    DiagnosisCk: string;
    PatientActiveDuty: string;
    frmAuthorStatus: string;
    FIMFacilityName: string;
    StationNumber: string;
    FSODNoteTitle: string;
    NonFSODNoteTitle: string;
    FSODConsultTitle: string;
    FSODNoteIEN: string;
    NonFSODNoteIEN: string;
    FSODConsultIEN: string;
    LockTIURecord : string;
    UnlockTIURecord : string;
    DeleteTIURecord : string;
    NoteTitle: string;
    TitleNo: string;
    FSODMailGroup: string;
    MailMsgnum: string;
    DateToday: string;
    FSODkey : string;
    SendFSOD : Boolean;
    RecType : string;
    CaseIEN : string;
    ReadOnly : Boolean;
    Sensitivity : string;
    NoteError : boolean;
    StopFlag : boolean;
    CallType : String;
    Impdate : Integer;
  end;


var
  MainForm: TMainForm;
  CheckVersion: string;
  TempString: string;
  SSNErrorFlag: Boolean;
  X, Y: Integer;
  DateIn, DateOut: string;
//  ParamCount: Integer;

  Ax,Bx,Cx,Dx,Ex,Fx,Gx : integer;
  Hx,Ix,Jx,Kx,Lx,Mx,Nx : integer;
  Ox,Px,Qx,Rx : integer;

  Ay,By,Cy,Dy,Ey,Fy,Gy : integer;
  Hy,Iy,Jy,Ky,Ly,My,Ny : integer;
  Oy,Py,Qy,Ry : integer;

  graph1,graph2,graph3,graph4,graph5: boolean;
  GoodScore : Boolean;
  CkDate : TDate;
  TimeOutNum : Cardinal;
  TimeOutFlag : Boolean;
  StartedfromCPRS : Boolean;
  //508 variables set during form create
   ReaderStateOn, ReaderRunning: longbool;

implementation

uses Note, SignNote, FIMKey, AboutBox,
  frmDemoUnit, frmLookupUnit, Consult, frmTimeOutUnit,
  frmPtChangeUnit, uFIM_Objects;

{$R *.DFM}

procedure TMainForm.DefaultHandler(var Message);
var buf: array[0..255] of Char;
begin
 inherited DefaultHandler(Message);
 // if message is 'VistA Event - Clinical' and not from self
 // wParam=Handle of Message Sender, lparam=entry in global atom table
 with TMessage(Message) do if (Msg = FVistaMsg) and (wParam <> Handle) then
  begin
   // retrieve the text pointed to by lparam into buffer (buf)
   GlobalGetAtomName(lParam,buf,255);
   memmessages.Lines.Add(StrPas(buf));
  end;
end;

function TMainForm.FileVersionValue(const AFileName, AValueName: string): string;
type
  PValBuf = ^TValBuf;
  TValBuf = array[0..255] of Char;
var
  VerSize, ValSize, AHandle: DWORD;
  VerBuf: Pointer;
  ValBuf: PValBuf;
begin
  Result := '';
  VerSize:=GetFileVersionInfoSize(PChar(AFileName), AHandle);
  if VerSize > 0 then
  begin
    GetMem(VerBuf, VerSize);
    try
      GetFileVersionInfo(PChar(AFileName), AHandle, VerSize, VerBuf);
      VerQueryValue(VerBuf, PChar(AValueName), Pointer(ValBuf), ValSize);
      SetString(Result, ValBuf^, ValSize);
    finally
      FreeMem(VerBuf);
    end;
  end;
end;

procedure TMainForm.SetTimer;
begin
 If TimeOutFlag then exit;
 Timer1.Enabled  := false;
 Timer1.Interval := TimeOutNum;
 Timer1.Enabled  := true;
end;

procedure TMainForm.SetTimer1;
begin
 If TimeOutFlag then exit;
 Timer1.Enabled  := false;
 Timer1.Interval := TimeOutNum;
 Timer1.Enabled  := true;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
 Timer1.Enabled := false;
 TimeOutFlag := true;
 If frmTimeOut = nil then
  Application.CreateForm(TfrmTimeOut,frmTimeOut);
 frmTimeOut.ShowModal;
 If frmTimeOut.ModalResult = mrOK then
  begin
   frmTimeOut.Free;
   frmTimeOut := nil;
   Timer1.Enabled := false;
   Timer1.Interval := TimeOutNum;
   Timer1.Enabled := true;
   TimeOutFlag := false;
   exit;
  end;
 Application.Terminate;
end;

procedure TMainForm.CheckServerVersion;
var A : string;
begin
//  FILEVERSION - use for TEST versions  -  data from Project/Options/Version Info/InternalName
 A := Piece(Trim(FileVersionValue(Application.ExeName, FILE_VER_INTERNALNAME)),' ',1);

//  FILEVERSION - use for LIVE versions  -  data from Project/Options/Version Info/FileVersion
 // A := Trim(FileVersionValue(Application.ExeName, FILE_VER_FILEVERSION));
  FIMBroker.Param[0].PType := literal;
  FIMBroker.Param[0].Value := 'RMIMFIM';
  FIMBroker.Param[1].PType := literal;
  FIMBroker.Param[1].Value := A;
  FIMBroker.RemoteProcedure := CheckVersion; {check server version}
  Try
   FIMBroker.Call;
   {check for errors on return}
  except
   on E:EBrokerError do
    begin
     ShowMessage('Broker Error: '+E.Message);
     exit;
    end;
   on E:EAccessViolation do
    begin
     ShowMessage(E.Message);
     exit;
    end;
   else
    raise;
  end;
 A := FIMBroker.Results[0];
 If A = '0' then
  begin
   MessageDlg('FIM GUI/Server Version mismatch. Terminating...',mterror,[mbok],0);
   FIMBroker.Connected := false;
   Application.Terminate;
  end;
end;

procedure TMainForm.TIU_LockNote;
begin
  FIMBroker.Param[0].PType := literal;
  FIMBroker.Param[0].Value := MainForm.TempPN_IEN;
  FIMBroker.RemoteProcedure := MainForm.LockTIURecord; {TIU LOCK RECORD}
  Try
   FIMBroker.Call;
   {check for errors on return}
  except
   on E:EBrokerError do
    begin
     ShowMessage('Broker Error: '+E.Message);
     exit;
    end;
   on E:EAccessViolation do
    begin
     ShowMessage(E.Message);
     exit;
    end;
   else
    begin
     raise;
     exit;
    end;
  end;
end;

procedure TMainForm.TIU_UnlockNote;
begin
 If NewPN_IEN <> '' then
  begin
   FIMBroker.Param[0].PType := literal;
   FIMBroker.Param[0].Value := MainForm.NewPN_IEN;
   FIMBroker.RemoteProcedure := MainForm.UnlockTIURecord; {TIU UNLOCK RECORD}
   Try
    FIMBroker.Call;
    {check for errors on return}
   except
    on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
      ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
   end;
  end;
 If Consul_IEN <> '' then
  begin
   FIMBroker.Param[0].PType := literal;
   FIMBroker.Param[0].Value := MainForm.Consul_IEN;
   FIMBroker.RemoteProcedure := MainForm.UnlockTIURecord; {TIU UNLOCK RECORD}
   Try
    FIMBroker.Call;
    {check for errors on return}
   except
    on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
      ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
   end;
  end;
 If AddPN_IEN <> '' then
  begin
   FIMBroker.Param[0].PType := literal;
   FIMBroker.Param[0].Value := MainForm.AddPN_IEN;
   FIMBroker.RemoteProcedure := MainForm.UnlockTIURecord; {TIU UNLOCK RECORD}
   Try
    FIMBroker.Call;
    {check for errors on return}
   except
    on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
      ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
   end;
  end;
end;

procedure TMainForm.TIU_DeleteNote;
begin
 If NewPN_IEN <> '' then
  begin
   FIMBroker.Param[0].PType := literal;
   FIMBroker.Param[0].Value := MainForm.NewPN_IEN;
   FIMBroker.RemoteProcedure := MainForm.DeleteTIURecord; {TIU DELETE RECORD}
   Try
    FIMBroker.Call;
    {check for errors on return}
   except
    on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
      ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
   end;
  end;
 If Consul_IEN <> '' then
  begin
   FIMBroker.Param[0].PType := literal;
   FIMBroker.Param[0].Value := MainForm.Consul_IEN;
   FIMBroker.RemoteProcedure := MainForm.DeleteTIURecord; {TIU DELETE RECORD}
   Try
    FIMBroker.Call;
    {check for errors on return}
   except
    on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
      ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
   end;
  end;
 If AddPN_IEN <> '' then
  begin
   FIMBroker.Param[0].PType := literal;
   FIMBroker.Param[0].Value := MainForm.AddPN_IEN;
   FIMBroker.RemoteProcedure := MainForm.DeleteTIURecord; {TIU DELETE RECORD}
   Try
    FIMBroker.Call;
    {check for errors on return}
   except
    on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
      ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
   end;
  end;
end;

procedure TMainForm.GetFIMParms;
var x : Integer;
    A : string;
begin
  errorflag := false;
  If not FIMBroker.Connected then
   ConnectBroker(application);
  If not FIMBroker.Connected then
   exit;
  try
   FIMBroker.RemoteProcedure := FIMParms;
   FIMBroker.Call;
  except
   on EBrokerError do
     begin
      ShowMessage('Unable to read your FIM Parameter File - terminating.');
      Application.Terminate;
      errorflag := true;
      exit;
     end;
  end;
  FIMFacilityName  := Piece(FIMBroker.Results[0],'^',1);
  StationNumber    := Piece(FIMBroker.Results[0],'^',2);
  FSODMailGroup    := Piece(FIMBroker.Results[0],'^',3);
  FSODNoteIEN      := Piece(FIMBroker.Results[0],'^',4);
  FSODNoteTitle    := Piece(FIMBroker.Results[0],'^',5);
  NonFSODNoteIEN   := Piece(FIMBroker.Results[0],'^',6);
  NonFSODNoteTitle := Piece(FIMBroker.Results[0],'^',7);
  FSODConsultIEN   := Piece(FIMBroker.Results[0],'^',8);
  FSODConsultTitle := Piece(FIMBroker.Results[0],'^',9);
  FIMAppSpecific.ParamCount       := StrtoInt(Piece(FIMBroker.Results[0],'^',10));
  TimeOutNum       := StrtoIntDef(Piece(FIMBroker.Results[0],'^',11),300);
  TimeOutNum       := TimeOutNum * 1000;
  If FIMAppSpecific.ParamCount > 0 then
   For x := 1 to FIMAppSpecific.ParamCount do
    lstFacilityCodes.Items.Add(
          Piece(FIMBroker.Results[x],'^',2)+'^'+
          Piece(FIMBroker.Results[x],'^',1));
  For x := 0 to lstFacilityCodes.Items.Count-1 do
   begin
     If StrtoInt(Piece(lstFacilityCodes.Items[x],'^',1)) = 1 then
      cbxFacilityCodes.Items.Add(Piece(lstFacilityCodes.Items[x],'^',2)+'-'+
       'Continuum of Care');
     If StrtoInt(Piece(lstFacilityCodes.Items[x],'^',1)) = 2 then
      cbxFacilityCodes.Items.Add(Piece(lstFacilityCodes.Items[x],'^',2)+'-'+
       'Acute Rehab Inpatient Bed Unit');
     If StrtoInt(Piece(lstFacilityCodes.Items[x],'^',1)) = 3 then
      cbxFacilityCodes.Items.Add(Piece(lstFacilityCodes.Items[x],'^',2)+'-'+
       'Subacute Rehab Inpatient Bed Unit');
   end;
  // check for missing titles
    A := '';
    If FSODNoteIEN = '' then
     A := '  '+FSODNoteTitle+#13;
    If NonFSODNoteIEN = '' then
     A := '  '+NonFSODNoteTitle+#13;
    If FSODConsultIEN = '' then
     A := '  '+FSODConsultTitle;
    If A <> '' then
     begin
      MessageDlg('Your system is missing required TIU Note Titles.'+#13+#13+
                 'Please check your system documentation - terminating.',mterror,[mbok],0);
      Application.Terminate;
      errorflag := true;
     end;
end;

procedure TMainForm.ClearComponents(Sender: TObject);
var
  I: Integer;
begin
  SetReadOnlyOff(application);
  for I := 0 to MainForm.ComponentCount - 1 do
  begin
    if MainForm.Components[I] is TListBox then
     begin
      If MainForm.Components[I].Name = 'lstImpGrp' then continue;
      If MainForm.Components[I].Name = 'lstFacilityCodes' then continue;
      If MainForm.Components[I].Name = 'lstMstat' then continue;
      If MainForm.Components[I].Name = 'lstRace' then continue;
      If (MainForm.Components[I].Name = 'lstEpisodes') and (Sender = lstEpisodes) then continue;
      If (MainForm.Components[I].Name = 'lstinvEpisodes') and (Sender = lstEpisodes) then continue;
      TListBox(MainForm.Components[i]).Clear;
     end;
    if MainForm.Components[I] is TComboBox then
     begin
      If (MainForm.Components[I].Name = 'cbxFacilityCodes') and
         (Sender = lstEpisodes) then continue;
      If (MainForm.Components[I].Name = 'cbxGender') and
         (Sender = lstEpisodes) then continue;
      If (MainForm.Components[I].Name = 'cbxGender') and
         (Sender = lstEpisodes) then continue;
      If (MainForm.Components[I].Name = 'cbxEthnic') and
         (Sender = lstEpisodes) then continue;
      If (MainForm.Components[I].Name = 'cbxMilStat') and
         (Sender = lstEpisodes) then continue;
      If (MainForm.Components[I].Name = 'cbxMarStat') and
         (Sender = lstEpisodes) then continue;
       TComboBox(MainForm.Components[i]).Text := '';
     end;
    if MainForm.Components[I] is TMemo then TMemo(MainForm.Components[i]).Clear;
    if MainForm.Components[I] is TEdit then
     begin
      If (MainForm.Components[I].Name = 'edtPtCode') and (Sender = lstEpisodes) then continue;
      If (MainForm.Components[I].Name = 'edtDob') and (Sender = lstEpisodes) then continue;
      TEdit(MainForm.Components[i]).Text := '';
     end;
    if MainForm.Components[I] is TCheckBox then TCheckBox(MainForm.Components[i]).Checked := False;
    if MainForm.Components[I] is TRadioButton then TRadioButton(MainForm.Components[i]).Checked := False;
  end;
 RecType := '';
 CaseIEN  := '';
 PN_IEN  := '';
 TempPN_IEN := '';
 AddPN_IEN := '';
 NewPN_IEN := '';
 Consul_IEN := '';
 MailMsgNum := '';
 Edit1.Visible := false;
 grpPrevNote.Visible := false;
 tbshtAdmit.TabVisible := false;
 tbshtDC.TabVisible := false;
 tbshtInterim.TabVisible := false;
 tbshtNote.TabVisible := false;
 tbshtGoal.TabVisible := false;
 tbshtCase.TabVisible := false;
 tbshtDx.TabVisible := false;
 tbshtFU.TabVisible := false;
 cbxAdmitClass.Text := cbxAdmitClass.Items[1];
 If Sender = New1 then
  begin
   grpPtInfo.Visible := false;
   grpFacCode.Visible := false;
   grpAssess.Visible := false;
  end;
end;

procedure TMainForm.ClearPatientData;
begin
    RecType := '';
    CaseIEN  := '';
    PN_IEN  := '';
    MailMsgNum := '';
    NewPN_IEN  := '';
    AddPN_IEN  := '';
    Consul_IEN := '';
    Consult_IEN  := '';
    TempPN_IEN := '';
    lblName.Caption := 'No Patient Selected';
    lblSSN.Caption := '000-00-0000';
    PatientDFN := '';
    P_Street := '';
    P_City   := '';
    P_State  := '';
    P_Zip    := '';
    P_Phone  := '';
end;

procedure TMainForm.SetReadOnly(Sender: TObject);
var
  I: Integer;
begin
  ReadOnly := true;
  for I := 0 to MainForm.ComponentCount - 1 do
  begin
    if (MainForm.Components[I] is TEdit) and (TEdit(MainForm.Components[I]).Text <> '')
     then TEdit(MainForm.Components[i]).Enabled := false;
    if (MainForm.Components[I] is TComboBox) and
       (TComboBox(MainForm.Components[I]).Text <> '') and
       (MainForm.Components[I].Name <> 'cbxFacilityCodes') then
     TComboBox(MainForm.Components[i]).Enabled := false;
    DisableCheckBoxes;
    if (MainForm.Components[I] is TCheckBox) and
       (TCheckBox(MainForm.Components[I]).Checked)
     then TCheckBox(MainForm.Components[i]).Enabled := false;
  end;
  //allow anyone to change the interim and followup data
  //change requested by Cliff Marshall 1/29/03
  for I := 0 to MainForm.ComponentCount - 1 do
   begin
    if MainForm.Components[I] is TEdit then
     if (MainForm.Components[I].GetParentComponent = GroupBox13) or
        (MainForm.Components[I].GetParentComponent = GroupBox14) or
        (MainForm.Components[I].GetParentComponent = GroupBox15) or
        (MainForm.Components[I].GetParentComponent = GroupBox16) or
        (MainForm.Components[I].GetParentComponent = GroupBox17) or
        (MainForm.Components[I].GetParentComponent = GroupBox18) or
        (MainForm.Components[I].GetParentComponent = GroupBox25) or
        (MainForm.Components[I].GetParentComponent = GroupBox26) or
        (MainForm.Components[I].GetParentComponent = GroupBox27) or
        (MainForm.Components[I].GetParentComponent = GroupBox28) or
        (MainForm.Components[I].GetParentComponent = GroupBox29) or
        (MainForm.Components[I].GetParentComponent = GroupBox30) then
      TEdit(MainForm.Components[i]).Enabled := true;
   end;
  for I := 0 to MainForm.ComponentCount - 1 do
   begin
    if MainForm.Components[I] is TCheckBox then
     if (MainForm.Components[I].GetParentComponent = GroupBox11) or
        (MainForm.Components[I].GetParentComponent = GroupBox38) or
        (MainForm.Components[I].GetParentComponent = GroupBox39) or
        (MainForm.Components[I].GetParentComponent = GroupBox1)  or
        (MainForm.Components[I].GetParentComponent = GroupBox33) or
        (MainForm.Components[I].GetParentComponent = GroupBox40) then
      TCheckBox(MainForm.Components[i]).Enabled := true;
   end;
end;

procedure TMainForm.DisableCheckBoxes;
begin
 if (cbxA1.Checked) or (cbxA2.Checked) or (cbxA3.Checked) then
  begin
   cbxA1.Enabled := false;
   cbxA2.Enabled := false;
   cbxA3.Enabled := false;
  end;
 if (cbxA4.Checked) or (cbxA5.Checked) or (cbxA6.Checked) then
  begin
   cbxA4.Enabled := false;
   cbxA5.Enabled := false;
   cbxA6.Enabled := false;
  end;
 if (cbxA7.Checked) or (cbxA8.Checked) or (cbxA9.Checked) then
  begin
   cbxA7.Enabled := false;
   cbxA8.Enabled := false;
   cbxA9.Enabled := false;
  end;
 if (cbxD1.Checked) or (cbxD2.Checked) or (cbxD3.Checked) then
  begin
   cbxD1.Enabled := false;
   cbxD2.Enabled := false;
   cbxD3.Enabled := false;
  end;
 if (cbxD4.Checked) or (cbxD5.Checked) or (cbxD6.Checked) then
  begin
   cbxD4.Enabled := false;
   cbxD5.Enabled := false;
   cbxD6.Enabled := false;
  end;
 if (cbxD7.Checked) or (cbxD8.Checked) or (cbxD9.Checked) then
  begin
   cbxD7.Enabled := false;
   cbxD8.Enabled := false;
   cbxD9.Enabled := false;
  end;
 if (cbxG1.Checked) or (cbxG2.Checked) or (cbxG3.Checked) then
  begin
   cbxG1.Enabled := false;
   cbxG2.Enabled := false;
   cbxG3.Enabled := false;
  end;
 if (cbxG4.Checked) or (cbxG5.Checked) or (cbxG6.Checked) then
  begin
   cbxG4.Enabled := false;
   cbxG5.Enabled := false;
   cbxG6.Enabled := false;
  end;
 if (cbxG7.Checked) or (cbxG8.Checked) or (cbxG9.Checked) then
  begin
   cbxG7.Enabled := false;
   cbxG8.Enabled := false;
   cbxG9.Enabled := false;
  end;
end;

procedure TMainForm.SetReadOnlyOff(Sender: TObject);
var
  I: Integer;
begin
  ReadOnly := false;
  for I := 0 to MainForm.ComponentCount - 1 do
  begin
    if MainForm.Components[I] is TEdit then TEdit(MainForm.Components[i]).Enabled := true;
    if (MainForm.Components[I] is TComboBox) then
     begin
      if (MainForm.Components[I].Name = 'cbxASIA') then
       TComboBox(MainForm.Components[i]).Enabled := false
      else
       TComboBox(MainForm.Components[i]).Enabled := true;
     end;
    if (MainForm.Components[I] is TCheckBox) then TCheckBox(MainForm.Components[i]).Enabled := true;
  end;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  UseServerList : Boolean;
  Exepath, SLServer, SLPort : string;
  i : integer;
begin
  Exepath := ExtractFilePath(Application.ExeName);
  Application.HelpFile := Exepath+'RMIM.HLP';
  Application.hintpause := 100;
  Screen.Cursor := crHourglass;

//cd 8/5/03 Removed below code with new
 CPRSDFN := '';
 StartedfromCPRS := false;
 If (ParamStr(1) <> '') and (ParamStr(2) <> '') and (ParamStr(3) <> '') then
  begin
   If ParamStr(1) <> '' then
    RPCB_Server := Piece(ParamStr(1),'=',2);
   If ParamStr(2) <> '' then
    RPCB_Port := Piece(ParamStr(2),'=',2);
   If ParamStr(3) <> '' then
    PatientDFN :=  Piece(ParamStr(3),'=',2);
   // set up to receive messages from CPRS
    FVistaMsg := RegisterWindowMessage('VistA Event - Clinical');
    memmessages.Lines.Clear;
    StartedfromCPRS := true;
  end;

  Exepath := ExtractFilePath(Application.ExeName);
  Application.HelpFile := Exepath+'RMIM.HLP';
  Application.hintpause := 100;
  Screen.Cursor := crHourglass;
//

{$I+}
  {set parameters}
    FormName := 'FIM';
    FormVersion := '1.0';
    CPRSDFN := '';
  if FIMAppSpecific.StartedfromCPRS = true then
    begin
      StartedfromCPRS := true;
      PatientDFN := FIMPatient.PatientDFN;
      CPRSDFN := FIMPatient.PatientDFN;
    end;

  UserDUZ := FIMUser.UserDUZ;
  UserName := FIMUser.UserName;
  FSODkey := FIMUser.FSODKey;
  Author := FIMUser.UserName;
  Author_Num := FIMUser.UserDuz;

    CheckMultiPatients :=   'DG CHK BS5 XREF Y/N';
    LoadConsultsCall :=     'ORQQCN LIST';
    LoadConsultsCall :=     'RMIM CONSULT LIST';

    GetVisits :=            'ORWCV VST';
//added to get admissions
    RPC_GetAdmits :=        'ORWPT ADMITLST';
    DiagnosisCk :=          'ORWPCE LEX';
    GetNowCall :=           'ORWU DT';
    GetMDate :=             'ORWD DT';
    CreateNote :=           'TIU CREATE RECORD';
    UpdateNote :=           'TIU UPDATE RECORD';
    CreateAddendum :=       'TIU CREATE ADDENDUM RECORD';
    AddendumText :=         'TIU SET DOCUMENT TEXT';
    GetCosign :=            'TIU REQUIRES COSIGNATURE';
    VerifyESign :=          'TIU SIGN RECORD';
    LockTIURecord :=        'TIU LOCK RECORD';
    UnlockTIURecord :=      'TIU UNLOCK RECORD';
    DeleteTIURecord :=      'TIU DELETE RECORD';

    GetPatientCall :=       'RMIM PATIENT LOOKUP';
    GetPatientData :=       'RMIM PATIENT INFO';
    GetAllAuthorsCall :=    'RMIM AUTHOR LOOKUP';
    RestrictedRecordCall := 'RMIM RESTRICTED RECORD';
    GetLocationsCall :=     'RMIM LOCATION LOOKUP';

    GetDFNCall :=           'RMIM GET DFN';
    SendFormName :=         'RMIM GET FORM';
    SendEMailCall :=        'RMIM SEND EMAIL';
    ReformatDateTime :=     'RMIM CONVERT DATE';
    GetUserCall :=          'RMIM GET USER INFO';
    FIMParms :=             'RMIM FIM PARAMETER';
    DMECall :=              'RMIM GET PATIENT DME';
    SaveFSOD :=             'RMIM SAVE FSOD';
    GetCases :=             'RMIM GET CASES';
    GetSelectedCase :=      'RMIM GET SELECTED CASE';
    CheckVersion :=         'RMIM VERSION';
    LockPatient :=          'RMIM LOCK PATIENT';
    CheckforDuplicate :=    'RMIM CHECK DUPLICATE';

//  ConnectBroker(application);
//  If not FIMBroker.Connected then exit;
//  CheckServerVersion;
//  If not FIMBroker.Connected then exit;
  Edit1.Visible := false;
  grpPrevNote.Visible := false;
  tbshtAdmit.TabVisible := false;
  tbshtDC.TabVisible := false;
  tbshtInterim.TabVisible := false;
  tbshtFU.TabVisible := false;
  dtpkr1.Date := Now;
  dtpkr2.Date := Now;
  dtpkr3.Date := Now;
  dtpkr4.Date := Now;
  dtpkr5.Date := Now;
  dtpkr6.Date := Now;
  dtpkr7.Date := Now;
  dtpkr8.Date := Now;
  dtpkr9.Date := Now;
  DateToday := DatetoStr(Now);
  DateToday := Piece(DateToday,'/',1)+'/'+Piece(DateToday,'/',2)+'/'+'20'+Piece(DateToday,'/',3);
  pnlGraph.SendToBack;
  pnlPt1.BringToFront;
  pnlImpGrp.SendToBack;
  pnlImpGrp.Left := 80;
  pnlImpGrp.Top := 55;
  pgctrl1.BringToFront;
  pgctrl1.ActivePage := tbshtPt;
  frmpatient := Tfrmpatient.Create(Application);
  frmDemo := TfrmDemo.Create(Application);
  frmNote := TfrmNote.Create(Application);
  GetFIMParms;
  If errorflag then exit;
  MainForm.Show;
  Screen.Cursor := crDefault;
  MainForm.Refresh;
  SetTimer1;
  NEW1CLICK(application);
  If StartedfromCPRS then
   New1.Enabled := false;

  //set all the graphs to blank;
  graph1:=false;
  graph2:=false;
  graph3:=false;
  graph4:=false;
  graph5:=false;
end;

procedure TMainForm.New1Click(Sender: TObject);
var
  x : Integer;
  A : string[1];
begin
  SetTimer1;
  pnlPt1.BringToFront;
  pgctrl1.ActivePage := tbshtPt;
  If PatientDFN <> '' then
   begin
     {unlock patient - only 1 new episode can be in progress at a time}
      FIMBroker.Param[0].PType := literal;
      FIMBroker.Param[0].Value := PatientDFN;
      FIMBroker.RemoteProcedure := LockPatient;
    Try
     FIMBroker.Call;
      {check for errors on return}
    except
     on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
      ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
    end;
    If Piece(FIMBroker.Results[0],'^',1) = '-1' then
     MessageDlg('Unable to unlock the patient'' record.',mterror,[mbok],0);
   end;
  ClearComponents(New1);
  ClearPatientData;
  eraseallgraphs;
  grpPtInfo.Visible := false;
  grpFacCode.Visible := false;
  grpAssess.Visible := false;
  PatientRace := '';
  PatientMaritalStatus := '';
  grpPrevNote.Visible := false;
  if not FIMBroker.Connected then ConnectBroker(application);
  if not FIMBroker.Connected then exit;

  frmPatient.PatientWildCardEdit.text := '';
  frmPatient.fmListBoxPatients.clear;
  frmPatient.GroupBox1.visible := false;
  frmpatient.status := '';

// called form CPRS tools menu
  If StartedfromCPRS then
   begin
    If CPRSDFN <> '' then
     begin
      PatientDFN := CPRSDFN;
      CPRSDFN := '';
     end
    else
     PatientDFN :=  Piece(ParamStr(3),'=',2);
    FIMBroker.Param[0].PType := literal;
    FIMBroker.Param[0].Value := '`'+PatientDFN;
    FIMBroker.RemoteProcedure := MainForm.GetPatientCall;
    Try
    FIMBroker.Call;
     {check for errors on return}
    except
     on E:EBrokerError do
      begin
       ShowMessage('Broker Error: '+E.Message);
       exit;
      end;
     on E:EAccessViolation do
      begin
       ShowMessage(E.Message);
       exit;
      end;
     else
      begin
      raise;
      exit;
     end;
    end;
    frmPatient.InvisiblefmListBoxPatients.Items.Clear;
    frmPatient.fmListBoxPatients.Items.Clear;
    frmPatient.InvisiblefmListBoxPatients.Items := FIMBroker.Results;
    if frmPatient.InvisiblefmListBoxPatients.items.count = 0 then
     frmPatient.fmListBoxPatients.items.add('    NO PATIENT(S) FOUND');
    for x :=0 to (frmPatient.InvisiblefmListBoxPatients.items.count-1) do
     begin
      frmPatient.fmListBoxPatients.items.add(Piece(frmPatient.InvisiblefmListBoxPatients.items[x],'^',4) +
       '          ' + Piece(frmPatient.InvisiblefmListBoxPatients.items[x],'^',2));
     end;
    frmPatient.fmListBoxPatients.ItemIndex := 0;
    frmPatient.btnOKpatClick(New1);
   end
  else
   // stand alone form
   begin
    frmpatient.showmodal;
    if frmpatient.status = 'Cancel' then exit;
   end;
  //------------------------------


  // delete when finished testing
{    If Form1 = nil then Application.CreateForm(TForm1,Form1);
     Form1.ShowModal;
    Form1.Free;
    Form1 := nil;     }

  // -----------------------------

  if FSODkey = '0' then
   begin
    grpAssess.Visible := true;
    tbshtNote.TabVisible := true;
    tbshtGoal.TabVisible := true;
    tbshtCase.TabVisible := true;
    tbshtDx.TabVisible   := true;
   end;
  if (FSODkey = '1') or (FSODkey = '2') then
   begin
    If messageDlg('Do you wish to send your data to FSOD?',
                mtconfirmation,[mbYes,mbNo],0) = mryes then
     begin
      SendFSOD := true;
      grpFacCode.Visible := true;
      try
       cbxFacilityCodes.SetFocus;
      except
      end;
     end
    else
     begin
      SendFSOD := false;
      grpAssess.Visible    := true;
      tbshtNote.TabVisible := true;
      tbshtGoal.TabVisible := true;
      tbshtCase.TabVisible := true;
      tbshtDx.TabVisible   := true;
      // Changed date captions to Therapy when non-FSOD (RMIM*1*3)
      lblDX1.Caption := 'Therapy Start Date';
      lblDX3.Caption := 'Therapy End Date';
     end;
   end;

  lblName.Caption := PatientName;
  edtPtCode.text := PatientSSN;
  edtDob.Color := clWindow;
  A := PatientDOB;
  If A = '0' then
   FIMPatient.PatientDOB := Copy(FIMPatient.PatientDOB,2,Length(FIMPatient.PatientDOB));
  edtDob.Text := PatientDOB;
  If edtDob.Text <> '*SENSITIVE*' then
  begin
    edtAdmitExit(edtDob);
    // added by RMIM*1*3:
    impDateConvert(edtDob);
  end;
  if (patientsex = 'MALE')   or (patientsex = 'M') then
   cbxGender.ItemIndex := 0;
  if (patientsex = 'FEMALE') or (patientsex = 'F') then
   cbxGender.ItemIndex := 1;
  If cbxGender.ItemIndex <> -1 then
   cbxGender.Text := cbxGender.Items[cbxGender.ItemIndex];

  if PatientMaritalStatus <> '' then
   begin
    for x := 0 to lstMstat.Items.Count -1 do
     If PatientMaritalStatus = Piece(lstMstat.Items[x],'^',1) then
      cbxMarStat.ItemIndex := StrtoInt(Piece(lstMstat.Items[x],'^',2));
     If cbxMarStat.ItemIndex <> -1 then
      cbxMarStat.Text := cbxMarStat.Items[cbxMarStat.ItemIndex];
    if PatientMaritalStatus = 'UNKNOWN' then
      cbxMarStat.ItemIndex := -1;
   end;

  if PatientRace <> '' then
   begin
    for x := 0 to lstRace.Items.Count -1 do
     If PatientRace = Piece(lstRace.Items[x],'^',1) then
      cbxEthnic.ItemIndex := StrtoInt(Piece(lstRace.Items[x],'^',2));
     If cbxEthnic.ItemIndex <> -1 then
      cbxEthnic.Text := cbxEthnic.Items[cbxEthnic.ItemIndex];
   end;
  if PatientActiveDuty = 'ACTIVE DUTY' then
   cbxMilStat.ItemIndex := 0
  else
   cbxMilStat.ItemIndex := 1;
  If cbxMilStat.ItemIndex <> -1 then
   cbxMilStat.Text := cbxMilStat.Items[cbxMilStat.ItemIndex];

  grpPtInfo.Visible := true;
  MainForm.Refresh;
  cbxGender.SetFocus;
  If ((FSODkey = '1') or (FSODkey = '2')) and (grpFacCode.Visible) then
   begin
    If cbxFacilityCodes.Items.Count = 1 then
     begin
     cbxFacilityCodes.ItemIndex := 0;
     cbxFacilityCodesChange(application);
     end
    else
     begin
      cbxFacilityCodes.ItemIndex := -1;
      Try
       cbxFacilityCodes.SetFocus;
      except
      end;
      cbxFacilityCodes.DroppedDown := true;
     end;
   end;
end;

procedure TMainForm.ConnectBroker(Sender: TObject);
var
  x: Integer;
begin
  If (RPCB_Server = '') or (RPCB_Port = '') then
  If GetServerInfo(RPCB_Server, RPCB_Port) = mrCancel then
   begin
    Application.Terminate;
    exit;
   end;
  try
   FIMBroker.Server := RPCB_Server;
   FIMBroker.ListenerPort := StrToInt(RPCB_Port);
   FIMBroker.Connected := True;
  except
   on EBrokerError do
     begin
      ShowMessage('Connection to server could not be established!');
      Application.Terminate;
      exit;
     end;
  end;
  if FIMBroker.Connected = true then
   begin
    Try
     FIMBroker.CreateContext('RMIMFIM');
    except
     on EBrokerError do
     begin
      MessageDlg('You are Not Authorized to use this form.' + chr(13) + chr(13) +
        'If you need access to this form, contact your ADPAC', mtError, [mbOK], 0);
      FIMBroker.Connected := false;
      Application.Terminate;
      exit;
     end;
    end;
    FIMBroker.RemoteProcedure := GetUserCall;
    Try
     FIMBroker.Call;
     {check for errors on return}
    except
     on E:EBrokerError do
      begin
       ShowMessage('Broker Error: '+E.Message);
       exit;
      end;
     on E:EAccessViolation do
      begin
       ShowMessage(E.Message);
       exit;
      end;
     else
      begin
       raise;
       exit;
      end;
    end;
    UserDUZ  := Piece(FIMBroker.Results[0], '^', 1);
    UserName := Piece(FIMBroker.Results[0], '^', 2);
    FSODKey  := Piece(FIMBroker.Results[0], '^', 3);
    Author := UserName;
    Author_Num := UserDuz;
    //x := StrToInt(UserDUZ);
    x := StrToInt64(UserDUZ);
    if x = 0 then
    begin
      MessageDlg('Error Detected during logon (DUZ = 0).' + chr(13) + 'You will have to start over.', mtError, [mbOK], 0);
      if FIMBroker.Connected = true then FIMBroker.Connected := false;
      Application.Terminate;
      exit;
    end;
//   Send the Form Name to Vista for Error checking
    FIMBroker.RemoteProcedure := SendFormName;
    FIMBroker.Param[0].PType := Literal;
    FIMBroker.Param[0].Value := 'FIM';
    Try
     FIMBroker.Call;
     {check for errors on return}
    except
     on E:EBrokerError do
      begin
       ShowMessage('Broker Error: '+E.Message);
       exit;
      end;
     on E:EAccessViolation do
      begin
       ShowMessage(E.Message);
       exit;
      end;
     else
      begin
       raise;
       exit;
      end;
    end;
  end;
end;

procedure TMainForm.btnVISTAClick(Sender: TObject);
begin
 SetTimer1;
 If mem1.lines.count = 0 then
  begin
   MessageDlg('No text in note.', mtError, [mbOK], 0);
   tbshtFinishedPage.SendtoBack;
   pnlPt1.BringToFront;
   exit;
  end;
 mem1.SelectAll;
 mem1.CopyToClipboard;
 If frmConsult = nil then
  Application.CreateForm(TfrmConsult,frmConsult);
  If frmConsult.fmListBoxPatNotes.Items.Count > 0 then
   begin
    If (messageDlg('Do you wish to complete a Consult with this note?',
               mtconfirmation,[mbNo,mbYes],0) = mryes) then
     frmConsult.Showmodal;
   end;
 frmConsult.Free;
 frmConsult := nil;
 If PN_IEN = '' then
   CallType := 'New Note';
 If PN_IEN <> '' then
   CallType := 'Addendum';
 CallNoteForm;
end;

procedure TMainForm.CallNoteForm;
begin
  SSNErrorFlag := false;
  if not FIMBroker.Connected then ConnectBroker(application);
  if FIMBroker.Connected then
   begin
   // setup Note Title
    If Consult_IEN <> '' then
     begin
      NoteTitle := MainForm.FSODConsultTitle;
      TitleNo := Mainform.FSODConsultIEN;
     end;
    If (Consult_IEN = '') and (MainForm.grpFacCode.Visible) then
     begin
      NoteTitle := MainForm.FSODNoteTitle;
      TitleNo := Mainform.FSODNoteIEN;
     end;
    If (Consult_IEN = '') and (MainForm.grpFacCode.Visible = false) then
     begin
      NoteTitle := MainForm.NonFSODNoteTitle;
      TitleNo := Mainform.NonFSODNoteIEN;
     end;
    If (Consult_IEN <> '') or (CallType = 'New Note') then
     begin
      If frmNote = nil then
       Application.CreateForm(Tfrmnote,frmNote);
      frmNote.Showmodal;
     end;
    If CallType = 'Addendum' then
     SendAddendumNote;
    If NoteStatus = 'Cancel' then exit;
    If NoteStatus = 'OK' then DoSignNote(application);
    If NoteStatus <> 'Cancel' then
     begin
      If SendFSOD = true then
       SendEmail;
      If ((FSODkey = '1') or (FSODkey = '2')) and (SendFSOD) then
       SendDatatoFSOD;
     end;
    NoteStatus := '';
   end;
  If StartedfromCPRS then
   begin
    // shut down the form
     Application.Terminate;
     exit;
   end;
  Screen.cursor := crHourglass;
  ClearComponents(New1);
  ClearPatientData;
  tbshtFinishedPage.sendtoback;
  pnlPt1.BringToFront;
  pgctrl1.ActivePage := tbshtPt;
  Screen.cursor := crDefault;
  If not StartedfromCPRS then
   begin
    If MessageDlg('Would you like to select another patient?',mtconfirmation,[mbyes,mbno],0) = mryes then
     New1Click(application)
    else
     Application.Terminate;
   end;
end;

procedure TMainForm.DoSignNote(Sender: TObject);
begin
  if frmSign = nil then frmSign := TfrmSign.Create(Application);
  frmSign.PtName.caption := PatientName;
  if MainForm.NoteTitle <> '' then
  begin
    frmSign.NoteTitle.caption := MainForm.NoteTitle;
    frmSign.NoteTitle.visible := true;
    frmSign.Label2.Visible := true;
  end else
  begin
    frmSign.NoteTitle.visible := false;
    frmSign.Label2.Visible := false;
  end;
  frmSign.Author.caption := Author;
  if Cosigner <> '' then
  begin
    frmSign.Cosigner.caption := Cosigner;
    Cosigner := '';
    frmSign.Cosigner.visible := true;
    frmSign.Label5.Visible := true;
  end;
  frmSign.showmodal;
  frmSign.free;
  frmSign := nil;
  Screen.cursor := crArrow;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  reply: Integer;
begin
  reply := MessageDlg('Are you sure you want to exit?', mtWarning, [mbYes, mbNo], 0);
  if reply = mrNo then Action := caNone;
end;

procedure TMainForm.BtnKeyAdmitClick(Sender: TObject);
begin
  If frmkey = nil then
   Application.createform(Tfrmkey, frmkey);
  frmkey.show;
end;

procedure TMainForm.ErrorMessage;
begin
  MessageDlg(ErrorInput + ' is not a valid input.  Please reenter.', mtError, [mbOK], 0);
end;

procedure TMainForm.chkInterruptClick(Sender: TObject);
begin
  if not chkInterrupt.checked then clearselected(grp36);
  grp36.visible := chkInterrupt.checked;
end;

procedure TMainForm.edtSEC1Exit(Sender: TObject);
var
  i, x, y: real;
  a: string;
begin
 SetTimer1;
  x := 0;  y := 0;
  with sender as TEdit do
  try
    a := Tedit(sender).text;
    if a <> '' then
    begin
       i := strtofloat(a);
       if (i < 1) or (i > 7) then
       begin
         showmessage('Enter a value from 1 to 7.  If you need help, press the Scoring Key button below.');
         tedit(sender).text := '';
         tedit(sender).setfocus;
       end
       else
       begin
        try
         if sender = edtSEC1  then edtSEC2.SetFocus;
         if sender = edtSEC2  then edtSEC3.SetFocus;
         if sender = edtSEC3  then edtSEC4.SetFocus;
         if sender = edtSEC4  then edtSEC5.SetFocus;
         if sender = edtSEC5  then edtSEC6.SetFocus;
         if sender = edtSEC6  then edtSPC1.SetFocus;
         if sender = edtSPC1  then edtSPC2.SetFocus;
         if sender = edtSPC2  then edtTR1.SetFocus;
         if sender = edtTR1   then edtTR2.SetFocus;
         if sender = edtTR2   then edtTR3.SetFocus;
         if sender = edtTR3   then edtLOCO1.SetFocus;
         if sender = edtLOCO1 then cbxA1.SetFocus;
         if sender = edtLOCO2 then edtCOMM1.SetFocus;
         if sender = edtCOMM1 then cbxA4.SetFocus;
         if sender = edtCOMM2 then cbxA7.SetFocus;
         if sender = edtSC1   then edtSC2.SetFocus;
         if sender = edtSC2   then edtSC3.SetFocus;
         if sender = edtSC3   then edtSEC1.SetFocus;
       except
       end;
    end;
       // make sure all fields have data
     If (edtSEC1.Text = '')  or (edtsec2.Text = '')  or (edtsec3.Text = '')  or
        (edtsec4.Text = '')  or (edtsec5.Text = '')  or (edtsec6.Text = '')  or
        (edtspc1.Text = '')  or (edtspc2.Text = '')  or (edttr1.Text = '')   or
        (edttr2.Text = '')   or (edttr3.Text = '')   or (edtloco1.Text = '') or
        (edtloco2.Text = '') or (edtcomm1.Text = '') or (edtcomm2.Text = '') or
        (edtsc1.Text = '')   or (edtsc2.Text = '')   or (edtsc3.Text = '') then
      exit;
       //calculate the scores
       x := x + (strtofloat(edtSEC1.text));
       x := x + (strtofloat(edtsec2.text));
       x := x  + (strtofloat(edtsec3.text));
       x := x + (strtofloat(edtsec4.text));
       x := x + (strtofloat(edtsec5.text));
       x := x + (strtofloat(edtsec6.text));
       x := x + (strtofloat(edtspc1.text));
       x := x + (strtofloat(edtspc2.text));
       x := x + (strtofloat(edttr1.text));
       x := x + (strtofloat(edttr2.text));
       x := x + (strtofloat(edttr3.text));
       x := x + (strtofloat(edtloco1.text));
       x := x + (strtofloat(edtloco2.text));
      edMotorAdmit.text := floattostr(x);
       y := y + (strtofloat(edtcomm1.text));
       y := y + (strtofloat(edtcomm2.text));
       y := y + (strtofloat(edtsc1.text));
       y := y + (strtofloat(edtsc2.text));
       y := y + (strtofloat(edtsc3.text));
      edCognitiveAdmit.text := floattostr(y);
      edTotalAdmit.text := floattostr(x + y);
    end;
  except
    on EConvertError do
    begin
      If (a = '') or (a = ' ') then
       begin
        edMotorAdmit.text := '';
        edCognitiveAdmit.text := '';
        edTotalAdmit.text := '';
        exit;
       end;
      showmessage('Enter a valid number');
      Tedit(sender).setfocus;
    end;
  end;
end;

procedure TMainForm.edtSEC1DExit(Sender: TObject);
var
  i, x, y: real;
  a: string;
begin
 SetTimer1;
  x := 0; y := 0;
  with sender as TEdit do
  try
    a := Tedit(sender).text;
    if a <> '' then
    begin
       i := strtofloat(a);
       if (i < 1) or (i > 7) then
       begin
         showmessage('Enter a value from 1 to 7.  If you need help, press the Scoring Key button below.');
         tedit(sender).text := '';
         tedit(sender).setfocus;
       end
       else
       begin
        try
         if sender = edtSEC1D  then edtSEC2D.SetFocus;
         if sender = edtSEC2D  then edtSEC3D.SetFocus;
         if sender = edtSEC3D  then edtSEC4D.SetFocus;
         if sender = edtSEC4D  then edtSEC5D.SetFocus;
         if sender = edtSEC5D  then edtSEC6D.SetFocus;
         if sender = edtSEC6D  then edtSPC1D.SetFocus;
         if sender = edtSPC1D  then edtSPC2D.SetFocus;
         if sender = edtSPC2D  then edtTR1D.SetFocus;
         if sender = edtTR1D   then edtTR2D.SetFocus;
         if sender = edtTR2D   then edtTR3D.SetFocus;
         if sender = edtTR3D   then edtLOCO1D.SetFocus;
         if sender = edtLOCO1D then cbxD1.SetFocus;
         if sender = edtLOCO2D then edtCOMM1D.SetFocus;
         if sender = edtCOMM1D then cbxD4.SetFocus;
         if sender = edtCOMM2D then cbxD7.SetFocus;
         if sender = edtSC1D   then edtSC2D.SetFocus;
         if sender = edtSC2D   then edtSC3D.SetFocus;
         if sender = edtSC3D   then edtSEC1D.SetFocus;
        except
        end;
       end;
       // make sure all fields have data
     If (edtsec1d.Text = '')  or (edtsec2d.Text = '')  or (edtsec3d.Text = '')  or
        (edtsec4d.Text = '')  or (edtsec5d.Text = '')  or (edtsec6d.Text = '')  or
        (edtspc1d.Text = '')  or (edtspc2d.Text = '')  or (edttr1d.Text = '')   or
        (edttr2d.Text = '')   or (edttr3d.Text = '')   or (edtloco1d.Text = '') or
        (edtloco2d.Text = '') or (edtcomm1d.Text = '') or (edtcomm2d.Text = '') or
        (edtsc1d.Text = '')   or (edtsc2d.Text = '')   or (edtsc3d.Text = '') then
      exit;
       //calculate the scores
       x := x + (strtofloat(edtsec1d.text));
       x := x + (strtofloat(edtsec2d.text));
       x := x  + (strtofloat(edtsec3d.text));
       x := x + (strtofloat(edtsec4d.text));
       x := x + (strtofloat(edtsec5d.text));
       x := x + (strtofloat(edtsec6d.text));
       x := x + (strtofloat(edtspc1d.text));
       x := x + (strtofloat(edtspc2d.text));
       x := x + (strtofloat(edttr1d.text));
       x := x + (strtofloat(edttr2d.text));
       x := x + (strtofloat(edttr3d.text));
       x := x + (strtofloat(edtloco1d.text));
       x := x + (strtofloat(edtloco2d.text));
      edMotorDC.text := floattostr(x);
       y := y + (strtofloat(edtcomm1d.text));
       y := y + (strtofloat(edtcomm2d.text));
       y := y + (strtofloat(edtsc1d.text));
       y := y + (strtofloat(edtsc2d.text));
       y := y + (strtofloat(edtsc3d.text));
      edCognitiveDC.text := floattostr(y);
      edTotalDC.text := floattostr(x + y);
    end;
  except
    on EConvertError do
    begin
      If (a = '') or (a = ' ') then
       begin
        edMotorDC.text := '';
        edCognitiveDC.text := '';
        edTotalDC.text := '';
        exit;
       end;
      showmessage('Enter a valid number');
      Tedit(sender).setfocus;
    end;
  end;
end;

procedure TMainForm.edtSEC1iExit(Sender: TObject);
var
  i, x, y: real;
  a: string;
begin
 SetTimer1;
  x := 0; y := 0;
  with sender as TEdit do
  try
    a := Tedit(sender).text;
    if a <> '' then
    begin
       i := strtofloat(a);
       if (i < 1) or (i > 7) then
       begin
         showmessage('Enter a value from 1 to 7.  If you need help, press the Scoring Key button below.');
         tedit(sender).text := '';
         tedit(sender).setfocus;
       end
       else
       begin
        try
         if sender = edtSEC1i  then edtSEC2i.SetFocus;
         if sender = edtSEC2i  then edtSEC3i.SetFocus;
         if sender = edtSEC3i  then edtSEC4i.SetFocus;
         if sender = edtSEC4i  then edtSEC5i.SetFocus;
         if sender = edtSEC5i  then edtSEC6i.SetFocus;
         if sender = edtSEC6i  then edtSPC1i.SetFocus;
         if sender = edtSPC1i  then edtSPC2i.SetFocus;
         if sender = edtSPC2i  then edtTR1i.SetFocus;
         if sender = edtTR1i   then edtTR2i.SetFocus;
         if sender = edtTR2i   then edtTR3i.SetFocus;
         if sender = edtTR3i   then edtLOCO1i.SetFocus;
         if sender = edtLOCO1i then cbxI1.SetFocus;
         if sender = edtLOCO2i then edtCOMM1i.SetFocus;
         if sender = edtCOMM1i then cbxI4.SetFocus;
         if sender = edtCOMM2i then cbxI7.SetFocus;
         if sender = edtSC1i   then edtSC2i.SetFocus;
         if sender = edtSC2i   then edtSC3i.SetFocus;
         if sender = edtSC3i   then edtSEC1i.SetFocus;
        except
        end;
       end;
       // make sure all fields have data
     If (edtsec1i.Text = '')  or (edtsec2i.Text = '')  or (edtsec3i.Text = '')  or
        (edtsec4i.Text = '')  or (edtsec5i.Text = '')  or (edtsec6i.Text = '')  or
        (edtspc1i.Text = '')  or (edtspc2i.Text = '')  or (edttr1i.Text = '')   or
        (edttr2i.Text = '')   or (edttr3i.Text = '')   or (edtloco1i.Text = '') or
        (edtloco2i.Text = '') or (edtcomm1i.Text = '') or (edtcomm2i.Text = '') or
        (edtsc1i.Text = '')   or (edtsc2i.Text = '')   or (edtsc3i.Text = '') then
      exit;
      //calculate the scores
       x := x + (strtofloat(edtsec1i.text));
       x := x + (strtofloat(edtsec2i.text));
       x := x + (strtofloat(edtsec3i.text));
       x := x + (strtofloat(edtsec4i.text));
       x := x + (strtofloat(edtsec5i.text));
       x := x + (strtofloat(edtsec6i.text));
       x := x + (strtofloat(edtspc1i.text));
       x := x + (strtofloat(edtspc2i.text));
       x := x + (strtofloat(edttr1i.text));
       x := x + (strtofloat(edttr2i.text));
       x := x + (strtofloat(edttr3i.text));
       x := x + (strtofloat(edtloco1i.text));
       x := x + (strtofloat(edtloco2i.text));
      edMotorInterim.text := floattostr(x);
       y := y + (strtofloat(edtcomm1i.text));
       y := y + (strtofloat(edtcomm2i.text));
       y := y + (strtofloat(edtsc1i.text));
       y := y + (strtofloat(edtsc2i.text));
       y := y + (strtofloat(edtsc3i.text));
      edCognitiveInterim.text := floattostr(y);
      edTotalInterim.text := floattostr(x + y);
    end;
  except
    on EConvertError do
    begin
      If (a = '') or (a = ' ') then
       begin
        edMotorInterim.text := '';
        edCognitiveInterim.text := '';
        edTotalInterim.text := '';
        exit;
       end;
      showmessage('Enter a valid number');
      Tedit(sender).setfocus;
    end;
  end;
end;

procedure TMainForm.edtSEC1FUExit(Sender: TObject);
var
  i, x, y: real;
  a: string;
begin
 SetTimer1;
  x := 0; y := 0;
  with sender as TEdit do
  try
    a := Tedit(sender).text;
    if a <> '' then
    begin
       i := strtofloat(a);
       if (i < 1) or (i > 7) then
       begin
         showmessage('Enter a value from 1 to 7.  If you need help, press the Scoring Key button below.');
         tedit(sender).text := '';
         tedit(sender).setfocus;
       end
       else
       begin
        try
         if sender = edtSEC1FU  then edtSEC2FU.SetFocus;
         if sender = edtSEC2FU  then edtSEC3FU.SetFocus;
         if sender = edtSEC3FU  then edtSEC4FU.SetFocus;
         if sender = edtSEC4FU  then edtSEC5FU.SetFocus;
         if sender = edtSEC5FU  then edtSEC6FU.SetFocus;
         if sender = edtSEC6FU  then edtSPC1FU.SetFocus;
         if sender = edtSPC1FU  then edtSPC2FU.SetFocus;
         if sender = edtSPC2FU  then edtTR1FU.SetFocus;
         if sender = edtTR1FU   then edtTR2FU.SetFocus;
         if sender = edtTR2FU   then edtTR3FU.SetFocus;
         if sender = edtTR3FU   then edtLOCO1FU.SetFocus;
         if sender = edtLOCO1FU then cbxF1.SetFocus;
         if sender = edtLOCO2FU then edtCOMM1FU.SetFocus;
         if sender = edtCOMM1FU then cbxF4.SetFocus;
         if sender = edtCOMM2FU then cbxF7.SetFocus;
         if sender = edtSC1FU   then edtSC2FU.SetFocus;
         if sender = edtSC2FU   then edtSC3FU.SetFocus;
         if sender = edtSC3FU   then edtSEC1FU.SetFocus;
        except
       end;
     end;
       // make sure all fields have data
     If (edtsec1fu.Text = '')  or (edtsec2fu.Text = '')  or (edtsec3fu.Text = '')  or
        (edtsec4fu.Text = '')  or (edtsec5fu.Text = '')  or (edtsec6fu.Text = '')  or
        (edtspc1fu.Text = '')  or (edtspc2fu.Text = '')  or (edttr1fu.Text = '')   or
        (edttr2fu.Text = '')   or (edttr3fu.Text = '')   or (edtloco1fu.Text = '') or
        (edtloco2fu.Text = '') or (edtcomm1fu.Text = '') or (edtcomm2fu.Text = '') or
        (edtsc1fu.Text = '')   or (edtsc2fu.Text = '')   or (edtsc3fu.Text = '') then
       exit;
       //calculate the scores
       x := x + (strtofloat(edtsec1fu.text));
       x := x + (strtofloat(edtsec2fu.text));
       x := x + (strtofloat(edtsec3fu.text));
       x := x + (strtofloat(edtsec4fu.text));
       x := x + (strtofloat(edtsec5fu.text));
       x := x + (strtofloat(edtsec6fu.text));
       x := x + (strtofloat(edtspc1fu.text));
       x := x + (strtofloat(edtspc2fu.text));
       x := x + (strtofloat(edttr1fu.text));
       x := x + (strtofloat(edttr2fu.text));
       x := x + (strtofloat(edttr3fu.text));
       x := x + (strtofloat(edtloco1fu.text));
       x := x + (strtofloat(edtloco2fu.text));
      edMotorFU.text := floattostr(x);
       y := y + (strtofloat(edtcomm1fu.text));
       y := y + (strtofloat(edtcomm2fu.text));
       y := y + (strtofloat(edtsc1fu.text));
       y := y + (strtofloat(edtsc2fu.text));
       y := y + (strtofloat(edtsc3fu.text));
      edCognitiveFU.text := floattostr(y);
      edTotalFU.text := floattostr(x + y);
    end;
  except
    on EConvertError do
    begin
      If (a = '') or (a = ' ') then
       begin
        edMotorFU.text := '';
        edCognitiveFU.text := '';
        edTotalFU.text := '';
        exit;
       end;
      showmessage('Enter a valid number');
      Tedit(sender).setfocus;
    end;
  end;
end;

procedure TMainForm.edtSEC1gExit(Sender: TObject);
var
  i, x, y: real;
  a: string;
begin
 SetTimer1;
  x := 0; y := 0;
  with sender as TEdit do
  try
    a := Tedit(sender).text;
    if a <> '' then
    begin
       i := strtofloat(a);
       if (i < 1) or (i > 7) then
       begin
         showmessage('Enter a value from 1 to 7.  If you need help, press the Scoring Key button below.');
         tedit(sender).text := '';
         tedit(sender).setfocus;
       end
       else
       begin
        try
         if sender = edtSEC1g  then edtSEC2g.SetFocus;
         if sender = edtSEC2g  then edtSEC3g.SetFocus;
         if sender = edtSEC3g  then edtSEC4g.SetFocus;
         if sender = edtSEC4g  then edtSEC5g.SetFocus;
         if sender = edtSEC5g  then edtSEC6g.SetFocus;
         if sender = edtSEC6g  then edtSPC1g.SetFocus;
         if sender = edtSPC1g  then edtSPC2g.SetFocus;
         if sender = edtSPC2g  then edtTR1g.SetFocus;
         if sender = edtTR1g   then edtTR2g.SetFocus;
         if sender = edtTR2g   then edtTR3g.SetFocus;
         if sender = edtTR3g   then edtLOCO1g.SetFocus;
         if sender = edtLOCO1g then cbxG1.SetFocus;
         if sender = edtLOCO2g then edtCOMM1g.SetFocus;
         if sender = edtCOMM1g then cbxG4.SetFocus;
         if sender = edtCOMM2g then cbxG7.SetFocus;
         if sender = edtSC1g   then edtSC2g.SetFocus;
         if sender = edtSC2g   then edtSC3g.SetFocus;
         if sender = edtSC3g   then edtSEC1g.SetFocus;
        except
       end;
     end;
       // make sure all fields have data
     If (edtsec1g.Text = '')  or (edtsec2g.Text = '')  or (edtsec3g.Text = '')  or
        (edtsec4g.Text = '')  or (edtsec5g.Text = '')  or (edtsec6g.Text = '')  or
        (edtspc1g.Text = '')  or (edtspc2g.Text = '')  or (edttr1g.Text = '')   or
        (edttr2g.Text = '')   or (edttr3g.Text = '')   or (edtloco1g.Text = '') or
        (edtloco2g.Text = '') or (edtcomm1g.Text = '') or (edtcomm2g.Text = '') or
        (edtsc1g.Text = '')   or (edtsc2g.Text = '')   or (edtsc3g.Text = '') then
      exit;
       //calculate the scores
       x := x + (strtofloat(edtsec1g.text));
       x := x + (strtofloat(edtsec2g.text));
       x := x + (strtofloat(edtsec3g.text));
       x := x + (strtofloat(edtsec4g.text));
       x := x + (strtofloat(edtsec5g.text));
       x := x + (strtofloat(edtsec6g.text));
       x := x + (strtofloat(edtspc1g.text));
       x := x + (strtofloat(edtspc2g.text));
       x := x + (strtofloat(edttr1g.text));
       x := x + (strtofloat(edttr2g.text));
       x := x + (strtofloat(edttr3g.text));
       x := x + (strtofloat(edtloco1g.text));
       x := x + (strtofloat(edtloco2g.text));
      edMotorG.text := floattostr(x);
       y := y + (strtofloat(edtcomm1g.text));
       y := y + (strtofloat(edtcomm2g.text));
       y := y + (strtofloat(edtsc1g.text));
       y := y + (strtofloat(edtsc2g.text));
       y := y + (strtofloat(edtsc3g.text));
      edCognitiveG.text := floattostr(y);
      edTotalG.text := floattostr(x + y);
    end;
  except
    on EConvertError do
    begin
      If (a = '') or (a = ' ') then
       begin
        edMotorG.text := '';
        edCognitiveG.text := '';
        edTotalG.text := '';
        exit;
       end;
      showmessage('Enter a valid number');
      Tedit(sender).setfocus;
    end;
  end;
end;

procedure TMainForm.FinishedButton1Click(Sender: TObject);
var
 Line1: string[75];
 a : string;
 x, col1, col2, col3, col4, col5, col6: integer;
 admission, interim, discharge, FU, goals: boolean;
begin
 SetTimer1;
//set the variables that will be needed to format the note well
 goals := false;
 line1:='                                                             ';
 col1:=2;
 col2:=28;
 col3:=38;
 col4:=48;
 col5:=58;
 col6:=68;

//set the types of assessments done
 admission := chkAdmit.checked;
 interim := chkInterim.checked;
 discharge:=chkDC.checked;
 FU := chkFU.checked;
 CheckScoresPresent(tbshtGoal);
 If GoodScore then goals := true;

//Put errorchecking in here if needed
 Errorcheck;
 if errorflag then exit;

//write the text of the note to mem1
 mem1.Clear;
 If (edtAdmit.Text <> '') and (edtAdmit.Enabled) then
  mem1.lines.add(lblDX1.Caption+': '+edtAdmit.Text);
 If (cbxAdmitClass.Text <> '') and (edtAdmit.Enabled) then
  mem1.lines.add('Admission Class: '+cbxAdmitClass.text);
 If (edtDC.Text <> '') and (edtAdmit.Enabled) then
  mem1.lines.add('Discharge Date:  '+edtDC.text);
 if chkInterrupt.checked then
  begin
    if ((edTrDt1.text <> '') and (edTrDt1.Enabled)) or
       ((edTrDt2.text <> '') and (edTrDt2.Enabled)) or
       ((edTrDt3.text <> '') and (edTrDt3.Enabled)) then
     mem1.lines.add('  The program was interrupted on the following occasions:');
    if (edTrDt1.text <> '') and ((edTrDt1.Enabled) or (edtRtDt1.Enabled)) then
      begin
        mem1.lines.add('    1st Interruption Transfer Date: '+edTrDt1.text);
        mem1.lines.add('                       Return Date: '+edtRtDt1.text);
      end;
    if (edTrDt2.text <> '') and ((edTrDt2.Enabled) or (edtRtDt2.Enabled)) then
      begin
        mem1.lines.add('    2nd Interruption Transfer Date: '+edTrDt2.text);
        mem1.lines.add('                       Return Date: '+edtRtDt2.text);
      end;
    if (edTrDt3.text <> '') and ((edTrDt3.Enabled) or (edtRtDt3.Enabled)) then
      begin
        mem1.lines.add('    3rd Interruption Transfer Date: '+edTrDt3.text);
        mem1.lines.add('                       Return Date: '+edtRtDt3.text);
      end;
  end;
 if ((edtImpGrp.text <> '')  and (edtImpGrp.Enabled))  or
    ((edtOnsetDt.text <> '') and (edtOnsetDt.Enabled)) or
    ((edtEtDiag.text <> '')  and (edtEtDiag.Enabled))  or
    ((cbxASIA.text <> '')    and (cbxASIA.Enabled))    or
    ((edtDiag1.text <> '')   and (edtDiag1.Enabled))   or
    ((edtDiag2.text <> '')   and (edtDiag2.Enabled))   or
    ((edtDiag3.text <> '')   and (edtDiag3.Enabled))   or
    ((edtDiag4.text <> '')   and (edtDiag4.Enabled))   or
    ((edtDiag5.text <> '')   and (edtDiag5.Enabled))   or
    ((edtDiag6.text <> '')   and (edtDiag6.Enabled))   or
    ((edtDiag7.text <> '')   and (edtDiag7.Enabled))   then
  begin
   mem1.lines.add('');
   mem1.lines.add('DIAGNOSIS');
   if (edtImpGrp.text <> '  .    ') and (edtImpGrp.Enabled) then
    begin
     mem2.lines.add('      Impairment Group: '+edtImpGrp.text+' '+edtImpGrptxt.Text);
     CopyIndentedText;
    end; 
   if (edtOnsetDt.text <> '') and (edtOnsetDt.Enabled) then
     mem1.lines.add('         Date of Onset: '+edtOnsetDt.text);
   if (edtEtDiag.text <> '') and (edtEtDiag.Enabled) then
     mem1.lines.add('   Etiologic Diagnosis: '+edtEtDiag.text);
   if (cbxASIA.text <> '') and (cbxASIA.Enabled) then
     mem1.lines.add(' ASIA Impairment Scale: '+cbxASIA.text);
   if ((edtDiag1.text <> '') and (edtDiag1.Enabled)) or
      ((edtDiag2.text <> '') and (edtDiag2.Enabled)) or
      ((edtDiag3.text <> '') and (edtDiag3.Enabled)) then
    begin
     mem1.lines.add('Other Diagnoses: ');
     a:='';
     if (edtDiag1.text <> '') and (edtDiag1.Enabled) then a:=a+edtDiag1.text+', ';
     if (edtDiag2.text <> '') and (edtDiag2.Enabled) then a:=a+edtDiag2.text+', ';
     if (edtDiag3.text <> '') and (edtDiag3.Enabled) then a:=a+edtDiag3.text+', ';
     if a<>'' then
      begin
       x:=length(a);
       a:=copy(a,1,(x-2));
      end;
     mem1.lines.add('          Most Significant: '+a);
    end;

   if ((edtDiag4.text <> '') and (edtDiag4.Enabled)) or
      ((edtDiag5.text <> '') and (edtDiag5.Enabled)) or
      ((edtDiag6.text <> '') and (edtDiag6.Enabled)) then
    begin
     a:='';
     if (edtDiag4.text <> '') and (edtDiag4.Enabled) then a:=a+edtDiag4.text+', ';
     if (edtDiag5.text <> '') and (edtDiag5.Enabled) then a:=a+edtDiag5.text+', ';
     if (edtDiag6.text <> '') and (edtDiag6.Enabled) then a:=a+edtDiag6.text+', ';
     if a<>'' then
      begin
       x:=length(a);
       a:=copy(a,1,(x-2));
      end;
     mem1.lines.add(' Complications Comorbidity: '+a);
    end;

   if (edtDiag7.text <> '') and (edtDiag7.Enabled) then
    mem1.lines.add('  Dx for Transfer or Death: '+edtDiag7.Text);
  end;

 if (admission) or (interim) or (discharge) or (fu) or (goals) then
  begin
   mem1.lines.add('');
   mem1.lines.add('FUNCTIONAL INDEPENDENCE MEASURE (FIM)');
   if admission then insert('ADMISSION',line1,24);
   if discharge then insert('DISCHARGE',line1,35);
   if interim then insert('INTERIM',line1,45);
   if fu then insert('F/U',line1,57);
   if goals then insert('GOALS',line1,66);
   mem1.lines.add(line1);
   line1:='                                                             ';

   if ((edtSEC1.text <> '')   and (edtSEC1.Enabled)) or
      ((edtsec1d.text <> '')  and (edtsec1d.Enabled)) or
      ((edtsec1i.text <> '')  and (edtsec1i.Enabled) and (interim)) or
      ((edtsec1fu.text <> '') and (edtsec1fu.Enabled)) or
      ((edtsec1g.text <> '')  and (edtsec1g.Enabled)) or
      ((edtsec2.text <> '')   and (edtsec2.Enabled)) or
      ((edtsec2d.text <> '')  and (edtsec2d.Enabled)) or
      ((edtsec2i.text <> '')  and (edtsec2i.Enabled) and (interim)) or
      ((edtsec2fu.text <> '') and (edtsec2fu.Enabled)) or
      ((edtsec2g.text <> '')  and (edtsec2g.Enabled)) or
      ((edtsec3.text <> '')   and (edtsec3.Enabled)) or
      ((edtsec3d.text <> '')  and (edtsec3d.Enabled)) or
      ((edtsec3i.text <> '')  and (edtsec3i.Enabled) and (interim)) or
      ((edtsec3fu.text <> '') and (edtsec3fu.Enabled)) or
      ((edtsec3g.text <> '')  and (edtsec3g.Enabled)) or
      ((edtsec4.text <> '')   and (edtsec4.Enabled)) or
      ((edtsec4d.text <> '')  and (edtsec4d.Enabled)) or
      ((edtsec4i.text <> '')  and (edtsec4i.Enabled) and (interim)) or
      ((edtsec4fu.text <> '') and (edtsec4fu.Enabled)) or
      ((edtsec4g.text <> '')  and (edtsec4g.Enabled)) or
      ((edtsec5.text <> '')   and (edtsec5.Enabled)) or
      ((edtsec5d.text <> '')  and (edtsec5d.Enabled)) or
      ((edtsec5i.text <> '')  and (edtsec5i.Enabled) and (interim)) or
      ((edtsec5fu.text <> '') and (edtsec5fu.Enabled)) or
      ((edtsec5g.text <> '')  and (edtsec5g.Enabled)) or
      ((edtsec6.text <> '')   and (edtsec6.Enabled)) or
      ((edtsec6d.text <> '')  and (edtsec6d.Enabled)) or
      ((edtsec6i.text <> '')  and (edtsec6i.Enabled) and (interim)) or
      ((edtsec6fu.text <> '') and (edtsec6fu.Enabled)) or
      ((edtsec6g.text <> '')  and (edtsec6g.Enabled)) then
    begin
     insert(' Self-Care',line1,1);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;

   if ((edtSEC1.text <> '')   and (edtSEC1.Enabled)) or
      ((edtsec1d.text <> '')  and (edtsec1d.Enabled)) or
      ((edtsec1i.text <> '')  and (edtsec1i.Enabled) and (interim)) or
      ((edtsec1fu.text <> '') and (edtsec1fu.Enabled)) or
      ((edtsec1g.text <> '')  and (edtsec1g.Enabled)) then
    begin
     insert(' Eating',line1,col1);
     if (admission) and (edtSEC1.Enabled)   then insert(edtSEC1.text,line1,col2);
     if (discharge) and (edtsec1d.Enabled)  then insert(edtsec1d.text,line1,col3);
     if (interim)   and (edtsec1i.Enabled)  then insert(edtsec1i.text,line1,col4);
     if (fu)        and (edtsec1fu.Enabled) then insert(edtsec1fu.text,line1,col5);
     if (goals)     and (edtsec1g.Enabled)  then insert(edtsec1g.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;
   if ((edtsec2.text <> '')   and (edtsec2.Enabled)) or
      ((edtsec2d.text <> '')  and (edtsec2d.Enabled)) or
      ((edtsec2i.text <> '')  and (edtsec2i.Enabled) and (interim)) or
      ((edtsec2fu.text <> '') and (edtsec2fu.Enabled)) or
      ((edtsec2g.text <> '')  and (edtsec2g.Enabled)) then
    begin
     insert(' Grooming',line1,col1);
     if (admission) and (edtsec2.Enabled)   then insert(edtsec2.text,line1,col2);
     if (discharge) and (edtsec2d.Enabled)  then insert(edtsec2d.text,line1,col3);
     if (interim)   and (edtsec2i.Enabled)  then insert(edtsec2i.text,line1,col4);
     if (fu)        and (edtsec2fu.Enabled) then insert(edtsec2fu.text,line1,col5);
     if (goals)     and (edtsec2g.Enabled)  then insert(edtsec2g.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;
   if ((edtsec3.text <> '')   and (edtsec3.Enabled)) or
      ((edtsec3d.text <> '')  and (edtsec3d.Enabled)) or
      ((edtsec3i.text <> '')  and (edtsec3i.Enabled) and (interim)) or
      ((edtsec3fu.text <> '') and (edtsec3fu.Enabled)) or
      ((edtsec3g.text <> '')  and (edtsec3g.Enabled)) then
    begin
     insert(' Bathing',line1,col1);
     if (admission) and (edtsec3.Enabled)   then insert(edtsec3.text,line1,col2);
     if (discharge) and (edtsec3d.Enabled)  then insert(edtsec3d.text,line1,col3);
     if (interim)   and (edtsec3i.Enabled)  then insert(edtsec3i.text,line1,col4);
     if (fu)        and (edtsec3fu.Enabled) then insert(edtsec3fu.text,line1,col5);
     if (goals)     and (edtsec3g.Enabled)  then insert(edtsec3g.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;
   if ((edtsec4.text <> '')   and (edtsec4.Enabled)) or
      ((edtsec4d.text <> '')  and (edtsec4d.Enabled)) or
      ((edtsec4i.text <> '')  and (edtsec4i.Enabled) and (interim)) or
      ((edtsec4fu.text <> '') and (edtsec4fu.Enabled)) or
      ((edtsec4g.text <> '')  and (edtsec4g.Enabled)) then
    begin
     insert(' Dressing-Upper Body',line1,col1);
     if (admission) and (edtsec4.Enabled)   then insert(edtsec4.text,line1,col2);
     if (discharge) and (edtsec4d.Enabled)  then insert(edtsec4d.text,line1,col3);
     if (interim)   and (edtsec4i.Enabled)  then insert(edtsec4i.text,line1,col4);
     if (fu)        and (edtsec4fu.Enabled) then insert(edtsec4fu.text,line1,col5);
     if (goals)     and (edtsec4g.Enabled)  then insert(edtsec4g.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;
   if ((edtsec5.text <> '')   and (edtsec5.Enabled)) or
      ((edtsec5d.text <> '')  and (edtsec5d.Enabled)) or
      ((edtsec5i.text <> '')  and (edtsec5i.Enabled) and (interim)) or
      ((edtsec5fu.text <> '') and (edtsec5fu.Enabled)) or
      ((edtsec5g.text <> '')  and (edtsec5g.Enabled)) then
    begin
     insert(' Dressing-Lower Body',line1,col1);
     if (admission) and (edtsec5.Enabled)   then insert(edtsec5.text,line1,col2);
     if (discharge) and (edtsec5d.Enabled)  then insert(edtsec5d.text,line1,col3);
     if (interim)   and (edtsec5i.Enabled)  then insert(edtsec5i.text,line1,col4);
     if (fu)        and (edtsec5fu.Enabled) then insert(edtsec5fu.text,line1,col5);
     if (goals)     and (edtsec5g.Enabled)  then insert(edtsec5g.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;
   if ((edtsec6.text <> '')   and (edtsec6.Enabled)) or
      ((edtsec6d.text <> '')  and (edtsec6d.Enabled)) or
      ((edtsec6i.text <> '')  and (edtsec6i.Enabled) and (interim)) or
      ((edtsec6fu.text <> '') and (edtsec6fu.Enabled)) or
      ((edtsec6g.text <> '')  and (edtsec6g.Enabled)) then
    begin
     insert(' Toileting',line1,col1);
     if (admission) and (edtsec6.Enabled)   then insert(edtsec6.text,line1,col2);
     if (discharge) and (edtsec6d.Enabled)  then insert(edtsec6d.text,line1,col3);
     if (interim)   and (edtsec6i.Enabled)  then insert(edtsec6i.text,line1,col4);
     if (fu)        and (edtsec6fu.Enabled) then insert(edtsec6fu.text,line1,col5);
     if (goals)     and (edtsec6g.Enabled)  then insert(edtsec6g.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;

   if ((edtspc1.text <> '')   and (edtspc1.Enabled)) or
      ((edtspc1d.text <> '')  and (edtspc1d.Enabled)) or
      ((edtspc1i.text <> '')  and (edtspc1i.Enabled) and (interim)) or
      ((edtspc1fu.text <> '') and (edtspc1fu.Enabled)) or
      ((edtspc1g.text <> '')  and (edtspc1g.Enabled)) or
      ((edtspc2.text <> '')   and (edtspc2.Enabled)) or
      ((edtspc2d.text <> '')  and (edtspc2d.Enabled)) or
      ((edtspc2i.text <> '')  and (edtspc2i.Enabled) and (interim)) or
      ((edtspc2fu.text <> '') and (edtspc2fu.Enabled)) or
      ((edtspc2g.text <> '')  and (edtspc2g.Enabled)) then
    begin
     insert(' Sphincter Control',line1,1);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;

   if ((edtspc1.text <> '')   and (edtspc1.Enabled)) or
      ((edtspc1d.text <> '')  and (edtspc1d.Enabled)) or
      ((edtspc1i.text <> '')  and (edtspc1i.Enabled) and (interim)) or
      ((edtspc1fu.text <> '') and (edtspc1fu.Enabled)) or
      ((edtspc1g.text <> '')  and (edtspc1g.Enabled)) then
    begin
     insert(' Bladder Management',line1,col1);
     if (admission) and (edtspc1.Enabled)   then insert(edtspc1.text,line1,col2);
     if (discharge) and (edtspc1d.Enabled)  then insert(edtspc1d.text,line1,col3);
     if (interim)   and (edtspc1i.Enabled)  then insert(edtspc1i.text,line1,col4);
     if (fu)        and (edtspc1fu.Enabled) then insert(edtspc1fu.text,line1,col5);
     if (goals)     and (edtspc1g.Enabled)  then insert(edtspc1g.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;
   if ((edtspc2.text <> '')   and (edtspc2.Enabled)) or
      ((edtspc2d.text <> '')  and (edtspc2d.Enabled)) or
      ((edtspc2i.text <> '')  and (edtspc2i.Enabled) and (interim)) or
      ((edtspc2fu.text <> '') and (edtspc2fu.Enabled)) or
      ((edtspc2g.text <> '')  and (edtspc2g.Enabled)) then
    begin
     insert(' Bowel Management',line1,col1);
     if (admission) and (edtspc2.Enabled)   then insert(edtspc2.text,line1,col2);
     if (discharge) and (edtspc2d.Enabled)  then insert(edtspc2d.text,line1,col3);
     if (interim)   and (edtspc2i.Enabled)  then insert(edtspc2i.text,line1,col4);
     if (fu)        and (edtspc2fu.Enabled) then insert(edtspc2fu.text,line1,col5);
     if (goals)     and (edtspc2g.Enabled)  then insert(edtspc2g.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;

   if ((edttr1.text <> '')   and (edttr1.Enabled)) or
      ((edttr1d.text <> '')  and (edttr1d.Enabled)) or
      ((edttr1i.text <> '')  and (edttr1i.Enabled) and (interim)) or
      ((edttr1fu.text <> '') and (edttr1fu.Enabled)) or
      ((edttr1g.text <> '')  and (edttr1g.Enabled)) or
      ((edttr2.text <> '')   and (edttr2.Enabled)) or
      ((edttr2d.text <> '')  and (edttr2d.Enabled)) or
      ((edttr2i.text <> '')  and (edttr2i.Enabled) and (interim)) or
      ((edttr2fu.text <> '') and (edttr2fu.Enabled)) or
      ((edttr2g.text <> '')  and (edttr2g.Enabled)) or
      ((edttr3.text <> '')   and (edttr3.Enabled)) or
      ((edttr3d.text <> '')  and (edttr3d.Enabled)) or
      ((edttr3i.text <> '')  and (edttr3i.Enabled) and (interim)) or
      ((edttr3fu.text <> '') and (edttr3fu.Enabled)) or
      ((edttr3g.text <> '')  and (edttr3g.Enabled)) then
    begin
     insert(' Mobility',line1,1);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;

   if ((edttr1.text <> '')   and (edttr1.Enabled)) or
      ((edttr1d.text <> '')  and (edttr1d.Enabled)) or
      ((edttr1i.text <> '')  and (edttr1i.Enabled) and (interim)) or
      ((edttr1fu.text <> '') and (edttr1fu.Enabled)) or
      ((edttr1g.text <> '')  and (edttr1g.Enabled)) then
    begin
     insert(' Bed, Chair, Wheelchair',line1,col1);
     if (admission) and (edttr1.Enabled)   then insert(edttr1.text,line1,col2);
     if (discharge) and (edttr1d.Enabled)  then insert(edttr1d.text,line1,col3);
     if (interim)   and (edttr1i.Enabled)  then insert(edttr1i.text,line1,col4);
     if (fu)        and (edttr1fu.Enabled) then insert(edttr1fu.text,line1,col5);
     if (goals)     and (edttr1g.Enabled)  then insert(edttr1g.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;
   if ((edttr2.text <> '')   and (edttr2.Enabled)) or
      ((edttr2d.text <> '')  and (edttr2d.Enabled)) or
      ((edttr2i.text <> '')  and (edttr2i.Enabled) and (interim)) or
      ((edttr2fu.text <> '') and (edttr2fu.Enabled)) or
      ((edttr2g.text <> '')  and (edttr2g.Enabled)) then
    begin
     insert(' Toilet',line1,col1);
     if (admission) and (edttr2.Enabled)   then insert(edttr2.text,line1,col2);
     if (discharge) and (edttr2d.Enabled)  then insert(edttr2d.text,line1,col3);
     if (interim)   and (edttr2i.Enabled)  then insert(edttr2i.text,line1,col4);
     if (fu)        and (edttr2fu.Enabled) then insert(edttr2fu.text,line1,col5);
     if (goals)     and (edttr2g.Enabled)  then insert(edttr2g.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;
   if ((edttr3.text <> '')   and (edttr3.Enabled)) or
      ((edttr3d.text <> '')  and (edttr3d.Enabled)) or
      ((edttr3i.text <> '')  and (edttr3i.Enabled) and (interim)) or
      ((edttr3fu.text <> '') and (edttr3fu.Enabled)) or
      ((edttr3g.text <> '')  and (edttr3g.Enabled)) then
    begin
     insert(' Tub, Shower',line1,col1);
     if (admission) and (edttr3.Enabled)   then insert(edttr3.text,line1,col2);
     if (discharge) and (edttr3d.Enabled)  then insert(edttr3d.text,line1,col3);
     if (interim)   and (edttr3i.Enabled)  then insert(edttr3i.text,line1,col4);
     if (fu)        and (edttr3fu.Enabled) then insert(edttr3fu.text,line1,col5);
     if (goals)     and (edttr3g.Enabled)  then insert(edttr3g.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;

   if ((edtloco1.text <> '')   and (edtloco1.Enabled)) or
      ((edtloco1d.text <> '')  and (edtloco1d.Enabled)) or
      ((edtloco1i.text <> '')  and (edtloco1i.Enabled) and (interim)) or
      ((edtloco1fu.text <> '') and (edtloco1fu.Enabled)) or
      ((edtloco1g.text <> '')  and (edtloco1g.Enabled)) or
      ((edtloco2.text <> '')   and (edtloco2.Enabled)) or
      ((edtloco2d.text <> '')  and (edtloco2d.Enabled)) or
      ((edtloco2i.text <> '')  and (edtloco2i.Enabled) and (interim)) or
      ((edtloco2fu.text <> '') and (edtloco2fu.Enabled)) or
      ((edtloco2g.text <> '')  and (edtloco2g.Enabled)) then
    begin
     insert(' Locomotion',line1,1);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;

   if ((edtloco1.text <> '')   and (edtloco1.Enabled)) or
      ((edtloco1d.text <> '')  and (edtloco1d.Enabled)) or
      ((edtloco1i.text <> '')  and (edtloco1i.Enabled) and (interim)) or
      ((edtloco1fu.text <> '') and (edtloco1fu.Enabled)) or
      ((edtloco1g.text <> '')  and (edtloco1g.Enabled)) then
    begin
     insert(' Walk/Wheelchair',line1,col1);
     if (admission) and (edtloco1.text <> '') and (edtloco1.Enabled) then
      begin
       if cbxA1.checked then insert('walk '+edtloco1.text,line1,(col2-5));
       if cbxA2.checked then insert('w/c '+edtloco1.text,line1,(col2-4));
       if cbxA3.Checked then insert('both '+edtloco1.text,line1,(col2-5));
      end;
     if (discharge) and (edtloco1d.text <> '') and (edtloco1d.Enabled) then
      begin
       if cbxD1.checked then insert('walk '+edtloco1d.text,line1,(col3-5));
       if cbxD2.checked then insert('w/c '+edtloco1d.text,line1,(col3-4));
       if cbxD3.Checked then insert('both '+edtloco1d.text,line1,(col3-5));
      end;
     if (interim) and (edtloco1i.text <> '') and (edtloco1i.Enabled) then
      begin
       if cbxI1.checked then insert('walk '+edtloco1i.text,line1,(col4-5));
       if cbxI2.checked then insert('w/c '+edtloco1i.text,line1,(col4-4));
       if cbxI3.Checked then insert('both '+edtloco1i.text,line1,(col4-5));
      end;
     if (fu) and (edtloco1fu.text <> '') and (edtloco1fu.Enabled) then
      begin
       if cbxF1.checked then insert('walk '+edtloco1fu.text,line1,(col5-5));
       if cbxF2.checked then insert('w/c '+edtloco1fu.text,line1,(col5-4));
       if cbxF3.checked then insert('both '+edtloco1fu.text,line1,(col5-5));
      end;
     if (goals) and (edtloco1g.text <> '') and (edtloco1g.Enabled) then
      begin
       if cbxG1.checked then insert('walk '+edtloco1g.text,line1,(col6-5));
       if cbxG2.checked then insert('w/c '+edtloco1g.text,line1,(col6-4));
       if cbxG3.checked then insert('both '+edtloco1g.text,line1,(col6-5));
      end;
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;
   if ((edtloco2.text <> '')   and (edtloco2.Enabled)) or
      ((edtloco2d.text <> '')  and (edtloco2d.Enabled)) or
      ((edtloco2i.text <> '')  and (edtloco2i.Enabled) and (interim)) or
      ((edtloco2fu.text <> '') and (edtloco2fu.Enabled)) or
      ((edtloco2g.text <> '')  and (edtloco2g.Enabled)) then
    begin
     insert(' Stairs',line1,col1);
     if (admission) and (edtloco2.Enabled)   then insert(edtLOCO2.text,line1,col2);
     if (discharge) and (edtloco2d.Enabled)  then insert(edtLOCO2d.text,line1,col3);
     if (interim)   and (edtloco2i.Enabled)  then insert(edtLOCO2i.text,line1,col4);
     if (fu)        and (edtloco2fu.Enabled) then insert(edtLOCO2fu.text,line1,col5);
     if (goals)     and (edtloco2g.Enabled)  then insert(edtLOCO2g.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;

   if ((edMotorAdmit.text <> '')   and (edMotorAdmit.Enabled)) or
      ((edMotorDC.text <> '')      and (edMotorDC.Enabled)) or
      ((edMotorInterim.text <> '') and (edMotorInterim.Enabled) and (interim)) or
      ((edMotorFU.text <> '')      and (edMotorFU.Enabled)) or
      ((edMotorG.text <> '')       and (edMotorG.Enabled)) then
    begin
     insert('Motor Subtotal Score:',line1,1);
     if (admission) and (edMotorAdmit.Enabled)   then insert(edMotorAdmit.text,line1,col2);
     if (discharge) and (edMotorDC.Enabled)      then insert(edMotorDC.text,line1,col3);
     if (interim)   and (edMotorInterim.Enabled) then insert(edMotorInterim.text,line1,col4);
     if (fu)        and (edMotorFU.Enabled)      then insert(edMotorFU.text,line1,col5);
     if (goals)     and (edMotorG.Enabled)       then insert(edMotorG.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;

   if ((edtcomm1.text <> '')   and (edtcomm1.Enabled)) or
      ((edtcomm1d.text <> '')  and (edtcomm1d.Enabled)) or
      ((edtcomm1i.text <> '')  and (edtcomm1i.Enabled) and (interim)) or
      ((edtcomm1fu.text <> '') and (edtcomm1fu.Enabled)) or
      ((edtcomm1g.text <> '')  and (edtcomm1g.Enabled)) or
      ((edtcomm2.text <> '')   and (edtcomm2.Enabled)) or
      ((edtcomm2d.text <> '')  and (edtcomm2d.Enabled)) or
      ((edtcomm2i.text <> '')  and (edtcomm2i.Enabled) and (interim)) or
      ((edtcomm2fu.text <> '') and (edtcomm2fu.Enabled)) or
      ((edtcomm2g.text <> '')  and (edtcomm2g.Enabled)) then
    begin
     insert(' Communication',line1,1);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;

   if ((edtcomm1.text <> '')   and (edtcomm1.Enabled)) or
      ((edtcomm1d.text <> '')  and (edtcomm1d.Enabled)) or
      ((edtcomm1i.text <> '')  and (edtcomm1i.Enabled) and (interim)) or
      ((edtcomm1fu.text <> '') and (edtcomm1fu.Enabled)) or
      ((edtcomm1g.text <> '')  and (edtcomm1g.Enabled)) then
    begin
     insert(' Comprehension',line1,col1);
     if (admission) and (edtcomm1.text <> '') and (edtcomm1.Enabled) then
      begin
       if cbxA4.Checked then insert('aud '+edtcomm1.text,line1,(col2-4));
       if cbxA5.checked then insert('vis '+edtcomm1.text,line1,(col2-4));
       if cbxA6.checked then insert('both '+edtcomm1.text,line1,(col2-5));
      end;
     if (discharge) and (edtcomm1d.text <> '') and (edtcomm1d.Enabled) then
      begin
       if cbxD4.Checked then insert('aud '+edtcomm1d.text,line1,(col3-4));
       if cbxD5.checked then insert('vis '+edtcomm1d.text,line1,(col3-4));
       if cbxD6.checked then insert('both '+edtcomm1d.text,line1,(col3-5));
      end;
     if (interim) and (edtcomm1i.text <> '') and (edtcomm1i.Enabled) then
      begin
       if cbxI4.Checked then insert('aud '+edtcomm1i.text,line1,(col4-4));
       if cbxI5.checked then insert('vis '+edtcomm1i.text,line1,(col4-4));
       if cbxI6.checked then insert('both '+edtcomm1i.text,line1,(col4-5));
      end;
     if (fu) and (edtcomm1fu.text <> '') and (edtcomm1fu.Enabled) then
      begin
       if cbxF4.Checked then insert('aud '+edtcomm1fu.text,line1,(col5-4));
       if cbxF5.checked then insert('vis '+edtcomm1fu.text,line1,(col5-4));
       if cbxF6.checked then insert('both '+edtcomm1fu.text,line1,(col5-5));
      end;
     if (goals) and (edtcomm1g.text <> '') and (edtcomm1g.Enabled) then
      begin
       if cbxG4.Checked then insert('aud '+edtcomm1g.text,line1,(col6-4));
       if cbxG5.checked then insert('vis '+edtcomm1g.text,line1,(col6-4));
       if cbxG6.checked then insert('both '+edtcomm1g.text,line1,(col6-5));
      end;
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;
   if ((edtcomm2.text <> '')   and (edtcomm2.Enabled)) or
      ((edtcomm2d.text <> '')  and (edtcomm2d.Enabled)) or
      ((edtcomm2i.text <> '')  and (edtcomm2i.Enabled) and (interim)) or
      ((edtcomm2fu.text <> '') and (edtcomm2fu.Enabled)) or
      ((edtcomm2g.text <> '')  and (edtcomm2g.Enabled)) then
    begin
     insert(' Expression',line1,col1);
     if (admission) and (edtcomm2.text <> '') and (edtcomm2.Enabled) then
      begin
       if cbxA7.Checked then insert('voc '   +edtcomm2.text,line1,(col2-4));
       if cbxA8.checked then insert('nonvoc '+edtcomm2.text,line1,(col2-7));
       if cbxA9.checked then insert('both '  +edtcomm2.text,line1,(col2-5));
      end;
     if (discharge) and (edtcomm2d.text <> '') and (edtcomm2d.Enabled)then
      begin
       if cbxD7.Checked then insert('vocal ' +edtcomm2d.text,line1,(col3-6));
       if cbxD8.checked then insert('nonvoc '+edtcomm2d.text,line1,(col3-7));
       if cbxD9.checked then insert('both '  +edtcomm2d.text,line1,(col3-5));
      end;
     if (interim) and (edtcomm2i.text <> '') and (edtcomm2i.Enabled)then
      begin
       if cbxI7.Checked then insert('vocal ' +edtcomm2i.text,line1,(col4-6));
       if cbxI8.checked then insert('nonvoc '+edtcomm2i.text,line1,(col4-7));
       if cbxI9.checked then insert('both ' +edtcomm2i.text,line1,(col4-5));
      end;
     if (fu) and (edtcomm2fu.text <> '') and (edtcomm2fu.Enabled) then
      begin
       if cbxF7.Checked then insert('vocal ' +edtcomm2fu.text,line1,(col5-6));
       if cbxF8.checked then insert('nonvoc '+edtcomm2fu.text,line1,(col5-7));
       if cbxF9.checked then insert('both '  +edtcomm2fu.text,line1,(col5-5));
      end;
     if (goals) and (edtcomm2g.text <> '') and (edtcomm2g.Enabled) then
      begin
       if cbxG7.Checked then insert('vocal ' +edtcomm2g.text,line1,(col6-6));
       if cbxG8.checked then insert('nonvoc '+edtcomm2g.text,line1,(col6-7));
       if cbxG9.checked then insert('both '  +edtcomm2g.text,line1,(col6-5));
      end;
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;

   if ((edtsc1.text <> '')   and (edtsc1.Enabled)) or
      ((edtsc1d.text <> '')  and (edtsc1d.Enabled)) or
      ((edtsc1i.text <> '')  and (edtsc1i.Enabled) and (interim)) or
      ((edtsc1fu.text <> '') and (edtsc1fu.Enabled)) or
      ((edtsc1g.text <> '')  and (edtsc1g.Enabled)) or
      ((edtsc2.text <> '')   and (edtsc2.Enabled)) or
      ((edtsc2d.text <> '')  and (edtsc2d.Enabled)) or
      ((edtsc2i.text <> '')  and (edtsc2i.Enabled) and (interim)) or
      ((edtsc2fu.text <> '') and (edtsc2fu.Enabled)) or
      ((edtsc2g.text <> '')  and (edtsc2g.Enabled)) or
      ((edtsc3.text <> '')   and (edtsc3.Enabled)) or
      ((edtsc3d.text <> '')  and (edtsc3d.Enabled)) or
      ((edtsc3i.text <> '')  and (edtsc3i.Enabled) and (interim)) or
      ((edtsc3fu.text <> '') and (edtsc3fu.Enabled)) or
      ((edtsc3g.text <> '')  and (edtsc3g.Enabled)) then
    begin
     insert(' Social Cognition',line1,1);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;

   if ((edtsc1.text <> '')   and (edtsc1.Enabled)) or
      ((edtsc1d.text <> '')  and (edtsc1d.Enabled)) or
      ((edtsc1i.text <> '')  and (edtsc1i.Enabled) and (interim)) or
      ((edtsc1fu.text <> '') and (edtsc1fu.Enabled)) or
      ((edtsc1g.text <> '')  and (edtsc1g.Enabled)) then
    begin
     insert(' Social Interaction',line1,col1);
     if (admission) and (edtsc1.Enabled)   then insert(edtsc1.text,line1,col2);
     if (discharge) and (edtsc1d.Enabled)  then insert(edtsc1d.text,line1,col3);
     if (interim)   and (edtsc1i.Enabled)  then insert(edtsc1i.text,line1,col4);
     if (fu)        and (edtsc1fu.Enabled) then insert(edtsc1fu.text,line1,col5);
     if (goals)     and (edtsc1g.Enabled)  then insert(edtsc1g.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;
   if ((edtsc2.text <> '')   and (edtsc2.Enabled)) or
      ((edtsc2d.text <> '')  and (edtsc2d.Enabled)) or
      ((edtsc2i.text <> '')  and (edtsc2i.Enabled) and (interim)) or
      ((edtsc2fu.text <> '') and (edtsc2fu.Enabled)) or
      ((edtsc2g.text <> '')  and (edtsc2g.Enabled)) then
    begin
     insert(' Problem Solving',line1,col1);
     if (admission) and (edtsc2.Enabled)   then insert(edtsc2.text,line1,col2);
     if (discharge) and (edtsc2d.Enabled)  then insert(edtsc2d.text,line1,col3);
     if (interim)   and (edtsc2i.Enabled)  then insert(edtsc2i.text,line1,col4);
     if (fu)        and (edtsc2fu.Enabled) then insert(edtsc2fu.text,line1,col5);
     if (goals)     and (edtsc2g.Enabled)  then insert(edtsc2g.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;
   if ((edtsc3.text <> '')   and (edtsc3.Enabled)) or
      ((edtsc3d.text <> '')  and (edtsc3d.Enabled)) or
      ((edtsc3i.text <> '')  and (edtsc3i.Enabled) and (interim)) or
      ((edtsc3fu.text <> '') and (edtsc3fu.Enabled)) or
      ((edtsc3g.text <> '')  and (edtsc3g.Enabled)) then
    begin
     insert(' Memory',line1,col1);
     if (admission) and (edtsc3.Enabled)   then insert(edtsc3.text,line1,col2);
     if (discharge) and (edtsc3d.Enabled)  then insert(edtsc3d.text,line1,col3);
     if (interim)   and (edtsc3i.Enabled)  then insert(edtsc3i.text,line1,col4);
     if (fu)        and (edtsc3fu.Enabled) then insert(edtsc3fu.text,line1,col5);
     if (goals)     and (edtsc3g.Enabled)  then insert(edtsc3g.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;

   if ((edCognitiveAdmit.text <> '')   and (edCognitiveAdmit.Enabled)) or
      ((edCognitiveDC.text <> '')      and (edCognitiveDC.Enabled)) or
      ((edCognitiveInterim.text <> '') and (edCognitiveInterim.Enabled) and (interim)) or
      ((edCognitiveFU.text <> '')      and (edCognitiveFU.Enabled)) or
      ((edCognitiveG.text <> '')       and (edCognitiveG.Enabled)) then
    begin
     insert(' Cognitive Subtotal Score:',line1,1);
     if (admission) and (edCognitiveAdmit.Enabled)   then insert(edCognitiveAdmit.text,line1,col2);
     if (discharge) and (edCognitiveDC.Enabled)      then insert(edCognitiveDC.text,line1,col3);
     if (interim)   and (edCognitiveInterim.Enabled) then insert(edCognitiveInterim.text,line1,col4);
     if (fu)        and (edCognitiveFU.Enabled)      then insert(edCognitiveFU.text,line1,col5);
     if (goals)     and (edCognitiveG.Enabled)       then insert(edCognitiveG.text,line1,col6);
     mem1.lines.add(line1);
     line1:='                                                             ';
    end;

   if ((edTotalAdmit.text <> '')   and (edTotalAdmit.Enabled)) or
      ((edTotalDC.text <> '')      and (edTotalDC.Enabled)) or
      ((edTotalInterim.text <> '') and (edTotalInterim.Enabled) and (interim)) or
      ((edTotalFU.text <> '')      and (edTotalFU.Enabled)) or
      ((edTotalG.text <> '')       and (edTotalG.Enabled)) then
    begin
     mem1.lines.add('Total Motor and');
     insert('      Cognitive Score:',line1,1);
     if (admission) then insert(edTotalAdmit.text,line1,col2);
     if (discharge) then insert(edTotalDC.text,line1,col3);
     if (interim)   then insert(edTotalInterim.text,line1,col4);
     if (fu)        then insert(edTotalFU.text,line1,col5);
     if (goals)     then insert(edTotalG.text,line1,col6);
     mem1.lines.add(line1);
    end;
   If PN_IEN = '' then
    begin
     mem1.Lines.Add(' ');
     mem1.Lines.Add('* FIM MEASUREMENT DEFINITIONS');
     mem1.Lines.Add('     NO HELPER');
     mem1.Lines.Add('       7.  Complete Independence (Timely, Safely)');
     mem1.Lines.Add('       6.  Modified Independence (Device)');
     mem1.Lines.Add('     HELPER (Modified Dependence)');
     mem1.Lines.Add('       5.  Supervision');
     mem1.Lines.Add('       4.  Minimal Assistance (Subject = 75% +)');
     mem1.Lines.Add('       3.  Moderate Assistance (Subject = 50% +)');
     mem1.Lines.Add('     HELPER (Complete Dependence)');
     mem1.Lines.Add('       2.  Maximal Assistance (Subject = 25% +)');
     mem1.Lines.Add('       1.  Total Assistance (Subject = 0% +)');
    end;
  end;
//  add case notes
 If memCurrent.Lines.Count>0 then
  begin
   mem1.Lines.Add(' ');
   mem1.Lines.Add('ADDITIONAL INFORMATION:');
   For x := 0 to memCurrent.Lines.Count-1 do
    mem1.Lines.Add('  '+memCurrent.Lines[x]);
  end;
//put the cursor at the top of the memo on the finish page
 mem1.SelStart:=0;
 mem1.SelLength:=0;
end;

procedure TMainForm.chkDCClick(Sender: TObject);
begin
 SetTimer1;
  if not chkDC.checked then
    begin
      clearselected(tbshtDC);
      resetfim(tbshtDC);
      tbshtDC.TabVisible := false;
      SetGraphBtn;
    end
   else tbshtDC.TabVisible:=true;
//  setstate(chkDC.checked, tbshtDC);
  //calculate the scores for this page
  edtSEC1dExit(edtSEC1d);
  //check to activate the next button
  SetGraphBtn;
end;

procedure TMainForm.chkAdmitClick(Sender: TObject);
begin
 SetTimer1;
  if not chkAdmit.checked then
    begin
     clearselected(tbshtAdmit);
//     clearselected(grpFacCode);
     resetfim(tbshtAdmit);
     tbshtAdmit.TabVisible:=false;
     SetGraphBtn;
    end
   else tbshtAdmit.TabVisible:=true;
//  setstate(chkAdmit.checked, tbshtAdmit);
  //calculate the scores for this page
  edtSEC1Exit(edtSEC1);
  SetGraphBtn;
end;
// RMIM*1*3 imprecise date reformat & message
procedure TMainForm.impDateConvert(Sender: TObject);
var a: string;
begin
  with sender as Tedit do
  begin
  a := Tedit(sender).text;
  impdate := 0;
  If Piece(a,'/',1)='0' then
    begin
    Tedit(sender).text := Piece(a,'/',3);
    if grpFacCode.Visible then Impdate := 1;
    end
  else
    If Piece(a,'/',2)='0' then
    begin
    Tedit(sender).text := Piece(a,'/',1)+'/'+Piece(a,'/',3);
    if grpFacCode.Visible then Impdate :=1;
    end
  end;
  If a = '' then
  begin
    Impdate := 2;
    Showmessage('No Birth Date for patient.  Please update in VistA before proceeding.');
    edtDob.Color := clYellow;
  end;
  If Impdate = 1 then
  begin
    Showmessage('Birth Date is imprecise and will not be accepted by the FSOD.  Please update in VistA before proceeding.');
    edtDob.Color := clYellow;
  end;
end;

procedure TMainForm.edtAdmitExit(Sender: TObject);
var a: string;
begin
 SetTimer1;
  if Tedit(sender).text = '' then exit;;
//CHECK TO SEE IF BROKER IS CONNECTED BEFORE DOING A BROKER CALL
  if not FIMBroker.Connected then exit;

  with sender as Tedit do
  begin
    a := Tedit(sender).text;
    if a = '' then exit;
    FIMBroker.Param[0].PType := literal;
    FIMBroker.Param[0].value := a;
    FIMBroker.RemoteProcedure := ReformatDateTime;
    Try
     FIMBroker.Call;
     {check for errors on return}
    except
     on E:EBrokerError do
      begin
       ShowMessage('Broker Error: '+E.Message);
       exit;
      end;
     on E:EAccessViolation do
      begin
       ShowMessage(E.Message);
       exit;
      end;
     else
      begin
       raise;
       exit;
      end;
    end;
    // changed by RMIM*1*3:
    if FIMBroker.Results[0] = '-1^Invalid Date/Time' then
    begin
      Tedit(sender).text := '';
      if sender = edtDob then
        Showmessage('Date of Birth is invalid.')
      else
        begin
          Showmessage('Incorrect Date Entry.');
          Tedit(sender).setfocus;
        end;
     end
    else
     Tedit(sender).text := FIMBroker.Results[0];
  end;
end;

procedure TMainForm.SetState(state: Boolean; WinControl: TWinControl);
var
  i: integer;
begin
  with WinControl do
    for i := 0 to controlcount - 1 do
    begin
      controls[i].enabled := state;
      if controls[i] is TWinControl then SetState(state, Twincontrol(controls[i]));
    end;
end;

procedure TMainForm.ClearSelected(WinControl: TWinControl);
var
  i: integer;
begin
 SetTimer1;
  with Wincontrol do
    for i := 0 to controlcount -1 do
    begin
      if controls[i] is TCheckbox then Tcheckbox(controls[i]).checked := false;;
      if controls[i] is Tedit then Tedit(controls[i]).text := '';
//      if controls[i] is TMaskEdit then TMaskEdit(controls[i]).clear;
      if controls[i] is TRadioGroup then TRadioGroup(controls[i]).itemindex := -1;
      if controls[i] is TRadioButton then TRadioButton(controls[i]).checked := false;
      if controls[i] is TComboBox then TComboBox(controls[i]).text := '';
      if controls[i] is TlistBox then TListBox(controls[i]).clear;
      if controls[i] is TWinControl then ClearSelected(TWinControl(controls[i]));
    end;
end;


procedure TMainForm.CheckScoresPresent(WinControl: TWinControl);
begin
 GoodScore := true;
// make sure all fields have data
 If (edtsec1g.Text = '')  and (edtsec2g.Text = '')  and (edtsec3g.Text = '')  and
    (edtsec4g.Text = '')  and (edtsec5g.Text = '')  and (edtsec6g.Text = '')  and
    (edtspc1g.Text = '')  and (edtspc2g.Text = '')  and (edttr1g.Text = '')   and
    (edttr2g.Text = '')   and (edttr3g.Text = '')   and (edtloco1g.Text = '') and
    (edtloco2g.Text = '') and (edtcomm1g.Text = '') and (edtcomm2g.Text = '') and
    (edtsc1g.Text = '')   and (edtsc2g.Text = '')   and (edtsc3g.Text = '') then
    GoodScore := false;
end;

procedure TMainForm.ResetFim(WinControl: TWinControl);
var
  i: integer;
begin
  SetTimer1;
  with Wincontrol do
   for i := 0 to controlcount-1 do
   begin
     if controls[i] is Tedit then Tedit(controls[i]).text := '';
     if controls[i] is TWinControl then ResetFim(TWinControl(controls[i]));
   end;
end;

procedure TMainForm.chkInterimClick(Sender: TObject);
begin
  if not chkInterim.checked then
    begin
     clearselected(tbshtInterim);
     resetfim(tbshtInterim);
     tbshtInterim.TabVisible:=false;
     SetGraphBtn;
    end
   else tbshtInterim.TabVisible:=true;
//  setstate(chkInterim.checked, tbshtInterim);
  //calculate the scores for this page
  edtSEC1iExit(edtSEC1i);
  SetGraphBtn;
end;

procedure TMainForm.errorcheck;
var A : string;
    A1,O1 : TDate;
    C : integer;
begin
  errorflag:=false;
  x := 0;
  //if no patient is selected, make them choose
  if (edtPtCode.Text = '') or (lblName.Caption = 'No Patient Selected') or (lblName.Caption = '') then
    begin
      pgctrl1.ActivePage := tbshtPt;
      showmessage('Choose a patient.');
      errorflag:=true;
      exit;
    end;
  if PatientDFN = '' then
   begin
    CheckDFN;
    if PatientDFN = '' then
     begin
      pgctrl1.ActivePage := tbshtPt;
      showmessage('Unable to find Patient IEN.  Choose a new patient.');
      errorflag:=true;
      exit;
     end;
   end;
  // confirm that a new record won't be a duplicate
  if (RecType = 'A') then
   begin
    A := '';
    A := PatientDFN+'^'+piece(cbxFacilityCodes.Text,'-',1);
    A := A+'^'+edtImpGrp.Text+'^'+edtAdmit.Text+'^'+edtOnsetDt.Text;
    FIMBroker.Param[0].PType := literal;
    FIMBroker.Param[0].Value := A;
    FIMBroker.RemoteProcedure := MainForm.CheckforDuplicate;
    Try
     FIMBroker.Call;
     {check for errors on return}
    except
     on E:EBrokerError do
      begin
       ShowMessage('Broker Error: '+E.Message);
       exit;
      end;
     on E:EAccessViolation do
      begin
       ShowMessage(E.Message);
       exit;
      end;
     else
      begin
       raise;
       exit;
      end;
    end;
    if FIMBroker.Results[0] = '1' then
     begin
      pgctrl1.ActivePage := tbshtPt;
      showmessage('This record is a duplicate.  Please review the existing Episodes.');
      errorflag:=true;
      exit;
    end;
  end;
  // added by RMIM*1*3:
  if Impdate > 0 then
  begin
    Showmessage('Birth Date is missing or imprecise.  Please update the patient''s Date of Birth in VistA.');
    pgctrl1.ActivePage := tbshtPt;
    errorflag := true;
    exit;
  end;
  if (grpFacCode.Visible) and (lstEpisodes.ItemIndex = -1) then
    begin
      pgctrl1.ActivePage := tbshtPt;
      showmessage('Choose an Episode of Care.');
      lstEpisodes.SetFocus;
      errorflag:=true;
      exit;
    end;
  if (grpFacCode.Visible) and (edtAdmit.Text = '') then
   begin
    pgctrl1.ActivePage := tbshtDx;
    showmessage('Choose a '+lblDX1.Caption+'.');
    edtAdmit.SetFocus;
    errorflag:=true;
    exit;
   end;
  if (grpFacCode.Visible) and (edtImpGrp.Text = '') then
   begin
    pgctrl1.ActivePage := tbshtDx;
    showmessage('Choose an Impairment Group.');
    edtImpGrp.SetFocus;
    errorflag:=true;
    exit;
   end;
  if (grpFacCode.Visible) and (edtImpGrp.Text <> '') then
   begin
    A := Copy(edtImpGrp.Text,1,3);
    if (A = '4.2') and (cbxASIA.Text = '') then
     begin
      pgctrl1.ActivePage := tbshtDx;
      showmessage('Choose an ASIA Impairment Scale.');
      cbxASIA.SetFocus;
      errorflag:=true;
      exit;
     end;
   end;
  if (grpFacCode.Visible) and (edtOnsetDt.Text = '') then
   begin
    pgctrl1.ActivePage := tbshtDx;
    showmessage('Choose a Date of Onset.');
    edtOnsetDt.SetFocus;
    errorflag:=true;
    exit;
   end;
   // check that admit/therapy start date is same or later than onset date
  if (edtAdmit.Text <> '') and (edtOnsetDt.Text <> '') then
   begin
    A1 := StrtoDate(edtAdmit.Text);
    O1 := StrtoDate(edtOnsetDt.Text);
    If A1 - O1 < 0 then
     begin
      pgctrl1.ActivePage := tbshtDx;
      showMessage('Admission/Therapy Start date cannot be earlier than Date of Onset.');
      errorflag:=true;
      exit;
     end;
   end;
   // check that discharge date is same or later than admit/therapy start date
  if edtDC.Text <> '' then
   begin
    O1 := StrtoDate(edtDC.Text);
    A1 := Now;//StrtoDate(edtAdmit.Text);
    If A1 - O1 < 0 then
     begin
      pgctrl1.ActivePage := tbshtDx;
      showMessage('Discharge date cannot be in the future.');
      errorflag:=true;
      exit;
     end;
   end;
   // check that discharge date is same or later than admit/therapy start date
  if (edtDC.Text <> '') and (edtAdmit.Text <> '') then
   begin
    A1 := StrtoDate(edtDC.Text);
    O1 := StrtoDate(edtAdmit.Text);
    If A1 - O1 < 0 then
     begin
      pgctrl1.ActivePage := tbshtDx;
      showMessage('Discharge date cannot be earlier than Admission/Therapy Start date.');
      errorflag:=true;
      exit;
     end;
   end;
{  if (grpFacCode.Visible) and (edtDC.Text <> '') and (edtEtDiag.Text = '') then
   begin
    pgctrl1.ActivePage := tbshtDx;
    showmessage('Choose an Etiologic Diagnosis (ICD-9 Code).');
    edtEtDiag.SetFocus;
    errorflag:=true;
    exit;
   end;  }
  if chkAdmit.checked then  //if admission page
    begin
      if (edtLoco1.Text <> '') and (edtLoco1.Text <> ' ') and (not (cbxA1.checked) and not (cbxA2.checked)
      and not (cbxA3.checked)) then
        begin
          pgctrl1.ActivePage := tbshtAdmit;
          showmessage('Specify Walk, Wheelchair or Both');
          errorflag:=true;
          exit;
        end;
      if (edtComm1.Text <> '') and (edtComm1.Text <> ' ') and (not (cbxA4.checked) and not (cbxA5.checked)
      and not (cbxA6.checked)) then
        begin
          pgctrl1.ActivePage := tbshtAdmit;
          showmessage('Specify Auditory, Visual or Both');
          errorflag:=true;
          exit;
        end;
      if (edtComm2.Text <> '') and (edtComm2.Text <> ' ') and (not (cbxA7.checked) and not (cbxA8.checked)
      and not (cbxA9.checked)) then
        begin
          pgctrl1.ActivePage := tbshtAdmit;
          showmessage('Specify Vocal, Nonvocal or Both');
          errorflag:=true;
          exit;
        end;
    end;

  if chkInterim.checked then  //if interim page
    begin
      if (edtLoco1i.Text <> '') and (edtLoco1i.Text <> ' ') and (not (cbxI1.checked) and not (cbxI2.checked)
      and not (cbxI3.checked)) then
        begin
          pgctrl1.ActivePage := tbshtInterim;
          showmessage('Specify Walk, Wheelchair or Both');
          errorflag:=true;
          exit;
        end;
      if (edtComm1i.Text <> '') and (edtComm1i.Text <> ' ') and (not (cbxI4.checked) and not (cbxI5.checked)
      and not (cbxI6.checked)) then
        begin
          pgctrl1.ActivePage := tbshtInterim;
          showmessage('Specify Auditory, Visual or Both');
          errorflag:=true;
          exit;
        end;
      if (edtComm2i.Text <> '') and (edtComm2i.Text <> ' ') and (not (cbxI7.checked) and not (cbxI8.checked)
      and not (cbxI9.checked)) then
        begin
          pgctrl1.ActivePage := tbshtInterim;
          showmessage('Specify Vocal, Nonvocal or Both');
          errorflag:=true;
          exit;
        end;
    end;

  if chkDC.checked then  //if discharge page
    begin
      if (edtLoco1d.Text <> '') and (edtLoco1d.Text <> ' ') and (not (cbxD1.checked) and not (cbxD2.checked)
      and not (cbxD3.checked)) then
        begin
          pgctrl1.ActivePage := tbshtDC;
          showmessage('Specify Walk, Wheelchair or Both');
          errorflag:=true;
          exit;
        end;
      if (edtComm1d.Text <> '') and (edtComm1d.Text <> ' ') and (not (cbxD4.checked) and not (cbxD5.checked)
      and not (cbxD6.checked)) then
        begin
          pgctrl1.ActivePage := tbshtDC;
          showmessage('Specify Auditory, Visual or Both');
          errorflag:=true;
          exit;
        end;
      if (edtComm2d.Text <> '') and (edtComm2d.Text <> ' ') and (not (cbxD7.checked) and not (cbxD8.checked)
      and not (cbxD9.checked)) then
        begin
          pgctrl1.ActivePage := tbshtDC;
          showmessage('Specify Vocal, Nonvocal or Both');
          errorflag:=true;
          exit;
        end;
    end;

  if chkFU.checked then   // follow up
    begin
      if (edtLoco1fu.Text <> '') and (edtLoco1fu.Text <> ' ') and (not (cbxF1.checked) and not (cbxF2.checked)
      and not (cbxF3.checked)) then
        begin
          pgctrl1.ActivePage := tbshtFU;
          showmessage('Specify Walk, Wheelchair or Both');
          errorflag:=true;
          exit;
        end;
      if (edtComm1fu.Text <> '') and (edtComm1fu.Text <> ' ') and (not (cbxF4.checked) and not (cbxF5.checked)
      and not (cbxF6.checked)) then
        begin
          pgctrl1.ActivePage := tbshtFU;
          showmessage('Specify Auditory, Visual or Both');
          errorflag:=true;
          exit;
        end;
      if (edtComm2fu.Text <> '') and (edtComm2fu.Text <> ' ') and (not (cbxF7.checked) and not (cbxF8.checked)
      and not (cbxF9.checked)) then
        begin
          pgctrl1.ActivePage := tbshtFU;
          showmessage('Specify Vocal, Nonvocal or Both');
          errorflag:=true;
          exit;
        end;
    end;
    //other errorchecks here

end;

procedure TMainForm.chkFUClick(Sender: TObject);
begin
  if not chkFU.checked then
    begin
     clearselected(tbshtFU);
     resetfim(tbshtFU);
     tbshtFU.TabVisible:=false;
     SetGraphBtn;
    end
   else
    tbshtFU.TabVisible:=true;
//  setstate(chkFU.checked, tbshtFU);
  //calculate the scores for this page
  edtSEC1fuExit(edtSEC1fu);
  //disable the two comboboxes that should be disabled on page 6.
  SetGraphBtn;
end;

procedure TMainForm.cbxEthnicKeyPress(Sender: TObject; var Key: Char);
type
  TPrtChr = set of Char;
var
  Printable:      TPrtChr;
  SavTxt:         String;
  CmpTxt:         String;
  idx:            Integer;
  Match:          Boolean;
begin
  Printable := [' ' .. '~'];
  if Key in Printable then
  begin
    with sender as TCombobox do
    begin
      DroppedDown := True;
      CmpTxt := Copy(Text, 1, SelStart) + Key;
      SavTxt := Text;
      Match := False;
      idx := 0;
      while (idx < Items.Count) and not Match do
      begin
        if CompareText(CmpTxt, Copy(Items[idx], 1, Length(CmpTxt))) = 0 then
        begin
          ItemIndex := idx;
          Text := Items[idx];
          CmpTxt := Copy(Text, 1, Length(CmpTxt));
          SelStart := Length(CmpTxt);
          SelLength := Length(Text) - Length(CmpTxt);
          Match := True;
          Key := #0;
        end;
      Inc(idx);
      end;
      if not Match then
       begin
        Text := SavTxt;
        Key := #0;
       end;
    end;
  end
  else
  begin
    if (Key = #13) or (Key = #9) then
    begin
      SavTxt := Tcombobox(sender).text;
      if Tcombobox(sender).Text = Tcombobox(sender).Items[Tcombobox(sender).ItemIndex] then
         Tcombobox(sender).DroppedDown := False;
      Tcombobox(sender).Text := savtxt;
      Key := #0;
      Perform(CM_DialogKey, VK_TAB, 0);
    end;
  end;
end;

procedure TMainForm.InitializeCoordinates(Kind: integer);
begin
//this is a nasty set of coordinates to initialize
 case kind of
   1: begin
       seta(edtSEC1.text);
       setb(edtSEC2.text);
       setc(edtSEC3.text);
       setd(edtSEC4.text);
       sete(edtSEC5.text);
       setf(edtSEC6.text);
       setg(edtSPC1.text);
       seth(edtSPC2.text);
       seti(edtTR1.text);
       setj(edtTR2.text);
       setk(edtTR3.text);
       setl(edtLOCO1.text);
       setm(edtLOCO2.text);
       setn(edtCOMM1.text);
       seto(edtCOMM2.text);
       setp(edtSC1.text);
       setq(edtSC2.text);
       setr(edtSC3.text);
      end;
   2: begin
       seta(edtSEC1d.text);
       setb(edtSEC2d.text);
       setc(edtSEC3d.text);
       setd(edtSEC4d.text);
       sete(edtSEC5d.text);
       setf(edtSEC6d.text);
       setg(edtSPC1d.text);
       seth(edtSPC2d.text);
       seti(edtTR1d.text);
       setj(edtTR2d.text);
       setk(edtTR3d.text);
       setl(edtLOCO1d.text);
       setm(edtLOCO2d.text);
       setn(edtCOMM1d.text);
       seto(edtCOMM2d.text);
       setp(edtSC1d.text);
       setq(edtSC2d.text);
       setr(edtSC3d.text);
      end;
   3: begin
       seta(edtSEC1fu.text);
       setb(edtSEC2fu.text);
       setc(edtSEC3fu.text);
       setd(edtSEC4fu.text);
       sete(edtSEC5fu.text);
       setf(edtSEC6fu.text);
       setg(edtSPC1fu.text);
       seth(edtSPC2fu.text);
       seti(edtTR1fu.text);
       setj(edtTR2fu.text);
       setk(edtTR3fu.text);
       setl(edtLOCO1fu.text);
       setm(edtLOCO2fu.text);
       setn(edtCOMM1fu.text);
       seto(edtCOMM2fu.text);
       setp(edtSC1fu.text);
       setq(edtSC2fu.text);
       setr(edtSC3fu.text);
      end;
   4: begin
       seta(edtSEC1i.text);
       setb(edtSEC2i.text);
       setc(edtSEC3i.text);
       setd(edtSEC4i.text);
       sete(edtSEC5i.text);
       setf(edtSEC6i.text);
       setg(edtSPC1i.text);
       seth(edtSPC2i.text);
       seti(edtTR1i.text);
       setj(edtTR2i.text);
       setk(edtTR3i.text);
       setl(edtLOCO1i.text);
       setm(edtLOCO2i.text);
       setn(edtCOMM1i.text);
       seto(edtCOMM2i.text);
       setp(edtSC1i.text);
       setq(edtSC2i.text);
       setr(edtSC3i.text);
      end;
   5: begin
       seta(edtSEC1g.text);
       setb(edtSEC2g.text);
       setc(edtSEC3g.text);
       setd(edtSEC4g.text);
       sete(edtSEC5g.text);
       setf(edtSEC6g.text);
       setg(edtSPC1g.text);
       seth(edtSPC2g.text);
       seti(edtTR1g.text);
       setj(edtTR2g.text);
       setk(edtTR3g.text);
       setl(edtLOCO1g.text);
       setm(edtLOCO2g.text);
       setn(edtCOMM1g.text);
       seto(edtCOMM2g.text);
       setp(edtSC1g.text);
       setq(edtSC2g.text);
       setr(edtSC3g.text);
      end;
 end;
end;

procedure TMainForm.seta(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Ax:=141; Ay:=3; end;
     6: begin Ax:=141; Ay:=24; end;
     5: begin Ax:=141; Ay:=42; end;
     4: begin Ax:=141; Ay:=63; end;
     3: begin Ax:=141; Ay:=84; end;
     2: begin Ax:=141; Ay:=104; end;
     1: begin Ax:=141; Ay:=119; end;
else
   begin Ax:=141; Ay:=119; end;
end;
end;

procedure TMainForm.setb(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Bx:=189; By:=13; end;
     6: begin Bx:=182; By:=31; end;
     5: begin Bx:=175; By:=50; end;
     4: begin Bx:=168; By:=68; end;
     3: begin Bx:=162; By:=88; end;
     2: begin Bx:=155; By:=106; end;
     1: begin Bx:=150; By:=120; end;
else
   begin Bx:=150; By:=120; end;
end;
end;

procedure TMainForm.setc(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Cx:=230; Cy:=37; end;
     6: begin Cx:=217; Cy:=52; end;
     5: begin Cx:=204; Cy:=67; end;
     4: begin Cx:=193; Cy:=83; end;
     3: begin Cx:=180; Cy:=98; end;
     2: begin Cx:=166; Cy:=113; end;
     1: begin Cx:=156; Cy:=125; end;
else
   begin Cx:=156; Cy:=125; end;
end;
end;

procedure TMainForm.setd(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Dx:=260; Dy:=74; end;
     6: begin Dx:=243; Dy:=84; end;
     5: begin Dx:=226; Dy:=94; end;
     4: begin Dx:=209; Dy:=104; end;
     3: begin Dx:=192; Dy:=113; end;
     2: begin Dx:=174; Dy:=123; end;
     1: begin Dx:=161; Dy:=131; end;
else
   begin Dx:=161; Dy:=131; end;
end;
end;

procedure TMainForm.sete(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Ex:=276; Ey:=118; end;
     6: begin Ex:=256; Ey:=122; end;
     5: begin Ex:=237; Ey:=125; end;
     4: begin Ex:=218; Ey:=129; end;
     3: begin Ex:=198; Ey:=132; end;
     2: begin Ex:=178; Ey:=136; end;
     1: begin Ex:=163; Ey:=138; end;
else
   begin Ex:=163; Ey:=138; end;
end;
end;

procedure TMainForm.setf(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Fx:=275; Fy:=166; end;
     6: begin Fx:=256; Fy:=163; end;
     5: begin Fx:=236; Fy:=159; end;
     4: begin Fx:=217; Fy:=155; end;
     3: begin Fx:=197; Fy:=152; end;
     2: begin Fx:=178; Fy:=148; end;
     1: begin Fx:=163; Fy:=146; end;
else
   begin Fx:=163; Fy:=146; end;
end;
end;

procedure TMainForm.setg(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Gx:=258; Gy:=211; end;
     6: begin Gx:=241; Gy:=200; end;
     5: begin Gx:=226; Gy:=190; end;
     4: begin Gx:=207; Gy:=180; end;
     3: begin Gx:=190; Gy:=171; end;
     2: begin Gx:=173; Gy:=161; end;
     1: begin Gx:=160; Gy:=154; end;
else
   begin Gx:=160; Gy:=154; end;
end;
end;

procedure TMainForm.seth(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Hx:=229; Hy:=247; end;
     6: begin Hx:=215; Hy:=232; end;
     5: begin Hx:=202; Hy:=216; end;
     4: begin Hx:=190; Hy:=201; end;
     3: begin Hx:=177; Hy:=185; end;
     2: begin Hx:=164; Hy:=170; end;
     1: begin Hx:=155; Hy:=159; end;
else
   begin Hx:=155; Hy:=159; end;
end;
end;

procedure TMainForm.seti(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Ix:=187; Iy:=270; end;
     6: begin Ix:=180; Iy:=251; end;
     5: begin Ix:=173; Iy:=232; end;
     4: begin Ix:=166; Iy:=214; end;
     3: begin Ix:=160; Iy:=196; end;
     2: begin Ix:=153; Iy:=177; end;
     1: begin Ix:=148; Iy:=163; end;
else
   begin Ix:=148; Iy:=163; end;
end;
end;

procedure TMainForm.setj(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Jx:=142; Jy:=279; end;
     6: begin Jx:=142; Jy:=258; end;
     5: begin Jx:=142; Jy:=238; end;
     4: begin Jx:=142; Jy:=218; end;
     3: begin Jx:=142; Jy:=198; end;
     2: begin Jx:=142; Jy:=179; end;
     1: begin Jx:=142; Jy:=163; end;
else
   begin Jx:=142; Jy:=163; end;
end;
end;

procedure TMainForm.setk(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Kx:=96; Ky:=271; end;
     6: begin Kx:=103; Ky:=251; end;
     5: begin Kx:=110; Ky:=232; end;
     4: begin Kx:=116; Ky:=214; end;
     3: begin Kx:=123; Ky:=196; end;
     2: begin Kx:=130; Ky:=177; end;
     1: begin Kx:=135; Ky:=163; end;
else
   begin Kx:=135; Ky:=163; end;
end;
end;

procedure TMainForm.setl(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Lx:=54; Ly:=247; end;
     6: begin Lx:=68; Ly:=232; end;
     5: begin Lx:=80; Ly:=216; end;
     4: begin Lx:=93; Ly:=202; end;
     3: begin Lx:=106; Ly:=186; end;
     2: begin Lx:=119; Ly:=171; end;
     1: begin Lx:=128; Ly:=160; end;
else
   begin Lx:=128; Ly:=160; end;
end;
end;

procedure TMainForm.setm(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Mx:=23; My:=212; end;
     6: begin Mx:=41; My:=201; end;
     5: begin Mx:=58; My:=191; end;
     4: begin Mx:=75; My:=182; end;
     3: begin Mx:=93; My:=172; end;
     2: begin Mx:=110; My:=161; end;
     1: begin Mx:=124; My:=154; end;
else
   begin Mx:=124; My:=154; end;
end;
end;

procedure TMainForm.setn(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Nx:=5; Ny:=167; end;
     6: begin Nx:=26; Ny:=164; end;
     5: begin Nx:=46; Ny:=160; end;
     4: begin Nx:=65; Ny:=157; end;
     3: begin Nx:=85; Ny:=153; end;
     2: begin Nx:=105; Ny:=150; end;
     1: begin Nx:=120; Ny:=147; end;
else
   begin Nx:=120; Ny:=147; end;
end;
end;

procedure TMainForm.seto(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Ox:=5; Oy:=119; end;
     6: begin Ox:=25; Oy:=122; end;
     5: begin Ox:=45; Oy:=126; end;
     4: begin Ox:=64; Oy:=129; end;
     3: begin Ox:=83; Oy:=134; end;
     2: begin Ox:=104; Oy:=136; end;
     1: begin Ox:=119; Oy:=139; end;
else
   begin Ox:=119; Oy:=139; end;
end;
end;

procedure TMainForm.setp(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Px:=21; Py:=74; end;
     6: begin Px:=38; Py:=84; end;
     5: begin Px:=56; Py:=94; end;
     4: begin Px:=73; Py:=104; end;
     3: begin Px:=90; Py:=114; end;
     2: begin Px:=108; Py:=124; end;
     1: begin Px:=121; Py:=132; end;
else
   begin Px:=121; Py:=132; end;
end;
end;

procedure TMainForm.setq(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Qx:=51; Qy:=37; end;
     6: begin Qx:=64; Qy:=53; end;
     5: begin Qx:=77; Qy:=68; end;
     4: begin Qx:=90; Qy:=83; end;
     3: begin Qx:=103; Qy:=99; end;
     2: begin Qx:=116; Qy:=115; end;
     1: begin Qx:=125; Qy:=126; end;
else
   begin Qx:=125; Qy:=126; end;
end;
end;

procedure TMainForm.setr(Value: string);
var x: integer;
begin
if value = '' then value := '1';
x:=strtoint(value);
case x of
     7: begin Rx:=92; Ry:=13; end;
     6: begin Rx:=99; Ry:=32; end;
     5: begin Rx:=105; Ry:=50; end;
     4: begin Rx:=112; Ry:=69; end;
     3: begin Rx:=119; Ry:=88; end;
     2: begin Rx:=126; Ry:=106; end;
     1: begin Rx:=131; Ry:=121; end;
else
   begin Rx:=131; Ry:=121; end;
end;
end;

procedure TMainForm.BtnGraphClick(Sender: TObject);
begin
 SetTimer1;
 pnlGraph.Visible := true;
 pnlGraph.BringToFront;
 File1.Enabled := false;
 Edit1.Enabled := false;
 View.Enabled := false;
//Enable the appropriate buttons
{ BtnG_AD.enabled := chkAdmit.checked;
 BtnG_IN.enabled := chkInterim.checked;
 BtnG_DC.enabled := chkDC.checked;
 BtnG_FU.enabled := chkFU.checked;
 CheckScoresPresent(tbshtGoal);
 If GoodScore then BtnG_G.enabled := true;
 If BtnG_G.enabled then BtnG_G.SetFocus;
 If BtnG_FU.Enabled then BtnG_FU.SetFocus;
 If BtnG_DC.Enabled then BtnG_DC.SetFocus;
 If BtnG_IN.Enabled then BtnG_IN.SetFocus;
 If BtnG_AD.Enabled then BtnG_AD.SetFocus;    }
end;

procedure TMainForm.btnGReturnClick(Sender: TObject);
begin
 pnlGraph.SendToBack;
 eraseallgraphs;
 pnlGraph.Visible := false;
 File1.Enabled := true;
 Edit1.Enabled := true;
 View.Enabled := true;
end;

procedure TMainForm.FinishGraph;
begin
 Image1.BringToFront;
 lbl1.BringToFront;
 lbl2.BringToFront;
 lbl3.BringToFront;
 lbl4.BringToFront;
 lbl5.BringToFront;
 lbl6.BringToFront;
 lbl7.BringToFront;  
end;

procedure TMainForm.BtnG_ADClick(Sender: TObject);
var
 InitialImage, CopyImage: Trect;
begin
 InitialImage := Rect(0,0,281,281);
 CopyImage := Rect(0,0,281,281);
 image2.Canvas.CopyMode := cmSrcErase;
 image2.Canvas.CopyRect(copyimage,image2.canvas,initialimage);

if graph1=false then
 begin
  InitializeCoordinates(1);
  image2.Canvas.Pen.Color := clRed;
  image2.Canvas.Polyline([point(Ax,Ay), point(Bx,By), point(Cx,Cy),
                        point(Dx,Dy), point(Ex,Ey), point(Fx,Fy),
                        point(Gx,Gy), point(Hx,Hy), point(Ix,Iy),
                        point(Jx,Jy), point(Kx,Ky), point(Lx,Ly),
                        point(Mx,My), point(Nx,Ny), point(Ox,Oy),
                        point(Px,Py), point(Qx,Qy), point(Rx,Ry),
                        point(Ax,Ay)]);
  image2.Canvas.Brush.Color := clred;
  image2.Canvas.brush.style := bsSolid;
  image2.Canvas.FloodFill(141,140,clred,fsborder);
  image2.BringToFront;
  graph1:=true;
  end;
//  end
// else graph1:=false;
 graph1:=false;

 finishgraph;
end;

procedure TMainForm.BtnG_INClick(Sender: TObject);
var
 InitialImage, CopyImage: Trect;
begin
 InitialImage := Rect(0,0,281,281);
 CopyImage := Rect(0,0,281,281);
 image3.Canvas.CopyMode := cmSrcErase;
 image3.Canvas.CopyRect(copyimage,image3.canvas,initialimage);

 if graph4=false then
   begin
    InitializeCoordinates(4);
    image3.Canvas.Pen.Color := clGreen;
    image3.Canvas.Polyline([point(Ax,Ay), point(Bx,By), point(Cx,Cy),
                           point(Dx,Dy), point(Ex,Ey), point(Fx,Fy),
                           point(Gx,Gy), point(Hx,Hy), point(Ix,Iy),
                           point(Jx,Jy), point(Kx,Ky), point(Lx,Ly),
                           point(Mx,My), point(Nx,Ny), point(Ox,Oy),
                           point(Px,Py), point(Qx,Qy), point(Rx,Ry),
                           point(Ax,Ay)]);
    image3.Canvas.Brush.Color := clGreen;
    image3.Canvas.brush.style := bsSolid;
    image3.Canvas.FloodFill(141,140,clGreen,fsborder);
    image3.BringToFront;
    graph4:=true;
   end;
//   end
// else graph2:=false;
 graph4:=false;
 finishgraph;
end;

procedure TMainForm.BtnG_DCClick(Sender: TObject);
var
 InitialImage, CopyImage: Trect;
begin
 InitialImage := Rect(0,0,281,281);
 CopyImage := Rect(0,0,281,281);
 image4.Canvas.CopyMode := cmSrcErase;
 image4.Canvas.CopyRect(copyimage,image4.canvas,initialimage);

 if graph2=false then
  begin
   InitializeCoordinates(2);
   image4.Canvas.Pen.Color := clPurple;
   image4.Canvas.Polyline([point(Ax,Ay), point(Bx,By), point(Cx,Cy),
                          point(Dx,Dy), point(Ex,Ey), point(Fx,Fy),
                          point(Gx,Gy), point(Hx,Hy), point(Ix,Iy),
                          point(Jx,Jy), point(Kx,Ky), point(Lx,Ly),
                          point(Mx,My), point(Nx,Ny), point(Ox,Oy),
                          point(Px,Py), point(Qx,Qy), point(Rx,Ry),
                          point(Ax,Ay)]);
   image4.Canvas.Brush.Color := clPurple;
   image4.Canvas.brush.style := bsSolid;
   image4.Canvas.FloodFill(141,140,clPurple,fsborder);
   image4.BringToFront;
   graph2:=true;
  end;
//  end
// else graph2:=false;
 graph2:=false;
 finishgraph;
end;

procedure TMainForm.BtnG_FUClick(Sender: TObject);
var
 InitialImage, CopyImage: Trect;
begin
 InitialImage := Rect(0,0,281,281);
 CopyImage := Rect(0,0,281,281);
 image5.Canvas.CopyMode := cmSrcErase;
 image5.Canvas.CopyRect(copyimage,image5.canvas,initialimage);

 if graph3=false then
  begin
   InitializeCoordinates(3);
   image5.Canvas.Pen.Color := clYellow;
   image5.Canvas.Polyline([point(Ax,Ay), point(Bx,By), point(Cx,Cy),
                          point(Dx,Dy), point(Ex,Ey), point(Fx,Fy),
                          point(Gx,Gy), point(Hx,Hy), point(Ix,Iy),
                          point(Jx,Jy), point(Kx,Ky), point(Lx,Ly),
                          point(Mx,My), point(Nx,Ny), point(Ox,Oy),
                          point(Px,Py), point(Qx,Qy), point(Rx,Ry),
                          point(Ax,Ay)]);
   image5.Canvas.Brush.Color := clYellow;
   image5.Canvas.brush.style := bsSolid;
   image5.Canvas.FloodFill(141,140,clYellow,fsborder);
   image5.BringToFront;
   graph3:=true;
  end;
// else graph3:=false;
 graph3:=false;
 finishgraph;
end;

procedure TMainForm.eraseallgraphs;
var
 InitialImage, CopyImage: Trect;
begin
 InitialImage := Rect(0,0,281,281);
 CopyImage := Rect(0,0,281,281);
 image6.Canvas.CopyMode := cmSrcErase;
 image6.Canvas.CopyRect(copyimage,image6.canvas,initialimage);
 image5.Canvas.CopyMode := cmSrcErase;
 image5.Canvas.CopyRect(copyimage,image5.canvas,initialimage);
 image4.Canvas.CopyMode := cmSrcErase;
 image4.Canvas.CopyRect(copyimage,image4.canvas,initialimage);
 image3.Canvas.CopyMode := cmSrcErase;
 image3.Canvas.CopyRect(copyimage,image3.canvas,initialimage);
 image2.Canvas.CopyMode := cmSrcErase;
 image2.Canvas.CopyRect(copyimage,image2.canvas,initialimage);
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
 SetTimer1;
 Application.CreateForm(TfrmAbout,frmAbout);
 frmAbout.ShowModal;
 frmAbout.Free;
 frmAbout := nil;
end;

procedure TMainForm.pgctrl1Change(Sender: TObject);
begin
 SetTimer1;
 If pgctrl1.ActivePage = tbshtNote then
  FinishedButton1Click(application);
end;

procedure TMainForm.BtnAddressClick(Sender: TObject);
begin
 SetTimer1;
 frmDemo.PtFirst.Text := Piece(PatientName,',',2);
 frmDemo.PtLast.Text := Piece(PatientName,',',1);
 frmDemo.PtMI.Text := Piece(PatientName,' ',2);
 frmDemo.PtStreet.Text := MainForm.P_Street;
 frmDemo.PtCity.Text := MainForm.P_City;
 frmDemo.PtState.Text := MainForm.P_State;
 frmDemo.PtZip.Text := MainForm.P_Zip;
 frmDemo.PtCountry.Text := 'USA';
 frmDemo.PtPhone.Text := MainForm.P_Phone;
 frmDemo.Showmodal;
end;

procedure TMainForm.CheckDFN;
var A : String;
begin
 SetTimer1;
 If Length(PatientSSN) > 9 then
  begin
   A := piece(PatientSSN,'-',1);
   A := A+piece(PatientSSN,'-',2);
   A := A+piece(PatientSSN,'-',3);
   PatientSSN := A;
  end;
 If not FIMBroker.Connected then ConnectBroker(application);
 If not FIMBroker.Connected then exit;
 FIMBroker.Param[0].PType := literal;
 FIMBroker.Param[0].Value := MainForm.PatientSSN;
 FIMBroker.RemoteProcedure := MainForm.GetDFNCall;
 Try
  FIMBroker.Call;
   {check for errors on return}
 except
  on E:EBrokerError do
   begin
    ShowMessage('Broker Error: '+E.Message);
    exit;
   end;
  on E:EAccessViolation do
   begin
    ShowMessage(E.Message);
    exit;
   end;
  else
   begin
    raise;
    exit;
   end;
 end;
 MainForm.PatientDFN := piece(FIMBroker.Results[0],'^',1);
 If (MainForm.PatientDFN = 'NO PATIENT REQUESTED') or  (MainForm.PatientDFN = 'INCORRECT SSN') then
  begin
  { MessageDlg(MainForm.PatientDFN+#13+#13+'Press OK to continue.',mtError,[mbOK],0); }
   SSNErrorFlag := true;
   Exit;
  end;
end;

procedure TMainForm.BTNImpGrpClick(Sender: TObject);
begin
 SetTimer1;
 if (sender = BTNImpGrp) or ((sender = edtImpGrp) and (pgctrl1.ActivePage = tbshtDx))  then
  begin
   if not edtImpGrp.Enabled then exit;
   edtImpGrp.Text := '';
   lstImpGrp.ItemIndex := -1;
   pnlImpGrp.BringToFront;
   lstImpGrp.SetFocus;
  end; 
end;

procedure TMainForm.FormatDate(Sender: TObject);
var A,B,C : string;
begin
 A := Piece(Datein,'/',1);
//  If Length(A) = 1 then A := '0'+A;
 B := Piece(Datein,'/',2);
  If Length(B) = 1 then B := '0'+B;
 C := Piece(Datein,'/',3);
 TEdit(Sender).Text := A+'/'+B+'/'+'20'+C;
 Datein := '';
end;

procedure TMainForm.dtpkr1Change(Sender: TObject);
begin
 SetTimer1;
 if not edtAdmit.Enabled then exit;
 if edtAdmit.Text = DatetoStr(dtpkr1.Date) then exit;
 edtAdmit.Text := DatetoStr(dtpkr1.Date);
 edtAdmitExit(edtAdmit);
end;

procedure TMainForm.dtpkr2Change(Sender: TObject);
begin
 SetTimer1;
 if not edtDC.Enabled then exit;
 if edtDC.Text = DatetoStr(dtpkr2.Date) then exit;
 edtDC.Text := DatetoStr(dtpkr2.Date);
 edtAdmitExit(edtDC);
 If ((FSODkey = '1') or (FSODkey = '2')) and (grpFacCode.Visible) and (edtDC.Text <> '') then
  begin
   If MessageDlg('Once you enter a discharge date and send the note, you will not be '+
   'able to add data to Admission, Interim, and Discharge assessments.'+
   #13+#13+'Do you wish to continue?',mtinformation,[mbyes,mbno],0) = mrno then
     edtDC.Text := '';
  end;                   
end;

procedure TMainForm.dtpkr3Change(Sender: TObject);
begin
 SetTimer1;
 if not edTrDt1.Enabled then exit;
 if edTrDt1.Text = DatetoStr(dtpkr3.Date) then exit;
 edTrDt1.Text := DatetoStr(dtpkr3.Date);
 edtAdmitExit(edTrDt1);
end;

procedure TMainForm.dtpkr4Change(Sender: TObject);
begin
 if not edTrDt2.Enabled then exit;
 if edTrDt2.Text = DatetoStr(dtpkr4.Date) then exit;
 edTrDt2.Text := DatetoStr(dtpkr4.Date);
 edtAdmitExit(edTrDt2);
end;

procedure TMainForm.dtpkr5Change(Sender: TObject);
begin
 if not edTrDt3.Enabled then exit;
 if edTrDt3.Text = DatetoStr(dtpkr5.Date) then exit;
 edTrDt3.Text := DatetoStr(dtpkr5.Date);
 edtAdmitExit(edTrDt3);
end;

procedure TMainForm.dtpkr6Change(Sender: TObject);
begin
 if not edtRtDt1.Enabled then exit;
 if edtRtDt1.Text = DatetoStr(dtpkr6.Date) then exit;
 edtRtDt1.Text := DatetoStr(dtpkr6.Date);
 edtAdmitExit(edtRtDt1);
 if edTrDt1.Text = '' then
  begin
   MessageDlg('Please enter the transfer date first.',mterror,[mbok],0);
   edtRtDt1.Text := '';
  end;
end;

procedure TMainForm.dtpkr7Change(Sender: TObject);
begin
 if not edtRtDt2.Enabled then exit;
 if edtRtDt2.Text = DatetoStr(dtpkr7.Date) then exit;
 edtRtDt2.Text := DatetoStr(dtpkr7.Date);
 edtAdmitExit(edtRtDt2);
 if edTrDt2.Text = '' then
  begin
   MessageDlg('Please enter the transfer date first.',mterror,[mbok],0);
   edtRtDt2.Text := '';
  end;
end;

procedure TMainForm.dtpkr8Change(Sender: TObject);
begin
 if not edtRtDt3.Enabled then exit;
 if edtRtDt3.Text = DatetoStr(dtpkr8.Date) then exit;
 edtRtDt3.Text := DatetoStr(dtpkr8.Date);
 edtAdmitExit(edtRtDt3);
 if edTrDt3.Text = '' then
  begin
   MessageDlg('Please enter the transfer date first.',mterror,[mbok],0);
   edtRtDt3.Text := '';
  end;
end;

procedure TMainForm.dtpkr9Change(Sender: TObject);
begin
 if not edtOnsetDt.Enabled then exit;
 if edtOnsetDt.Text = DatetoStr(dtpkr9.Date) then exit;
 edtOnsetDt.Text := DatetoStr(dtpkr9.Date);
 edtAdmitExit(edtOnsetDt);
end;

procedure TMainForm.FindCPT(Sender: TObject);
var A,Cpt : string;
    I : Integer;
begin
 If frmLookup = nil then
  Application.Createform(TfrmLookup,frmLookup);
 frmLookup.Label1.Caption := 'Search for Diagnosis';
 frmLookup.Edit1.Text := '';
 frmLookup.ListBox1.Clear;
 frmLookup.ShowModal;
 If (frmLookup.ModalResult = mrok) and (frmLookup.ListBox1.ItemIndex > -1) then
  begin
   Cpt := frmLookup.ListBox1.Items[frmLookup.ListBox1.ItemIndex];
   x := pos('(',Cpt);
   y := pos(')',Cpt);
   A := '';
   For i := x+1 to y-1 do
    A := A+Cpt[i];
   Cpt := Piece(A ,' ',2);
   If pos('/',Cpt) > 0 then
    Cpt := Piece(Cpt,'/',1);
   TEdit(Sender).Text := Cpt; 
  end;
 frmLookup.Free;
 frmLookup := nil;
end;

procedure TMainForm.BTNETDiagClick(Sender: TObject);
begin
 if not edtEtDiag.Enabled then exit;
 FindCPT(edtEtDiag);
end;

procedure TMainForm.BTNDiag1Click(Sender: TObject);
begin
 if not edtDiag1.Enabled then exit;
 FindCPT(edtDiag1);
end;

procedure TMainForm.BTNDiag2Click(Sender: TObject);
begin
 if not edtDiag2.Enabled then exit;
 FindCPT(edtDiag2);
end;

procedure TMainForm.BTNDiag3Click(Sender: TObject);
begin
 if not edtDiag3.Enabled then exit;
 FindCPT(edtDiag3);
end;

procedure TMainForm.BTNDiag4Click(Sender: TObject);
begin
 if not edtDiag4.Enabled then exit;
 FindCPT(edtDiag4);
end;

procedure TMainForm.BTNDiag5Click(Sender: TObject);
begin
 if not edtDiag5.Enabled then exit;
 FindCPT(edtDiag5);
end;

procedure TMainForm.BTNDiag6Click(Sender: TObject);
begin
 if not edtDiag6.Enabled then exit;
 FindCPT(edtDiag6);
end;

procedure TMainForm.BTNDiag7Click(Sender: TObject);
begin
 if not edtDiag7.Enabled then exit;
 FindCPT(edtDiag7);
end;

procedure TMainForm.SetGraphBtn;
begin
 SetTimer1;
// If (chkAdmit.Checked)   or (chkDC.Checked) or
//    (chkInterim.Checked) or (chkFU.Checked) or (edTotalG.Text <> '0') then
  BtnGraph.Visible := true
// else
//  BtnGraph.Visible := false;
end;

procedure TMainForm.SendEMAIL;
var
 y: Integer;
 A,B: string;
begin
 B := '';
 B := copy(PatientName,1,1);
 B := B+copy(PatientSSN,6,4);
 mem3.clear;
 mem3.lines.add('Patient: '+PatientName+' ('+B+')');
 mem3.lines.add(' ');
 A := '';
 If chkAdmit.Checked then A := A+'Admission, ';   //admission
 If chkInterim.Checked then A := A+'Interim, ';  //interim
 If chkDC.Checked then A := A+'Discharge, ';     //discharge
 If chkFU.Checked then A := A+'Follow Up, ';     //FU
 If A = '' then  A := A+'Other, ';              //default
 A[Length(A)-1] := ' ';
 if not FIMBroker.Connected then
  begin
   ConnectBroker(application);
   if not FIMBroker.Connected then exit;
  end;
 If MailMsgnum = '' then
  mem3.lines.add('Progress note entered.');
 If MailMsgnum <> '' then
  mem3.lines.add('Addendum entered.');
 mem3.lines.add(' ');
 mem3.lines.add('  '+'Facility Code: '+cbxFacilityCodes.Text);
 mem3.lines.add('  '+lblDX1.Caption+': '+edtAdmit.Text);
 mem3.lines.add('  '+'Assessment Type: '+A);

{ call broker to send EMail to FIM MailGroup}
 FIMBroker.Param[0].PType := literal;
 FIMBroker.Param[0].Value := 'FIM Data Entered'+'^'+'G.'+UpperCase(FSODMailGroup)+'^'+ MailMsgnum;
 FIMBroker.Param[1].Value := '.X';
 FIMBroker.Param[1].PType := List;
 for Y := 0 to mem3.Lines.Count - 1 do
 FIMBroker.Param[1].Mult.Assign(mem3.Lines);
 FIMBroker.RemoteProcedure := SendEMailCall;
 Try
  FIMBroker.Call;
   {check for errors on return}
 except
  on E:EBrokerError do
   begin
    ShowMessage('Broker Error: '+E.Message);
    exit;
   end;
  on E:EAccessViolation do
   begin
    ShowMessage(E.Message);
    exit;
   end;
  else
   begin
    raise;
    exit;
   end;
 end;
    //
      //      -1 is bad piece 2 is message
        //
      //       1 is good piece 2 is number for new msg num or blank if reply to old msg
    //
 If Piece(FIMBroker.Results[0],'^',1) = '1' then
  begin
   MessageDlg('EMail sent to FSOD Coordinator.',mtinformation,[mbok],0);
   If (Piece(FIMBroker.Results[0],'^',1) = '1') and
      (Piece(FIMBroker.Results[0],'^',2) <> '') then
    MailMsgnum := Piece(FIMBroker.Results[0],'^',2);
  end;
 If Piece(FIMBroker.Results[0],'^',1) = '-1' then
   MessageDlg('EMail not sent to FSOD Coordinator.'+#13+#13+
              Piece(FIMBroker.Results[0],'^',2),mtinformation,[mbok],0);
end;

procedure TMainForm.BtnG_GClick(Sender: TObject);
var
 InitialImage, CopyImage: Trect;
begin
 InitialImage := Rect(0,0,281,281);
 CopyImage := Rect(0,0,281,281);
 image6.Canvas.CopyMode := cmSrcErase;
 image6.Canvas.CopyRect(copyimage,image6.canvas,initialimage);

 if graph5=false then
  begin
   InitializeCoordinates(5);
   image6.Canvas.Pen.Color := clAqua;
   image6.Canvas.Polyline([point(Ax,Ay), point(Bx,By), point(Cx,Cy),
                          point(Dx,Dy), point(Ex,Ey), point(Fx,Fy),
                          point(Gx,Gy), point(Hx,Hy), point(Ix,Iy),
                          point(Jx,Jy), point(Kx,Ky), point(Lx,Ly),
                          point(Mx,My), point(Nx,Ny), point(Ox,Oy),
                          point(Px,Py), point(Qx,Qy), point(Rx,Ry),
                          point(Ax,Ay)]);
   image6.Canvas.Brush.Color := clAqua;
   image6.Canvas.brush.style := bsSolid;
   image6.Canvas.FloodFill(141,140,clAqua,fsborder);
   image6.BringToFront;
   graph5:=true;
  end; 
//  end
// else graph5:=false;
 graph5:=false;
 finishgraph;
end;

procedure TMainForm.BtnReturnClick(Sender: TObject);
begin
 pnlImpGrp.SendToBack;
end;

procedure TMainForm.lstImpGrpClick(Sender: TObject);
var A,A1 : string;
    x,y : integer;
begin
 If lstImpGrp.ItemIndex > 1 then
  begin
   A := Piece(lstImpGrp.Items[lstImpGrp.ItemIndex],' -',1);
   If (A = '1')   or (A = '2')   or (A = '3')   or (A = '4')    or (A = '5')    or
      (A = '6')   or (A = '7')   or (A = '8')   or (A = '10')   or (A = '12')   or
      (A = '14')  or (A = '17')  or (A = '8.1') or (A = '8.5')  or (A = '8.6')  or
      (A = '8.7') or (A = '4.1') or (A = '4.2') or (A = '17.3') or (A = '17.5') then
    begin
     MessageDlg('You may not select this item.  Please select another.',mtinformation,[mbok],0);
     lstImpGrp.ItemIndex := -1;
     exit;
    end;
   A1 := Copy(A,1,3);
   If A1 = '4.2' then
    cbxASIA.Enabled := true
   else
    begin
     cbxASIA.Text := '';
     cbxASIA.Enabled := false;
    end;
   A                 := Piece(lstImpGrp.Items[lstImpGrp.ItemIndex],' -',2);
   edtImpGrp.Text    := Piece(lstImpGrp.Items[lstImpGrp.ItemIndex],' -',1);
   y := 0;
   for x := 1 to Length(A) do
    begin
     if A[x] = ' ' then
      continue;
     y := x;
     break;
    end;
   if y > 0 then
    edtImpGrptxt.Text := Copy(A,y,length(A)-y);
   pnlImpGrp.SendToBack;
   edtOnsetDt.SetFocus;
  end;
end;

procedure TMainForm.SendDatatoFSOD;
var A,B,C,D,E,F,G,H,I,J,Dt,D1 : String;
    x : Integer;
begin
 If not FIMBroker.Connected then ConnectBroker(application);
 If not FIMBroker.Connected then exit;
 A := ''; B := ''; C := ''; D := ''; E := ''; F := ''; G := ''; H := '';
 I := ''; J := ''; Dt := ''; D1 := '';
 lstFSODout.Clear;
 If (PN_IEN = '') and (NewPN_IEN <> '') then
  PN_IEN := NewPN_IEN;
//check discharge and transfer/return dates replace blank with @
 If edtDC.Text    = '' then edtDC.Text    := '@';
 If edTrDt1.Text  = '' then edTrDt1.Text  := '@';
 If edTrDt2.Text  = '' then edTrDt2.Text  := '@';
 If edTrDt3.Text  = '' then edTrDt3.Text  := '@';
 If edtRtDt1.Text = '' then edtRtDt1.Text := '@';
 If edtRtDt2.Text = '' then edtRtDt2.Text := '@';
 If edtRtDt3.Text = '' then edtRtDt3.Text := '@';
//collect data
//   required fields    0.01
 A := RecType+'^'+CaseIEN+'^'+PatientDFN+'^'+edtPtCode.Text+'^'+edtDob.Text+'^'+
      Piece(cbxFacilityCodes.Items[cbxFacilityCodes.ItemIndex],'-',1)+'^'+
      Piece(lstFacilityCodes.Items[cbxFacilityCodes.ItemIndex],'^',1)+'^'+
      edtImpGrp.Text+'^'+edtOnsetDt.Text+'^'+edtAdmit.Text+'^'+edtDC.Text+'^'+PN_IEN+'^'+MailMsgNum;
//   address data       1.01
 B := P_Street+'^'+P_City+'^'+P_State+'^'+P_Zip+'^'+P_Phone+'^'+
      Piece(cbxGender.Text,'-',1)+'^'+Piece(cbxEthnic.Text,'-',1)+'^'+
      Piece(cbxMarStat.Text,'-',1)+'^'+Piece(cbxMilStat.Text,'-',1);
//   case data          2.01
 C := Piece(cbxAdmitClass.Text,'-',1)+'^^';
     If chkInterrupt.Checked then
      C := C+'1'+'^'
     else
      C := C+'2'+'^';
     C := C+edTrDt1.Text+'^'+edtRtDt1.Text+'^'+edTrDt2.Text+'^'+
        edtRtDt2.Text+'^'+edTrDt3.Text+'^'+edtRtDt3.Text+'^';
     C := C+edtEtDiag.Text+'^'+Piece(cbxASIA.Text,'-',1);
//   diagnoses           3.01
 D := edtDiag1.Text+'^'+edtDiag2.Text+'^'+edtDiag3.Text+'^'+edtDiag4.Text+'^'+
      edtDiag5.Text+'^'+edtDiag6.Text+'^'+edtDiag7.Text;
//   FIM admission       4.01
 E := edtSEC1.Text+'^' +edtSec2.Text+'^'+edtSec3.Text +'^'+edtSec4.Text +'^'+edtSec5.Text+'^'+
      edtSec6.Text+'^' +edtSpc1.Text+'^'+edtSpc2.Text +'^'+edtTr1.Text  +'^'+edtTr2.Text+'^'+
      edtTr3.Text+'^' +edtLoco1.Text+'^'+edtLoco2.Text+'^'+edtComm1.Text+'^'+edtComm2.Text+'^'+
      edtSC1.Text+'^' +edtSC2.Text  +'^'+edtSC3.Text+'^';
      If cbxA1.Checked then E := E+'W'+'^';
      If cbxA2.Checked then E := E+'C'+'^';
      If cbxA3.Checked then E := E+'B'+'^';
      If (not cbxA1.Checked) and (not cbxA2.Checked) and (not cbxA3.Checked) then
       E := E+'^';
      If cbxA4.Checked then E := E+'A'+'^';
      If cbxA5.Checked then E := E+'V'+'^';
      If cbxA6.Checked then E := E+'B'+'^';
      If (not cbxA4.Checked) and (not cbxA5.Checked) and (not cbxA6.Checked) then
       E := E+'^';
      If cbxA7.Checked then E := E+'V';
      If cbxA8.Checked then E := E+'N';
      If cbxA9.Checked then E := E+'B';
      If (not cbxA7.Checked) and (not cbxA8.Checked) and (not cbxA9.Checked) then
       E := E+'^';
//   FIM discharge       5.01
 F := edtSec1D.Text+'^'+edtSec2D.Text +'^'+edtSec3D.Text +'^'+edtSec4D.Text +'^'+edtSec5D.Text+'^'+
      edtSec6D.Text+'^'+edtSpc1D.Text +'^'+edtSpc2D.Text +'^'+edtTr1D.Text +'^'+edtTr2D.Text+'^'+
      edtTr3D.Text +'^'+edtLoco1D.Text+'^'+edtLoco2D.Text+'^'+edtComm1D.Text+'^'+edtComm2D.Text+'^'+
      edtSC1D.Text +'^'+edtSC2D.Text  +'^'+edtSC3D.Text  +'^';
      If cbxD1.Checked then F := F+'W'+'^';
      If cbxD2.Checked then F := F+'C'+'^';
      If cbxD3.Checked then F := F+'B'+'^';
      If (not cbxD1.Checked) and (not cbxD2.Checked) and (not cbxD3.Checked) then
       F := F+'^';
      If cbxD4.Checked then F := F+'A'+'^';
      If cbxD5.Checked then F := F+'V'+'^';
      If cbxD6.Checked then F := F+'B'+'^';
      If (not cbxD4.Checked) and (not cbxD5.Checked) and (not cbxD6.Checked) then
       F := F+'^';
      If cbxD7.Checked then F := F+'V';
      If cbxD8.Checked then F := F+'N';
      If cbxD9.Checked then F := F+'B';
      If (not cbxD7.Checked) and (not cbxD8.Checked) and (not cbxD9.Checked) then
       F := F+'^';
//   FIM interim         6.01
 G := edtSec1i.Text+'^'+edtSec2i.Text +'^'+edtSec3i.Text +'^'+edtSec4i.Text +'^'+edtSec5i.Text+'^'+
      edtSec6i.Text+'^'+edtSpc1i.Text +'^'+edtSpc2i.Text +'^'+edtTr1i.Text  +'^'+edtTr2i.Text+'^'+
      edtTr3i.Text +'^'+edtLoco1i.Text+'^'+edtLoco2i.Text+'^'+edtComm1i.Text+'^'+edtComm2i.Text+'^'+
      edtSC1i.Text +'^'+edtSC2i.Text  +'^'+edtSC3i.Text  +'^';
      If cbxI1.Checked then G := G+'W'+'^';
      If cbxI2.Checked then G := G+'C'+'^';
      If cbxI3.Checked then G := G+'B'+'^';
      If (not cbxI1.Checked) and (not cbxI2.Checked) and (not cbxI3.Checked) then
       G := G+'^';
      If cbxI4.Checked then G := G+'A'+'^';
      If cbxI5.Checked then G := G+'V'+'^';
      If cbxI6.Checked then G := G+'B'+'^';
      If (not cbxI4.Checked) and (not cbxI5.Checked) and (not cbxI6.Checked) then
       G := G+'^';
      If cbxI7.Checked then G := G+'V';
      If cbxI8.Checked then G := G+'N';
      If cbxI9.Checked then G := G+'B';
      If (not cbxI7.Checked) and (not cbxI8.Checked) and (not cbxI9.Checked) then
       G := G+'^';
//   FIM follow up       7.01
 H := edtSec1FU.Text+'^'+edtSec2FU.Text +'^'+edtSec3FU.Text +'^'+edtSec4FU.Text +'^'+edtSec5FU.Text+'^'+
      edtSec6FU.Text+'^'+edtSpc1FU.Text +'^'+edtSpc2FU.Text +'^'+edtTr1FU.Text  +'^'+edtTr2FU.Text+'^'+
      edtTr3FU.Text +'^'+edtLoco1FU.Text+'^'+edtLoco2FU.Text+'^'+edtComm1FU.Text+'^'+edtComm2FU.Text+'^'+
      edtSC1FU.Text +'^'+edtSC2FU.Text  +'^'+edtSC3FU.Text  +'^';
      If cbxF1.Checked then H := H+'W'+'^';
      If cbxF2.Checked then H := H+'C'+'^';
      If cbxF3.Checked then H := H+'B'+'^';
      If (not cbxF1.Checked) and (not cbxF2.Checked) and (not cbxF3.Checked) then
       H := H+'^';
      If cbxF4.Checked then H := H+'A'+'^';
      If cbxF5.Checked then H := H+'V'+'^';
      If cbxF6.Checked then H := H+'B'+'^';
      If (not cbxF4.Checked) and (not cbxF5.Checked) and (not cbxF6.Checked) then
       H := H+'^';
      If cbxF7.Checked then H := H+'V';
      If cbxF8.Checked then H := H+'N';
      If cbxF9.Checked then H := H+'B';
      If (not cbxF7.Checked) and (not cbxF8.Checked) and (not cbxF9.Checked) then
       H := H+'^';
//   FIM goals           8.01
 J := edtSec1G.Text+'^'+edtSec2G.Text +'^'+edtSec3G.Text +'^'+edtSec4G.Text+'^'+edtSec5G.Text+'^'+
      edtSec6G.Text+'^'+edtSpc1G.Text +'^'+edtSpc2G.Text +'^'+edtTr1G.Text+'^'+edtTr2G.Text+'^'+
      edtTr3G.Text +'^'+edtLoco1G.Text+'^'+edtLoco2G.Text+'^'+edtComm1G.Text+'^'+edtComm2G.Text+'^'+
      edtSC1G.Text +'^'+edtSC2G.Text  +'^'+edtSC3G.Text  +'^';
      If cbxG1.Checked then J := J+'W'+'^';
      If cbxG2.Checked then J := J+'C'+'^';
      If cbxG3.Checked then J := J+'B'+'^';
      If (not cbxG1.Checked) and (not cbxG2.Checked) and (not cbxG3.Checked) then
       J := J+'^';
      If cbxG4.Checked then J := J+'A'+'^';
      If cbxG5.Checked then J := J+'V'+'^';
      If cbxG6.Checked then J := J+'B'+'^';
      If (not cbxG4.Checked) and (not cbxG5.Checked) and (not cbxG6.Checked) then
       J := J+'^';
      If cbxG7.Checked then J := J+'V';
      If cbxG8.Checked then J := J+'N';
      If cbxG9.Checked then J := J+'B';
      If (not cbxG7.Checked) and (not cbxG8.Checked) and (not cbxG9.Checked) then
       J := J+'^';
//load data
 lstFSODout.Items.Add(A);
 lstFSODout.Items.Add(B);
 lstFSODout.Items.Add(C);
 lstFSODout.Items.Add(D);
 lstFSODout.Items.Add(E);
 lstFSODout.Items.Add(F);
 lstFSODout.Items.Add(G);
 lstFSODout.Items.Add(H);
 lstFSODout.Items.Add(J);
// add case notes
 If memPrevious.Lines.Count > 0 then
  for x := 0 to memPrevious.Lines.Count-1 do
   lstFSODout.Items.Add(memPrevious.Lines[x]);
 If memCurrent.Lines.Count > 0 then
  begin
   lstFSODout.Items.Add(' ');
   for x := 0 to memCurrent.Lines.Count-1 do
    lstFSODout.Items.Add(memCurrent.Lines[x]);
  end;
//send data
 FIMBroker.Param[0].PType := List;
 FIMBroker.Param[0].Value := '.X';
 For x := 0 to MainForm.lstFSODout.Items.count-1 do
  FIMBroker.Param[0].Mult[InttoStr(x+1)] := MainForm.lstFSODout.Items[x];
 FIMBroker.RemoteProcedure := MainForm.SaveFSOD;
 Try
  FIMBroker.Call;
   {check for errors on return}
 except
  on E:EBrokerError do
   begin
    ShowMessage('Broker Error: '+E.Message);
    exit;
   end;
  on E:EAccessViolation do
   begin
    ShowMessage(E.Message);
    exit;
   end;
  else
   begin
    raise;
    exit;
   end;
 end;
// check errors
 A := FIMBroker.Results[0];
 try
  x := StrtoInt(A);
  if x < 0 then
   MessageDlg(Piece(A,'^',2),mterror,[mbok],0);
 except
 end;
   {unlock patient - only 1 new episode can be in progress at a time}
 FIMBroker.Param[0].PType := literal;
 FIMBroker.Param[0].Value := PatientDFN;
 FIMBroker.RemoteProcedure := LockPatient;
 Try
  FIMBroker.Call;
   {check for errors on return}
 except
  on E:EBrokerError do
   begin
    ShowMessage('Broker Error: '+E.Message);
    exit;
   end;
  on E:EAccessViolation do
   begin
    ShowMessage(E.Message);
    exit;
   end;
  else
   begin
    raise;
    exit;
   end;
 end;
 If Piece(FIMBroker.Results[0],'^',1) = '-1' then
  MessageDlg('Unable to unlock the patient'' record.',mterror,[mbok],0);
//clear discharge and transfer/return dates
 If edtDC.Text    = '@' then edtDC.Text    := '';
 If edTrDt1.Text  = '@' then edTrDt1.Text  := '';
 If edTrDt2.Text  = '@' then edTrDt2.Text  := '';
 If edTrDt3.Text  = '@' then edTrDt3.Text  := '';
 If edtRtDt1.Text = '@' then edtRtDt1.Text := '';
 If edtRtDt2.Text = '@' then edtRtDt2.Text := '';
 If edtRtDt3.Text = '@' then edtRtDt3.Text := '';
end;

procedure TMainForm.edtPtCodeClick(Sender: TObject);
begin
 grpAssess.Visible := false;
 If cbxFacilityCodes.Text <> '' then
  begin
   GetEpisodes;
   grpEpisodes.Visible := true;
  end
 else
  grpEpisodes.Visible := false;
 If Piece(cbxFacilityCodes.Text,'-',2) = 'Continuum of Care' then
  begin
   lblDX1.Caption := 'Therapy Start Date';
   lblDX3.Caption := 'Therapy End Date';
  end
 else
  begin
   lblDX1.Caption := 'Rehab Bed Unit Admission';
   lblDX3.Caption := 'Rehab Bed Unit Discharge';
  end;
end;

procedure TMainForm.GetEpisodes;
var Line1 : string[60];
    x : Integer;
begin
 lstEpisodes.Clear;
 lstinvEpisodes.Clear;
 If PatientDFN = '' then
  CheckDFN;
 Try
 FIMBroker.Param[0].PType := literal;
 FIMBroker.Param[0].Value := PatientDFN+'^'+Piece(cbxFacilityCodes.Text,'-',1);
 FIMBroker.RemoteProcedure := GetCases;
 Try
  FIMBroker.Call;
   {check for errors on return}
 except
  on E:EBrokerError do
   begin
    ShowMessage('Broker Error: '+E.Message);
    exit;
   end;
  on E:EAccessViolation do
   begin
    ShowMessage(E.Message);
    exit;
   end;
  else
   begin
    raise;
    exit;
   end;
 end;
 // results in order     CASE_IEN, PatientDFN, Facility Code, Admit Date, Discharge Date
 FIMAppSpecific.ParamCount      := StrtoInt(FIMBroker.Results[0]);
 If FIMAppSpecific.ParamCount > 0 then
  For x := 1 to FIMAppSpecific.ParamCount do
   lstinvEpisodes.Items.Add(FIMBroker.Results[x]);
 For x := 0 to lstinvEpisodes.Items.Count-1 do
  begin
   Line1 := '                                       ';
   Insert(Piece(lstinvEpisodes.Items[x],'^',3),Line1,1);
   Insert(Piece(lstinvEpisodes.Items[x],'^',4),Line1,14);
   Insert(Piece(lstinvEpisodes.Items[x],'^',5),Line1,29);
   lstEpisodes.Items.Add(Line1);
  end;
 except
 end;
 lstEpisodes.Items.Add('Enter New Episode');
end;

procedure TMainForm.lstEpisodesClick(Sender: TObject);
begin
 ClearComponents(lstEpisodes);
 tbshtNote.TabVisible := true;
 tbshtGoal.TabVisible := true;
 tbshtCase.TabVisible := true;
 tbshtDx.TabVisible   := true;
 If lstEpisodes.ItemIndex = -1 then exit;
 If lstEpisodes.Items[lstEpisodes.ItemIndex] = 'Enter New Episode' then
  begin
     {lock patient - only 1 new episode can be in progress at a time}
   FIMBroker.Param[0].PType := literal;
   FIMBroker.Param[0].Value := PatientDFN+'^1';
   FIMBroker.RemoteProcedure := LockPatient;
   Try
    FIMBroker.Call;
     {check for errors on return}
   except
    on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
      ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
   end;
   If Piece(FIMBroker.Results[0],'^',1) = '-1' then
    begin
     MessageDlg('Another user is currently entering a New Episode for this patient.'+#13+
                'Please try again later.',mterror,[mbok],0);
     exit;
    end;
   chkAdmit.Visible   := true;
   chkDC.Visible      := true;
   chkInterim.Visible := true;
   chkFU.Visible      := false;
   chkNOMS.Visible    := false;
   grpAssess.Visible := true;
   RecType := 'A';
   exit;
  end;

 lstinvLBCase.Clear;
 FIMBroker.Param[0].PType := literal;
 FIMBroker.Param[0].Value := Piece(lstinvEpisodes.Items[lstEpisodes.ItemIndex],'^',1);
 FIMBroker.RemoteProcedure := GetSelectedCase;
 Try
  FIMBroker.Call;
   {check for errors on return}
 except
  on E:EBrokerError do
   begin
    ShowMessage('Broker Error: '+E.Message);
    exit;
   end;
  on E:EAccessViolation do
   begin
    ShowMessage(E.Message);
    exit;
   end;
  else
   begin
    raise;
    exit;
   end;
 end;
 lstinvLBCase.Items := FIMBroker.Results;
 If Piece(lstinvLBCase.Items[0],'^',2) <> Piece(lstinvEpisodes.Items[lstEpisodes.ItemIndex],'^',1) then
  begin
   MessageDlg(Piece(lstinvLBCase.Items[0],'^',2),mterror,[mbok],0);
   exit;
  end;
 PopulateFormData;

 RecType := 'E';
 If Piece(lstinvEpisodes.Items[lstEpisodes.ItemIndex],'^',2) <> '' then
   chkAdmit.Visible   := false
 else
   chkAdmit.Visible   := true;
 If Piece(lstinvEpisodes.Items[lstEpisodes.ItemIndex],'^',4) <> '' then
  begin
    chkAdmit.Visible   := true;
    chkDC.Visible      := true;
    chkFU.Visible      := false;
    chkInterim.Visible := true;
//    cbNOMS.Visible    := true;
  end;
 If Piece(lstinvEpisodes.Items[lstEpisodes.ItemIndex],'^',5) <> '' then
  begin
    chkAdmit.Visible   := false;
    chkDC.Visible      := false;
    chkInterim.Visible := false;
    chkFU.Visible      := true;
//    cbNOMS.Visible    := true;
  end;
 grpAssess.Visible  := true;
 SetReadOnly(application);
 if FSODkey = '2' then
  begin
   Edit1.Visible := true;
   Edit2.Enabled := true;
   Save1.Enabled := false;
  end
 else
  Edit1.Visible := false;
end;

procedure TMainForm.PopulateFormData;
var x, y : Integer;
begin
 Screen.Cursor := crHourglass;
 x := 0;
  CaseIEN         := Piece(lstinvLBCase.Items[x],'^',2);
  edtImpGrp.Text  := Piece(lstinvLBCase.Items[x],'^',8);
  edtOnsetDt.Text := Piece(lstinvLBCase.Items[x],'^',9);
  edtAdmit.Text   := Piece(lstinvLBCase.Items[x],'^',10);
  edtDC.Text      := Piece(lstinvLBCase.Items[x],'^',11);
  PN_IEN          := Piece(lstinvLBCase.Items[x],'^',12);
  MailMsgNum      := Piece(lstinvLBCase.Items[x],'^',13);

 x := 1;
  P_Street := Piece(lstinvLBCase.Items[x],'^',1);
  P_City := Piece(lstinvLBCase.Items[x],'^',2);
  P_State := Piece(lstinvLBCase.Items[x],'^',3);
  P_Zip := Piece(lstinvLBCase.Items[x],'^',4);
  P_Phone := Piece(lstinvLBCase.Items[x],'^',5);
  if Piece(lstinvLBCase.Items[x],'^',6) <> '' then
   cbxGender.Text :=  cbxGender.Items[StrtoInt(Piece(lstinvLBCase.Items[x],'^',6))-1];
  if Piece(lstinvLBCase.Items[x],'^',7) <> '' then
   cbxEthnic.Text :=  cbxEthnic.Items[StrtoInt(Piece(lstinvLBCase.Items[x],'^',7))-1];
  if Piece(lstinvLBCase.Items[x],'^',8) <> '' then
//   cbxGender.Text := cbxGender.Items[StrtoInt(Piece(lstinvLBCase.Items[x],'^',8))-1];
   cbxMarStat.Text := cbxMarStat.Items[StrtoInt(Piece(lstinvLBCase.Items[x],'^',8))-1];
  if Piece(lstinvLBCase.Items[x],'^',9) = 'A' then
  cbxMilStat.Text := cbxMilStat.Items[0];
  if Piece(lstinvLBCase.Items[x],'^',9) = 'N' then
  cbxMilStat.Text := cbxMilStat.Items[1];
 x := 2;
  if Piece(lstinvLBCase.Items[x],'^',1) <> '' then
  cbxAdmitClass.Text := cbxAdmitClass.Items[StrtoInt(Piece(lstinvLBCase.Items[x],'^',1))];
  if Piece(lstinvLBCase.Items[x],'^',3) = '1' then
   chkInterrupt.Checked := true;
  if Piece(lstinvLBCase.Items[x],'^',3) = '2' then
   chkInterrupt.Checked := false;
  edTrDt1.Text   := Piece(lstinvLBCase.Items[x],'^',4);
  edtRtDt1.Text  := Piece(lstinvLBCase.Items[x],'^',5);
  edTrDt2.Text   := Piece(lstinvLBCase.Items[x],'^',6);
  edtRtDt2.Text  := Piece(lstinvLBCase.Items[x],'^',7);
  edTrDt3.Text   := Piece(lstinvLBCase.Items[x],'^',8);
  edtRtDt3.Text  := Piece(lstinvLBCase.Items[x],'^',9);
  edtEtDiag.Text := Piece(lstinvLBCase.Items[x],'^',10);
  cbxASIA.Text   := Piece(lstinvLBCase.Items[x],'^',11);
  for y := 0 to cbxASIA.Items.Count-1 do
   if cbxASIA.Text = Piece(cbxASIA.Items[y],'-',1) then
    begin
     cbxASIA.Text := cbxASIA.Items[y];
     cbxASIA.ItemIndex := y;
    end;
 x := 3;
 edtDiag1.Text := Piece(lstinvLBCase.Items[x],'^',1);
 edtDiag2.Text := Piece(lstinvLBCase.Items[x],'^',2);
 edtDiag3.Text := Piece(lstinvLBCase.Items[x],'^',3);
 edtDiag4.Text := Piece(lstinvLBCase.Items[x],'^',4);
 edtDiag5.Text := Piece(lstinvLBCase.Items[x],'^',5);
 edtDiag6.Text := Piece(lstinvLBCase.Items[x],'^',6);
 edtDiag7.Text := Piece(lstinvLBCase.Items[x],'^',7);
//   FIM admission       4.01
 x := 4;
 edtSec1.Text := '';
 edtSEC1.Text  := Piece(lstinvLBCase.Items[x],'^',1);
 edtSec2.Text  := Piece(lstinvLBCase.Items[x],'^',2);
 edtSec3.Text  := Piece(lstinvLBCase.Items[x],'^',3);
 edtSec4.Text  := Piece(lstinvLBCase.Items[x],'^',4);
 edtSec5.Text  := Piece(lstinvLBCase.Items[x],'^',5);
 edtSec6.Text  := Piece(lstinvLBCase.Items[x],'^',6);
 edtSpc1.Text  := Piece(lstinvLBCase.Items[x],'^',7);
 edtSpc2.Text  := Piece(lstinvLBCase.Items[x],'^',8);
 edtTr1.Text   := Piece(lstinvLBCase.Items[x],'^',9);
 edtTr2.Text   := Piece(lstinvLBCase.Items[x],'^',10);
 edtTr3.Text   := Piece(lstinvLBCase.Items[x],'^',11);
 edtLoco1.Text := Piece(lstinvLBCase.Items[x],'^',12);
 edtLoco2.Text := Piece(lstinvLBCase.Items[x],'^',13);
 edtComm1.Text := Piece(lstinvLBCase.Items[x],'^',14);
 edtComm2.Text := Piece(lstinvLBCase.Items[x],'^',15);
 edtSC1.Text   := Piece(lstinvLBCase.Items[x],'^',16);
 edtSC2.Text   := Piece(lstinvLBCase.Items[x],'^',17);
 edtSC3.Text   := Piece(lstinvLBCase.Items[x],'^',18);
 if Piece(lstinvLBCase.Items[x],'^',19) = 'W' then
  cbxA1.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',19) = 'C' then
  cbxA2.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',19) = 'B' then
  cbxA3.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',20) = 'A' then
  cbxA4.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',20) = 'V' then
  cbxA5.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',20) = 'B' then
  cbxA6.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',21) = 'V' then
  cbxA7.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',21) = 'N' then
  cbxA8.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',21) = 'B' then
  cbxA9.Checked := true;
//   FIM discharge       5.01
 x := 5;
 edtSec1d.Text  := Piece(lstinvLBCase.Items[x],'^',1);
 edtSec2d.Text  := Piece(lstinvLBCase.Items[x],'^',2);
 edtSec3d.Text  := Piece(lstinvLBCase.Items[x],'^',3);
 edtSec4d.Text  := Piece(lstinvLBCase.Items[x],'^',4);
 edtSec5d.Text  := Piece(lstinvLBCase.Items[x],'^',5);
 edtSec6d.Text  := Piece(lstinvLBCase.Items[x],'^',6);
 edtSpc1d.Text  := Piece(lstinvLBCase.Items[x],'^',7);
 edtSpc2d.Text  := Piece(lstinvLBCase.Items[x],'^',8);
 edtTr1d.Text   := Piece(lstinvLBCase.Items[x],'^',9);
 edtTr2d.Text   := Piece(lstinvLBCase.Items[x],'^',10);
 edtTr3d.Text   := Piece(lstinvLBCase.Items[x],'^',11);
 edtLoco1d.Text := Piece(lstinvLBCase.Items[x],'^',12);
 edtLoco2d.Text := Piece(lstinvLBCase.Items[x],'^',13);
 edtComm1d.Text := Piece(lstinvLBCase.Items[x],'^',14);
 edtComm2d.Text := Piece(lstinvLBCase.Items[x],'^',15);
 edtSC1d.Text   := Piece(lstinvLBCase.Items[x],'^',16);
 edtSC2d.Text   := Piece(lstinvLBCase.Items[x],'^',17);
 edtSC3d.Text   := Piece(lstinvLBCase.Items[x],'^',18);
 if Piece(lstinvLBCase.Items[x],'^',19) = 'W' then
  cbxD1.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',19) = 'C' then
  cbxD2.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',19) = 'B' then
  cbxD3.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',20) = 'A' then
  cbxD4.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',20) = 'V' then
  cbxD5.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',20) = 'B' then
  cbxD6.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',21) = 'V' then
  cbxD7.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',21) = 'N' then
  cbxD8.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',21) = 'B' then
  cbxD9.Checked := true;
//   FIM interim       6.01
 x := 6;
 edtSec1i.Text  := Piece(lstinvLBCase.Items[x],'^',1);
 edtSec2i.Text  := Piece(lstinvLBCase.Items[x],'^',2);
 edtSec3i.Text  := Piece(lstinvLBCase.Items[x],'^',3);
 edtSec4i.Text  := Piece(lstinvLBCase.Items[x],'^',4);
 edtSec5i.Text  := Piece(lstinvLBCase.Items[x],'^',5);
 edtSec6i.Text  := Piece(lstinvLBCase.Items[x],'^',6);
 edtSpc1i.Text  := Piece(lstinvLBCase.Items[x],'^',7);
 edtSpc2i.Text  := Piece(lstinvLBCase.Items[x],'^',8);
 edtTr1i.Text   := Piece(lstinvLBCase.Items[x],'^',9);
 edtTr2i.Text   := Piece(lstinvLBCase.Items[x],'^',10);
 edtTr3i.Text   := Piece(lstinvLBCase.Items[x],'^',11);
 edtLoco1i.Text := Piece(lstinvLBCase.Items[x],'^',12);
 edtLoco2i.Text := Piece(lstinvLBCase.Items[x],'^',13);
 edtComm1i.Text := Piece(lstinvLBCase.Items[x],'^',14);
 edtComm2i.Text := Piece(lstinvLBCase.Items[x],'^',15);
 edtSC1i.Text   := Piece(lstinvLBCase.Items[x],'^',16);
 edtSC2i.Text   := Piece(lstinvLBCase.Items[x],'^',17);
 edtSC3i.Text   := Piece(lstinvLBCase.Items[x],'^',18);
 if Piece(lstinvLBCase.Items[x],'^',19) = 'W' then
  cbxI1.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',19) = 'C' then
  cbxI2.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',19) = 'B' then
  cbxI3.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',20) = 'A' then
  cbxI4.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',20) = 'V' then
  cbxI5.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',20) = 'B' then
  cbxI6.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',21) = 'V' then
  cbxI7.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',21) = 'N' then
  cbxI8.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',21) = 'B' then
  cbxI9.Checked := true;
//   FIM follow up       7.01
 x := 7;
 edtSec1fu.Text  := Piece(lstinvLBCase.Items[x],'^',1);
 edtSec2fu.Text  := Piece(lstinvLBCase.Items[x],'^',2);
 edtSec3fu.Text  := Piece(lstinvLBCase.Items[x],'^',3);
 edtSec4fu.Text  := Piece(lstinvLBCase.Items[x],'^',4);
 edtSec5fu.Text  := Piece(lstinvLBCase.Items[x],'^',5);
 edtSec6fu.Text  := Piece(lstinvLBCase.Items[x],'^',6);
 edtSpc1fu.Text  := Piece(lstinvLBCase.Items[x],'^',7);
 edtSpc2fu.Text  := Piece(lstinvLBCase.Items[x],'^',8);
 edtTr1fu.Text   := Piece(lstinvLBCase.Items[x],'^',9);
 edtTr2fu.Text   := Piece(lstinvLBCase.Items[x],'^',10);
 edtTr3fu.Text   := Piece(lstinvLBCase.Items[x],'^',11);
 edtLoco1fu.Text := Piece(lstinvLBCase.Items[x],'^',12);
 edtLoco2fu.Text := Piece(lstinvLBCase.Items[x],'^',13);
 edtComm1fu.Text := Piece(lstinvLBCase.Items[x],'^',14);
 edtComm2fu.Text := Piece(lstinvLBCase.Items[x],'^',15);
 edtSC1fu.Text   := Piece(lstinvLBCase.Items[x],'^',16);
 edtSC2fu.Text   := Piece(lstinvLBCase.Items[x],'^',17);
 edtSC3fu.Text   := Piece(lstinvLBCase.Items[x],'^',18);
 if Piece(lstinvLBCase.Items[x],'^',19) = 'W' then
  cbxF1.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',19) = 'C' then
  cbxF2.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',19) = 'B' then
  cbxF3.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',20) = 'A' then
  cbxF4.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',20) = 'V' then
  cbxF5.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',20) = 'B' then
  cbxF6.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',21) = 'V' then
  cbxF7.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',21) = 'N' then
  cbxF8.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',21) = 'B' then
  cbxF9.Checked := true;
//   FIM follow up       8.01
 x := 8;
 edtSec1g.Text  := Piece(lstinvLBCase.Items[x],'^',1);
 edtSec2g.Text  := Piece(lstinvLBCase.Items[x],'^',2);
 edtSec3g.Text  := Piece(lstinvLBCase.Items[x],'^',3);
 edtSec4g.Text  := Piece(lstinvLBCase.Items[x],'^',4);
 edtSec5g.Text  := Piece(lstinvLBCase.Items[x],'^',5);
 edtSec6g.Text  := Piece(lstinvLBCase.Items[x],'^',6);
 edtSpc1g.Text  := Piece(lstinvLBCase.Items[x],'^',7);
 edtSpc2g.Text  := Piece(lstinvLBCase.Items[x],'^',8);
 edtTr1g.Text   := Piece(lstinvLBCase.Items[x],'^',9);
 edtTr2g.Text   := Piece(lstinvLBCase.Items[x],'^',10);
 edtTr3g.Text   := Piece(lstinvLBCase.Items[x],'^',11);
 edtLoco1g.Text := Piece(lstinvLBCase.Items[x],'^',12);
 edtLoco2g.Text := Piece(lstinvLBCase.Items[x],'^',13);
 edtComm1g.Text := Piece(lstinvLBCase.Items[x],'^',14);
 edtComm2g.Text := Piece(lstinvLBCase.Items[x],'^',15);
 edtSC1g.Text   := Piece(lstinvLBCase.Items[x],'^',16);
 edtSC2g.Text   := Piece(lstinvLBCase.Items[x],'^',17);
 edtSC3g.Text   := Piece(lstinvLBCase.Items[x],'^',18);
 if Piece(lstinvLBCase.Items[x],'^',19) = 'W' then
  cbxG1.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',19) = 'C' then
  cbxG2.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',19) = 'B' then
  cbxG3.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',20) = 'A' then
  cbxG4.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',20) = 'V' then
  cbxG5.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',20) = 'B' then
  cbxG6.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',21) = 'V' then
  cbxG7.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',21) = 'N' then
  cbxG8.Checked := true;
 if Piece(lstinvLBCase.Items[x],'^',21) = 'B' then
  cbxG9.Checked := true;
 if lstinvLBCase.Items.Count > 9 then
  begin
   for x := 9 to lstinvLBCase.Items.Count-1 do
    memPrevious.Lines.Add(lstinvLBCase.Items[x]);
   grpPrevNote.Visible := true;
  end;
 Screen.Cursor := crDefault;



 end;

procedure TMainForm.Save1Click(Sender: TObject);
begin
 SendDatatoFSOD;
 SetReadOnly(Save1);
 Save1.Enabled := false;
 Edit2.Enabled := true;
end;

procedure TMainForm.Edit2Click(Sender: TObject);
begin
 SetTimer1;
 SetReadOnlyOff(Edit2);
 chkAdmit.Visible := true;
 chkDC.Visible := true;
 chkInterim.Visible := true;
 chkFU.Visible := true;
 If chkAdmit.Checked then
  tbshtAdmit.TabVisible := true;
 If chkDC.Checked then
  tbshtDC.TabVisible := true;
 If chkInterim.Checked then
  tbshtInterim.TabVisible := true;
 If chkFU.Checked then
  tbshtFU.TabVisible := true;
 Save1.Enabled := true;
 Edit2.Enabled := false;
end;

procedure TMainForm.cbxFacilityCodesChange(Sender: TObject);
begin
 SetTimer1;
 if cbxFacilityCodes.ItemIndex = -1 then
  exit;
 grpAssess.Visible := false;
 tbshtAdmit.TabVisible := false;
 tbshtDC.TabVisible := false;
 tbshtInterim.TabVisible := false;
 tbshtNote.TabVisible := false;
 tbshtGoal.TabVisible := false;
 tbshtCase.TabVisible := false;
 tbshtDx.TabVisible := false;
 tbshtFU.TabVisible := false;
 if Edit1.Visible then
  begin
   Edit2.Enabled := true;
   Save1.Enabled := false;
  end;
 If cbxFacilityCodes.Text <> '' then
  begin
   GetEpisodes;
   grpEpisodes.Visible := true;
  end
 else
  grpEpisodes.Visible := false;
 If Piece(cbxFacilityCodes.Text,'-',2) = 'Continuum of Care' then
  begin
   lblDX1.Caption := 'Therapy Start Date';
   lblDX3.Caption := 'Therapy End Date';
  end
 else
  begin
   lblDX1.Caption := 'Rehab Bed Unit Admission';
   lblDX3.Caption := 'Rehab Bed Unit Discharge';
  end;
end;

procedure TMainForm.cbxFacilityCodesKeyPress(Sender: TObject;
  var Key: Char);
type
  TPrtChr = set of Char;
var
  Printable:      TPrtChr;
  SavTxt:         String;
  CmpTxt:         String;
  idx:            Integer;
  Match:          Boolean;
begin
  Printable := [' ' .. '~'];
  if Key in Printable then
  begin
    with sender as TCombobox do
    begin
      DroppedDown := True;
      CmpTxt := Copy(Text, 1, SelStart) + Key;
      SavTxt := Text;
      Match := False;
      idx := 0;
      while (idx < Items.Count) and not Match do
      begin
        if CompareText(CmpTxt, Copy(Items[idx], 1, Length(CmpTxt))) = 0 then
        begin
          ItemIndex := idx;
          Text := Items[idx];
          CmpTxt := Copy(Text, 1, Length(CmpTxt));
          SelStart := Length(CmpTxt);
          SelLength := Length(Text) - Length(CmpTxt);
          Match := True;
          Key := #0;
        end;
      Inc(idx);
      end;
      if not Match then
       begin
        Text := SavTxt;
        Key := #0;
       end;
    end;
  end
  else
  begin
    if (Key = #13) or (Key = #9) then
    begin
      SavTxt := Tcombobox(sender).text;
      if Tcombobox(sender).Text = Tcombobox(sender).Items[Tcombobox(sender).ItemIndex] then
         Tcombobox(sender).DroppedDown := False;
      Tcombobox(sender).Text := savtxt;
      Key := #0;
      Perform(CM_DialogKey, VK_TAB, 0);
    end;
  end;
end;

procedure TMainForm.SendAddendumNote;
var x : Integer;
    Date : String;
    Time, A : String;
begin
   A := '';
   MainForm.NoteTitle := '';
   Date := DatetoStr(Now);
   DT := TimetoStr(now);
   Time := FormatDateTime('hh:nn',StrtoTime(DT));
   DT := Date+'@'+Time;
   FIMBroker.Param[0].Value := DT;
   FIMBroker.Param[0].PType := literal;
   FIMBroker.RemoteProcedure := MainForm.GetNowCall;
   Try
    FIMBroker.Call;
    {check for errors on return}
   except
    on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
      ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
   end;
   NowDate := FIMBroker.Results[0];
   FIMBroker.Param[0].ptype := literal;
   FIMBroker.Param[0].Value :=  MainForm.PN_IEN;
   FIMBroker.Param[1].PType := List;
   FIMBroker.Param[1].Value := '.X';
   FIMBroker.Param[1].Mult['1202'] := MainForm.Author_num;
   FIMBroker.Param[1].Mult['1301'] := NOWDATE;
   FIMBroker.Param[2].ptype := literal;
   FIMBroker.Param[2].Value :=  '1';
   FIMBroker.RemoteProcedure := MainForm.CreateAddendum;
   Try
    FIMBroker.Call;
    {check for errors on return}
   except
    on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
      ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
   end;
   Try
    MainForm.AddPN_IEN  := Piece(FIMBroker.Results[0],'^',1);
   except
    NoteStatus := 'Cancel';
    MessageDlg('Unable to create your addendum.'+#13+#13+
               'Please check your Vista user setup.',mterror,[mbok],0);
    exit;
   end;
   If Piece(FIMBroker.Results[0],'^',1) = '0' then
    begin
     x := pos('unsigned',Piece(FIMBroker.Results[0],'^',2));
     If x > 0 then
      A := 'The author of the note that you wish to addend MUST sign first.';
     MessageDlg(Piece(FIMBroker.Results[0],'^',2)+#13+#13+A,mterror,[mbok],0);
     MainForm.NoteError := true;
     exit;
    end;
 // lock the note
   MainForm.TempPN_IEN  := MainForm.AddPN_IEN;
   MainForm.TIU_LockNote;
 // add note text
   FIMBroker.Param[0].ptype := literal;
   FIMBroker.Param[0].Value :=  MainForm.AddPN_IEN;
   FIMBroker.Param[1].PType := List;
   FIMBroker.Param[1].Value := '.X';
   For x:=0 to MainForm.mem1.lines.count-1 do
    FIMBroker.Param[1].Mult['"TEXT",' + IntToStr(x+1) + ',0'] := MainForm.mem1.lines[x];
   FIMBroker.Param[1].Mult['"HDR"'] := '1^1';
   FIMBroker.Param[2].ptype := literal;
   FIMBroker.Param[2].Value :=  '0';
   FIMBroker.RemoteProcedure := MainForm.AddendumText;
   Try
    FIMBroker.Call;
    {check for errors on return}
   except
    on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
      ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
   end;

   If Piece(FIMBroker.Results[0],'^',1) = '0' then
    begin
     MessageDlg(Piece(FIMBroker.Results[0],'^',2)+#13+#13+A,mterror,[mbok],0);
     MainForm.NoteError := true;
     exit;
    end;
 //  update note
   FIMBroker.Param[0].ptype := literal;
   FIMBroker.Param[0].Value :=  MainForm.AddPN_IEN;
   FIMBroker.Param[1].PType := List;
   FIMBroker.Param[1].Value := '.X';
   FIMBroker.Param[1].Mult['1202'] := MainForm.Author_num;
   FIMBroker.Param[1].Mult['1301'] := NOWDATE;
   FIMBroker.Param[1].Mult['1701'] := '';
   FIMBroker.RemoteProcedure := MainForm.UpdateNote;
   Try
    FIMBroker.Call;
    {check for errors on return}
   except
    on E:EBrokerError do
     begin
      ShowMessage('Broker Error: '+E.Message);
      exit;
     end;
    on E:EAccessViolation do
     begin
      ShowMessage(E.Message);
      exit;
     end;
    else
     begin
      raise;
      exit;
     end;
   end;
   If Piece(FIMBroker.Results[0],'^',1) = '0' then
    begin
     ShowMessage(Piece(FIMBroker.Results[0],'^',2));
     exit;
    end;
   MainForm.NoteStatus := 'OK';
end;

procedure TMainForm.DatesDx1Click(Sender: TObject);
begin
 If tbshtDx.TabVisible then
  pgctrl1.ActivePage := tbshtDx
 else
  ShowMessage('The Dates and Dx tab is not currently available.');
end;

procedure TMainForm.PtProgram1Click(Sender: TObject);
begin
 pgctrl1.ActivePage := tbshtPt;
end;

procedure TMainForm.Admission1Click(Sender: TObject);
begin
 If tbshtAdmit.TabVisible then
  pgctrl1.ActivePage := tbshtAdmit
 else
  ShowMessage('The Admission tab is not currently available.');
end;

procedure TMainForm.Interim1Click(Sender: TObject);
begin
 If tbshtAdmit.TabVisible then
 pgctrl1.ActivePage := tbshtInterim
 else
  ShowMessage('The Interim tab is not currently available.');
end;

procedure TMainForm.Discharge1Click(Sender: TObject);
begin
 If tbshtDC.TabVisible then
  pgctrl1.ActivePage := tbshtDC
 else
  ShowMessage('The Discharge tab is not currently available.');
end;

procedure TMainForm.FollowUp1Click(Sender: TObject);
begin
 If tbshtFU.TabVisible then
  pgctrl1.ActivePage := tbshtFU
 else
  ShowMessage('The Follow Up tab is not currently available.');
end;

procedure TMainForm.CaseNotes1Click(Sender: TObject);
begin
 If tbshtCase.TabVisible then
  pgctrl1.ActivePage := tbshtCase
 else
  ShowMessage('The Case Notes tab is not currently available.');
end;

procedure TMainForm.Goals1Click(Sender: TObject);
begin
 If tbshtGoal.TabVisible then
  pgctrl1.ActivePage := tbshtGoal
 else
  ShowMessage('The Goals tab is not currently available.');
end;

procedure TMainForm.Finished1Click(Sender: TObject);
begin
 If tbshtNote.TabVisible then
  pgctrl1.ActivePage := tbshtNote
 else
  ShowMessage('The Finished tab is not currently available.');
end;

procedure TMainForm.FIMGraph1Click(Sender: TObject);
begin
 If BtnGraph.Visible then
  BtnGraphClick(application)
 else
  ShowMessage('The FIM Graph is not currently available.');
end;

procedure TMainForm.cbxA1Click(Sender: TObject);
begin
 If cbxA1.Checked then
  begin
   cbxA2.Checked := false;
   cbxA3.Checked := false;
  end;
end;

procedure TMainForm.cbxA2Click(Sender: TObject);
begin
 If cbxA2.Checked then
  begin
   cbxA1.Checked := false;
   cbxA3.Checked := false;
  end;
end;

procedure TMainForm.cbxA3Click(Sender: TObject);
begin
 If cbxA3.Checked then
  begin
   cbxA1.Checked := false;
   cbxA2.Checked := false;
  end;
end;

procedure TMainForm.cbxA4Click(Sender: TObject);
begin
 If cbxA4.Checked then
  begin
   cbxA5.Checked := false;
   cbxA6.Checked := false;
  end;
end;

procedure TMainForm.cbxA5Click(Sender: TObject);
begin
 If cbxA5.Checked then
  begin
   cbxA4.Checked := false;
   cbxA6.Checked := false;
  end;
end;

procedure TMainForm.cbxA6Click(Sender: TObject);
begin
 If cbxA6.Checked then
  begin
   cbxA4.Checked := false;
   cbxA5.Checked := false;
  end;
end;

procedure TMainForm.cbxA7Click(Sender: TObject);
begin
 If cbxA7.Checked then
  begin
   cbxA8.Checked := false;
   cbxA9.Checked := false;
  end;
end;

procedure TMainForm.cbxA8Click(Sender: TObject);
begin
 If cbxA8.Checked then
  begin
   cbxA7.Checked := false;
   cbxA9.Checked := false;
  end;
end;

procedure TMainForm.cbxA9Click(Sender: TObject);
begin
 If cbxA9.Checked then
  begin
   cbxA7.Checked := false;
   cbxA8.Checked := false;
  end;
end;

procedure TMainForm.cbxI1Click(Sender: TObject);
begin
 If cbxI1.Checked then
  begin
   cbxI2.Checked := false;
   cbxI3.Checked := false;
  end;
end;

procedure TMainForm.cbxI2Click(Sender: TObject);
begin
 If cbxI2.Checked then
  begin
   cbxI1.Checked := false;
   cbxI3.Checked := false;
  end;
end;

procedure TMainForm.cbxI3Click(Sender: TObject);
begin
 If cbxI3.Checked then
  begin
   cbxI1.Checked := false;
   cbxI2.Checked := false;
  end;
end;

procedure TMainForm.cbxI4Click(Sender: TObject);
begin
 If cbxI4.Checked then
  begin
   cbxI5.Checked := false;
   cbxI6.Checked := false;
  end;
end;

procedure TMainForm.cbxI5Click(Sender: TObject);
begin
 If cbxI5.Checked then
  begin
   cbxI4.Checked := false;
   cbxI6.Checked := false;
  end;
end;

procedure TMainForm.cbxI6Click(Sender: TObject);
begin
 If cbxI6.Checked then
  begin
   cbxI4.Checked := false;
   cbxI5.Checked := false;
  end;
end;

procedure TMainForm.cbxI7Click(Sender: TObject);
begin
 If cbxI7.Checked then
  begin
   cbxI8.Checked := false;
   cbxI9.Checked := false;
  end;
end;

procedure TMainForm.cbxI8Click(Sender: TObject);
begin
 If cbxI8.Checked then
  begin
   cbxI7.Checked := false;
   cbxI9.Checked := false;
  end;
end;

procedure TMainForm.cbxI9Click(Sender: TObject);
begin
 If cbxI9.Checked then
  begin
   cbxI7.Checked := false;
   cbxI8.Checked := false;
  end;
end;

procedure TMainForm.cbxD1Click(Sender: TObject);
begin
 If cbxD1.Checked then
  begin
   cbxD2.Checked := false;
   cbxD3.Checked := false;
  end;
end;

procedure TMainForm.cbxD2Click(Sender: TObject);
begin
 If cbxD2.Checked then
  begin
   cbxD1.Checked := false;
   cbxD3.Checked := false;
  end;
end;

procedure TMainForm.cbxD3Click(Sender: TObject);
begin
 If cbxD3.Checked then
  begin
   cbxD1.Checked := false;
   cbxD2.Checked := false;
  end;
end;

procedure TMainForm.cbxD4Click(Sender: TObject);
begin
 If cbxD4.Checked then
  begin
   cbxD5.Checked := false;
   cbxD6.Checked := false;
  end;
end;

procedure TMainForm.cbxD5Click(Sender: TObject);
begin
 If cbxD5.Checked then
  begin
   cbxD4.Checked := false;
   cbxD6.Checked := false;
  end;
end;

procedure TMainForm.cbxD6Click(Sender: TObject);
begin
 If cbxD6.Checked then
  begin
   cbxD4.Checked := false;
   cbxD5.Checked := false;
  end;
end;

procedure TMainForm.cbxD7Click(Sender: TObject);
begin
 If cbxD7.Checked then
  begin
   cbxD8.Checked := false;
   cbxD9.Checked := false;
  end;
end;

procedure TMainForm.cbxD8Click(Sender: TObject);
begin
 If cbxD8.Checked then
  begin
   cbxD7.Checked := false;
   cbxD9.Checked := false;
  end;
end;

procedure TMainForm.cbxD9Click(Sender: TObject);
begin
 If cbxD9.Checked then
  begin
   cbxD7.Checked := false;
   cbxD8.Checked := false;
  end;
end;

procedure TMainForm.cbxF1Click(Sender: TObject);
begin
 If cbxF1.Checked then
  begin
   cbxF2.Checked := false;
   cbxF3.Checked := false;
  end;
end;

procedure TMainForm.cbxF2Click(Sender: TObject);
begin
 If cbxF2.Checked then
  begin
   cbxF1.Checked := false;
   cbxF3.Checked := false;
  end;
end;

procedure TMainForm.cbxF3Click(Sender: TObject);
begin
 If cbxF3.Checked then
  begin
   cbxF1.Checked := false;
   cbxF2.Checked := false;
  end;
end;

procedure TMainForm.cbxF4Click(Sender: TObject);
begin
 If cbxF4.Checked then
  begin
   cbxF5.Checked := false;
   cbxF6.Checked := false;
  end;
end;

procedure TMainForm.cbxF5Click(Sender: TObject);
begin
 If cbxF5.Checked then
  begin
   cbxF4.Checked := false;
   cbxF6.Checked := false;
  end;
end;

procedure TMainForm.cbxF6Click(Sender: TObject);
begin
 If cbxF6.Checked then
  begin
   cbxF4.Checked := false;
   cbxF5.Checked := false;
  end;
end;

procedure TMainForm.cbxF7Click(Sender: TObject);
begin
 If cbxF7.Checked then
  begin
   cbxF8.Checked := false;
   cbxF9.Checked := false;
  end;
end;

procedure TMainForm.cbxF8Click(Sender: TObject);
begin
 If cbxF8.Checked then
  begin
   cbxF7.Checked := false;
   cbxF9.Checked := false;
  end;
end;

procedure TMainForm.cbxF9Click(Sender: TObject);
begin
 If cbxF9.Checked then
  begin
   cbxF7.Checked := false;
   cbxF8.Checked := false;
  end;
end;

procedure TMainForm.cbxG1Click(Sender: TObject);
begin
 If cbxG1.Checked then
  begin
   cbxG2.Checked := false;
   cbxG3.Checked := false;
  end;
end;

procedure TMainForm.cbxG2Click(Sender: TObject);
begin
 If cbxG2.Checked then
  begin
   cbxG1.Checked := false;
   cbxG3.Checked := false;
  end;
end;

procedure TMainForm.cbxG3Click(Sender: TObject);
begin
 If cbxG3.Checked then
  begin
   cbxG1.Checked := false;
   cbxG2.Checked := false;
  end;
end;

procedure TMainForm.cbxG4Click(Sender: TObject);
begin
 If cbxG4.Checked then
  begin
   cbxG5.Checked := false;
   cbxG6.Checked := false;
  end;
end;

procedure TMainForm.cbxG5Click(Sender: TObject);
begin
 If cbxG5.Checked then
  begin
   cbxG4.Checked := false;
   cbxG6.Checked := false;
  end;
end;

procedure TMainForm.cbxG6Click(Sender: TObject);
begin
 If cbxG6.Checked then
  begin
   cbxG4.Checked := false;
   cbxG5.Checked := false;
  end;
end;

procedure TMainForm.cbxG7Click(Sender: TObject);
begin
 If cbxG7.Checked then
  begin
   cbxG8.Checked := false;
   cbxG9.Checked := false;
  end;
end;

procedure TMainForm.cbxG8Click(Sender: TObject);
begin
 If cbxG8.Checked then
  begin
   cbxG7.Checked := false;
   cbxG9.Checked := false;
  end;
end;

procedure TMainForm.cbxG9Click(Sender: TObject);
begin
 If cbxG9.Checked then
  begin
   cbxG7.Checked := false;
   cbxG8.Checked := false;
  end;
end;

procedure TMainForm.CopyIndentedText;
Var x: Integer;
begin;
  If mem2.Lines.Count > 0 then
   for x := 0 to mem2.Lines.Count-1 do
    begin
     If x = 0 then
      mem1.Lines.Add(mem2.Lines[x]) else
      mem1.Lines.Add('                            '+mem2.Lines[x]);
    end;
  mem2.Clear;
end;

procedure TMainForm.lstImpGrpKeyPress(Sender: TObject; var Key: Char);
begin
 if key=chr(13) then
  lstImpGrpClick(application);
end;

procedure TMainForm.C1Click(Sender: TObject);
begin
 SetTimer1;
 Application.HelpCommand(HELP_FINDER,0);
end;


procedure TMainForm.memCurrentChange(Sender: TObject);
begin
 SetTimer1;
end;

procedure TMainForm.memmessagesChange(Sender: TObject);
var x : Integer;
    A,b : string;
begin
    a := patientdfn;
    b := piece(memmessages.Lines[memmessages.Lines.Count-1],'^',3);

 If memmessages.Lines.Count < 1 then exit;

 for x := memmessages.Lines.Count-1 downto 0 do
  If (piece(memmessages.Lines[x],'^',1) <> 'XPT') or
     (a = b) then
   memmessages.Lines.Delete(x);

 If memmessages.Lines.Count > 0 then
  begin
   If frmPtChange = nil then
    Application.CreateForm(TfrmPtChange,frmPtChange);
   frmPtChange.Showmodal;
   frmPtChange.Free;
   try
    TIU_DeleteNote;
    TIU_UnlockNote;
   except
   end;
   NoteStatus := 'Cancel';
   Application.Terminate;
  end;
end;

end.

